<?php if(!defined('fb_tools')) die("Plugin-File for fb_tools");	// (charset=iso-8859-1 / tabs=8 / lines=cr+lf / lang=de)

$plugin = "KonfigDecrypt 0.25 (c) 19.06.2019 by Michael Engelke";
$info = 'Entschlsselt die Fritz!Box Konfigdateien mit hilfe der Fritz!Box (End of Service)'; /*

Plugingeschichte:
0.13 25.06.2016
 - NEU: Alle Zugangsdaten knnen OHNE Telnet aus der Fritz!Konfig ausgelesen und angezeigt werden
0.15 07.07.2016
 - Zugangsdaten knnen auch bei einer Internationalen Fritz!Box (z.B. 4020) ausgelesen/entschlsselt werden
0.16 20.07.2016
 - Konfig-DeCrypt verbessert (Entschlsselt auch Konfigurationen mit mehreren Kennwrtern - Danke an Herby007)
0.17 06.08.2016
 - Konfig-DeCrypt verbessert (Entschlsselt auch Kennwrter im Binaer-Bereich der Konfig - Danke fr den Hinweis)
0.19 29.01.2017
 - Ereignisse und Konfig-DeCrypt an OS 6.8 angepasst
 - Workaround fr Konfig-DeCrypt an Fritz!Box 7312 implemmentiert
 - Workaround fr HTTP-Fehler 503 implementiert
0.20 20.03.2017
 - Konfig DeCrypt: Internationale Sprachen an OS 6.8 angepasst
0.22 11.04.2017 (Intern)
 - Letzte Version als bestandteil von fb_Tools
0.23 18.03.2019
 - Bug: Konfig-Decrypt entschlsselte nur ein Teil bei einer Fritz!Box 7412
 - Ausgelagert als Plugin
0.25 19.06.2019
 - Fix: Anpassungen an fb_Tools 0.25+
*/
function konfigdecrypt($data,$pass,$sid=0) {		// Konfig-Datei mit Fritz!Box entschlsseln
 global $cfg;
 if(!$sid)						// Sid sicherstellen
  $sid = $cfg['sid'];
 dbug($data,4,'12,KonfigDeCrypt-Crypted');
 $plain = $buffer = array();
 if($sid and preg_match_all('/^\s*([\w-]+)\s*=\s*("?)(\${4}\w+)\2;?\s*$/m',$data,$array) and preg_match('/(?:\s*Password\d*=\${4}\w+)+/',$data,$var)) {
  if(preg_match('/^boxusers\s\{\s*^\s{8}users(\s\{.*?^\s{8}\}$)/smx',$k = str_replace("\t","        ",$cfg['zlib']['inflate'](base64_decode("
	tVnrbxs3Ev8s/RU6+ZuBxJIjO01SH9A4dupD/EDspL1DAYJaUrusd0keyZWsBvnfb4aPfchOIvdgx4B3Z4bkcB6/mdns7u7ujk4/nt385x9v1d3o5ezVZHR8
	eXF69v7Tx19uzi4vRie/X11+vNmZDE+FqVbU8M/cWKHk0XT64vnk8PnBZBgWkLOL65tfPnwgN/++OjmqhLYvZuRgun/+ltyJUsg7smS2JIxnbjY7JLOcu4Ls
	0zkRlkkiHXGcaOUs2a/tnBTKOrIqqZxOJdlHvYaXJ+dHdFkNj1UtnVkfTWavhh+ozGua8yPGh7t4l+PT96dnH05eU/PyebbIh3u7w9HuaG9JzZ6rtCfB+01R
	j/5F5Wgyhd/Xkwn8jqavXk6AtzccVtzR0ZcRl5liQuajo9G4dotnP43fjL4Oh7Az7DL6MhxUinFgwq0YPhKjasfNm+GAZk4s4TZGLQXjBjcQEliSu3HLlrTC
	5WMkiZwxLum85AxIa24jjWQK7qpK0jKlAt6KSjI3guWcrATYkRWZzpqVHW5OHV/RNbAmz/0/YHthUltOrKNOZIRJmzZGHoEbLZSpK2XyRAdnxevGp3gAsFym
	KuKoAYdSkxWNFt7dhlta8kj3O1G40ZJ0KXOZk97KwgqvHt5jCTHQYyAhOuAr+MDVJKvdnGa3JCoIJK8grR3u3pEA5vRggia4xotbuDs8GHe5OAel8PwpXtWb
	mlQ0I2rJDVyTNwoAEW/Vofvg6f6i5/TyMCqDj16TCi0deLOWNyNSmYqWwLDcCFq2NwM7+6BZ0IzbSAObb5JAnYb2AIlAMBuBobHvDw9ei4Jaa8UXq7R5DRwX
	X5ZZlk6oslpbZzitNgN5qYQmECkAC8zUJbcpnD1D6MMHmc5MDl99h/OtdelkIgAuqCOeSe5lTZKCZNxG7KGT0IBdG4fg9m8Dt9boOzAduCqGPUm7wdpBSuuu
	oQZKlmuSmbV2GAxN5A9KldHS7zuAgDdp7c7Urxpoau2KdSigzMDwSjket4l64BtqRrKC6jc9IeLPVhKUhEQNeBZsEIX88bixkB6ZhFsTJyoOBgTRgwol558s
	Py7wsmd4rSUona4g79GnfkmZaZ4VijBhAcQkwH5K0MSJCQpGyAWYoSPoMU0Xa4v0Vt+ORKvgZIWsBSjf2QGWtRoKDW6YC2WtVmoRLBA4AHwLUYLiGAYk4jIT
	BnZQZt1eUWE05QqWEty5QctBpqxqvYBvXsBXgQE+eWBivPQQPPW3ENk8GiIuiwSAAsl9sGwKqA2BymZzbfiCm7YiDKq6dFhnbxt/FpxC9QGtKhC2WLQ7pqSO
	bnDiYchBRuMeKBIZ4jiPfikAOME6RNbV3Be3cD6US4zv3l4h4pPanfiCY5dconDInRA4wZWSrwADKGMGozY6tL3mOjJ7JW0ASj1IR6ReGQG9Bfh6+h3efp83
	/6zKuuIfoddgn3Rzeo/6du08Zkwn/scvu4o1/10TilfNVZtdvifUzSP2I+FfVY33nf3waBS85q71PyKLWKKBU2S3FoZQO8Q6in+JWiwScRaJnaIVqk1eqjmU
	LiUXIlUvmgF8AoxCF7cMDWPUM7RPHeL0BVC7KNzlIVIjEoe9u5yDVC980gMjpm9zxT4zJpTHQuxx7glgaGPJQKbSXXf15UDTrM26Pg9bEygJtxzfvi3S1nhs
	chbijjPf6pK85mAv0YRbraWGBDCWAJKoFVFG5EI2ZWqTHfL9m2zoBArFHmBX9I5AD50iLkgjcOUGAx1hogqpX1FZgztcbfz9gqGDfGYAXwmDPkdIv6LhR9/x
	O6yHILzGIiXz1oilqAQgum88iYGGta3S2vfUJNjJgHGgjcoKxGHPAMENcgQtb0lLcFCorWvrPvTvQ6iz4IngBHxf8bk1y/iC/Vp8hODVrRTGRVjZIWSlgPxK
	BGn7AthWf/GpgBNLaB82+5BBsJgv8fu+xPf6gBfjlKyxDQgE3Lo7XfyMixiH2sbZP8chL7Ed6LUs445QOMkgyowL5/TrvT3fiuDYFdc3+3/pNDX3Dvrm5iXk
	Yqp7M98QOFVnBdbtBumjuWJAgrcPNylyofpaNtdPwxc8kuXMqxydWQtUuWtGXORtqAxL7/xOc+PiLnFsEn8BBvmqWHLXxqcHURIaBdQdSNANMxIwrkEObGMa
	0MiUuhX+8Olk+iz+TLyHqdab45yfEgqBM2CHNLtPgs549RAVGl1sXfocyKYSq1ufioW/TwHoCWOBBQQSG0zfyu9LdvX5eIOThTn8gTUpdDz8a8RsyEGJ1Wdc
	cSbq6giKBprC3gq0hW+UVx0PhZMbsB9P91/MDv74Q45DBmdUC0RTgIyYaxySqJTKicUanX+/21+oljZN/X8osxXOfuUaiKdG+RlnZ4bK3aj2+fr85uq6ic0m
	VV7vH4SB3tuiydpZE3CsfbcFoKQPJTRLo5ono5FxFu9TbwWz96lQwiDJMgCUe6yFkn0iDrfOt6uBgLOrrm2B1kolcdKOvDAhgNsg1m0Nk6Fx2Ao2SRBE/Ja1
	fkgiM9QWhiM57e1UEvRTyIZQNz3DpyEHejXKxhOb4SHwYui1NBL8NPZZiU2qXrF7497pb5806MpxpI6197jbrvwGOfAeawZ+GKjT3HepubwCTdP7BV+940vR
	DNrvBM2lsun1mmc1tJPrc9Q0kD5Q684BJKC8njXQs1jVXhnrzyIRQXnQ8JO8lWol0XutieE+UDLbvgNDXoq8CHNQ+kgUc0G6fl1CO4QnFP4LmnFfx2mSr8J3
	q/hmRMqpTNfEZgVn0JRF0s1HMjmcpX2pZN4aNhK0gRkrKfHf5hG/83l/Nw1ipIYBHHq7SKoBxQAnGLRDwUCRTpcVYGu6hNWcMzRec2oAGwifBYUZKJL/pFZJ
	IR5CAywNhMd4Gu/4FPa0bo0I5Lm6I8K/w9PEw9Dhy59eTeg8g+OetZRW2O+iC4hz3u7D1hKHjCbk46Hxuwqxa5kBUErW6cOxkyG4peE54qfp+B7IqLBNhe4b
	vYXXfOew+1Vi56WvoM3t2/6iUxsHSy1jdWumAtSEsgqaO4OBhwwLrpv/mcpgIDfDnqR2S0ldYEh+XxbrbRjVFoDRpFAVh9gBnW8TsAyQ5m32/+70dRg/jKSV
	3ozTSa8kYQ2BVQS7Yfx0gB9aNuzvg1OtsAzKFMpoFcir+FYoZ7VybZNZ7rtOywmNQsqhkA/+e23aqgqwYsM9ep15ENjbG51cng7Dd/GTi3ejy9MRfhsfIaH/
	tRynjyf6XL5qBp5H6oQ18Yl0wq3/lk61nT+RSrAzNhTtSMLosofi2DjRJhpwdCtVDc0qNHk9XIWi2JHMdZXWK6ML/OJ9myYdGeaxRQkVuQ1PNn+8WfyI+0SG
	8Xs/yllvzy68Vos7kuVbS4INt5UF5N9WtMzMVqKOlxy6N1IJm221wIPmHIaMraTxSySU0K1kmW+sttUDlM6cKbffmXMo2NV28lVuCPQ9DLs6LHPb3dVnw3ZW
	p9UP/d7AkX4qhISd/yYYcfNkaNT9QPKInKsrZ70C23uKbXVZWtDamq23BvHHyGJdfYw8RvJj5KHDeIx4+J76mBVpqPvhmkgN/6s/msSfIPA/"))),$v))
   $export = array(str_replace("#0",$var[0],$k),$v[1]);	// Stark gekrze und leere Fritz!Box 7490 Konfig
  if(preg_match_all('/\${4}\w+/',$var[0],$val))		// Salt-Kennwrter entfernen
   foreach($val[0] as $var)
    if(($key = array_search($var,$array[3])) !== false) {
     $plain[$var] = $pass;
     unset($array[3][$key]);
    }
  if(preg_match_all('/^\*\*\*\*\sBINFILE:(.*)\s*([\dA-F\s]*?(?:24\s*){4}(?:[46][1-9A-F]|[57][0-9A]|3\d|\s*)+[\dA-F\s]*)/mi',$data,$binfile)) {
   $binfile = array_combine($binfile[1],$binfile[2]);	// Binfiles mit verschlsselten Werten einbeziehen
   foreach($binfile as $key => $var) {
    $binfile[$key] = pack('H*',preg_replace('/[^\da-f]+/i',"",$var));
    if(preg_match_all('/\${4}\w+/',$binfile[$key],$val))
     $array[3] = array_merge($array[3],$val[0]);
   }
  }
  else
   $binfile = false;
  dbug($array,4,'KonfigDeCrypt');
  $list = array_unique($array[3]);			// Doppelte Eintrge entfernen
  shuffle($list);					// Alle Eintrge durchwrfeln (Fr Problemflle)
  if(preg_match_all('/\${4}\w+/',$var[0],$array))	// Salt-Kennwrter eintragen
   foreach($array[0] as $var)
    $plain[$var] = $pass;
  $dupe = array(array(1,4,'/^(.*?)$/'), array(15,5,'/(?<=^|,\s)(.*?)(?=,\s|$)/'));
  $pregimport = array(
   'de' => array('Internetzugangsdaten' => array(1,0,'/^Benutzer:\s(.*?)(?:,\sAnbieter:\s.*?)?$/'), 'Dyn(amic )?DNS' => array(2,1,'/(?<=Domainname:\s|Benutzername:\s)(.*?)(?=,\s|$)/'),
    'PushService' => array(1,3,'/^E-Mail-Empfnger:\s(.*?)$/'), 'MyFRITZ!' => $dupe[0], 'FRITZ!Box-Benutzer' => $dupe[1]),
   'en' => array('Internet Account Information' => array(1,0,'/^User:\s(.*?)(?:,\sProvider:\s.*?)?$/'), 'Dyn(amic )?DNS' => array(2,1,'/(?<=Domain\sname:\s|user\sname:\s)(.*?)(?=,\s|$)/'),
    'Push service' => array(1,3,'/^e-mail\srecipient:\s(.*?)$/'), 'MyFRITZ!' => $dupe[0], 'FRITZ!Box Users' => $dupe[1]),
   'es' => array('Datos de acceso a Internet' => array(1,0,'/^Usuario:\s(.*?)(?:,\sProvider:\s.*?)?$/'),
    '(Dyn)?DNS( dinmico)?' => array(2,1,'/(?<=Nombre\sdel\sdominio:\s|nombre\sdel\susuario:\s)(.*?)(?=,\s|$)/'),
    'Push Service|Notificaciones' => array(1,3,'/^Destinatario\sde\scorreo:\s(.*?)$/'), 'MyFRITZ!' => $dupe[0], 'Usuarios de FRITZ!Box' => $dupe[1]),
   'fr' => array('Donnes d\'accs  Internet' => array(1,0,'/^Utilisateur[\xa0\s]?:[\xa0\s](.*?)(?:,\sProvider:\s.*?)?$/'),
    '(Dyn)?DNS( dynamique)?' => array(2,1,'/(?<=Nom\sde\sdomaine[\xa0\s]:[\xa0\s]|nom\sd\'utilisateur[\xa0\s]:[\xa0\s])(.*?)(?=,\s|$)/'),
    'Service push' => array(1,3,'/^Destinataire\sdu\scourrier\slectronique[\xa0\s]?:[\xa0\s](.*?)$/'), 'MyFRITZ!' => $dupe[0], 'Utilisateur de FRITZ!Box' => $dupe[1]),
   'it' => array('Dati di accesso a Internet' => array(1,0,'/^Utente:\s(.*?)(?:,\sProvider:\s.*?)?$/'), 'Dyn(amic )?DNS' => array(2,1,'/(?<=Nome\sdi\sdominio:\s|nome\sutente:\s)(.*?)(?=,\s|$)/'),
    'Servizio Push' => array(1,3,'/^Destinatario\se-mail:\s(.*?)$/'), 'MyFRITZ!' => $dupe[0], 'Utenti FRITZ!Box' => $dupe[1]),
   'pl' => array('Dane dost\?powe do internetu' => array(1,0,'/^U\?ytkownik:\s(.*?)(?:,\sProvider:\s.*?)?$/'),
    'Dyn(amic )?DNS' => array(2,1,'/(?<=Nazwa\sdomeny:\s|nazwa\su\?ytkownika:\s)(.*?)(?=,\s|$)/'), 'Push Service' => array(1,3,'/^Odbiorca\se-maila:\s(.*?)$/'),
    'MyFRITZ!' => $dupe[0], 'U\?ytkownicy FRITZ!Box' => $dupe[1]),
  );
  $lang = (ifset($cfg['boxinfo']['Lang']) and ifset($pregimport[$cfg['boxinfo']['Lang']])) ? $cfg['boxinfo']['Lang'] : 'de';
  dbug((count($list) + count($plain))." verschiedene verschlsselte Eintrge gefunden! (Sprachmuster: $lang)");
  dbug($list,4,'KonfigDeCrypt-List');
  $b = 1;
  while($list) {					// Alle Verschlsselte Eintrge durchlaufen
   $import = $export[0];
   $buffer = array_values($buffer);
   while($list and count($buffer) < ((ifset($cfg['boxinfo']['Name'],'/FRITZ!Box 7[34]12/i')) ? 4 : 20))	// Die ersten 20 Eintrge sichern
    $buffer[] = array_shift($list);
   $a = 0;						// Import-Buffer fllen
   $v = array();
   foreach($buffer as $var)
    if($a++ < 5)
     $import = str_replace("#$a",$var,$import);
    else
     $v[] = str_replace('#7',$var,str_replace('#6',4+$a,$export[1]));
   $import = preg_replace('/(^boxusers\s\{\s*^\s{8}users)\s\{.*?^\s{8}\}$/smx',"$1".str_replace('$','\$',implode('',$v)),$import);
   if($var = cfgcalcsum($import))			// Checksum berechnen
    $import = $var[2];
   dbug($import,4,"KonfigDeCrypt-Import-$b");
   dbug($buffer,4,"KonfigDeCrypt-Buffer-".($b++));
   if($var = request('POST','/cgi-bin/firmwarecfg',array('sid' => $sid, 'ImportExportPassword' => $pass,
	'ConfigTakeOverImportFile' => array('filename' => 'fritzbox.export', 'Content-Type' => 'application/octet-stream', '' => $import), 'apply' => false)) and !preg_match('/cfg_nok/',$var)) {
    if($getdata = utf8(($cfg['fiwa'] < 650) ? request('GET',"/system/cfgtakeover_edit.lua?sid=$sid&cfg_ok=1") : request('POST',"/data.lua","xhr=1&sid=$sid&lang=de&no_sidrenew=&page=cfgtakeover_edit"))) {
     if(preg_match_all('/^\s*\["add\d+_text"\]\s*=\s*"([^"]+)",\s*$.*?^\s*\["gui_text"\]\s*=\s*"([^"]+)",\s*$/sm',$getdata,$match))
      $match[2] = array_flip($match[2]);
     elseif(preg_match_all('/<label for="uiCheckcfgtakeover\d+">(.*?)\s*<\/label>\s*<span class="addtext">(.*?)\s*<br>\s*<\/span>/',$getdata,$match))
      $match = array(1 => $match[2], 2 => array_flip($match[1]));
     if($match) {					// Decodierte Kennwrter gefunden
      dbug($match,4,'KonfigDeCrypt-Match');
      foreach($pregimport[$lang] as $key => $var)
       if($k = preg_array("/^$key$/",$match[2],5) and preg_match_all($var[2],$match[1][$match[2][$k]],$array))
        foreach($array[1] as $k => $v)
         if(isset($buffer[$var[1] + $k]) and $buffer[$var[1] + $k] != $v) {	// Kennwort sichern
          $plain[$buffer[$var[1] + $k]] = str_replace('"','\\\\"',html_entity_decode($v,ENT_QUOTES,'ISO-8859-1'));
          unset($buffer[$var[1] + $k]);
         }
     }
     else
      return errmsg('Keine Entschlsselte Daten gefunden',__FUNCTION__);
    }
    else
     return errmsg('Keine Daten erhalten',__FUNCTION__);
   }
   else
    return errmsg('Entschlsselungsversuch wurde nicht akzeptiert'
	.(($val = ifset($var,'/<p class="ErrorMsg">(.*?)<\/p>/')) ? (($val[1] == '?1043?')
	? "\nBitte \"Ausfhrung bestimmter Einstellungen und Funktionen zustzlich besttigen\" deaktivieren!" : " - $val[1]") : ''),__FUNCTION__);
   dbug((count($list)) ? floor(count($plain)/(count($list)+count($plain))*100)."% entschlsselt..." : "100% ".(($buffer) ? "Es konnte".((count($buffer) == 1)
	? " ein Eintrag" : "n ".count($buffer)." Eintrge")." nicht Entschlsselt werden! " : "")."- Ersetze ".count($plain)." entschlsselte Eintrge...");
  }
  dbug($buffer,4,'KonfigDeCrypt-Resistant');
  dbug($plain,4,'KonfigDeCrypt-Plain');			// Plaintext sichern
  if($binfile)						// BinFiles wieder zusammenpacken
   foreach($binfile as $key => $var)
    $data = preg_replace("/(?<=\*{4} BINFILE:$key\s)[\dA-F\s]*(?=\s\*{4} END OF FILE \*{4})/",
	wordwrap(strtoupper(implode('',unpack('H*',str_replace(array_keys($plain),array_values($plain),$var)))),80,"\n",1),$data,1);
  $data = str_replace(array_keys($plain),array_values($plain),$data);
  dbug($data,4,'12,KonfigDeCrypt-Decrypted');
  return $data;
 }
 return errmsg('Keine Konfig-Datei',__FUNCTION__);
}
if(isset($cfg['utf8']) and !$cfg['utf8'])
 out("Hinweis: UTF-8 wird auf Ihrem System von PHP nicht untersttzt, daher ist die Entschlsselung Problematisch!");
if(!ifset($cfg['ver'][10]) or $cfg['ver'][10] < 0.25)
 out("Dieses Plugin bentigt {$cfg['ver'][1]} 0.25 oder neuer!");
elseif(ifset($cfg['help']) or !getArg(true)) {		// Hilfe Ausgeben
 out("$plugin\n$info\n\n$self <fritz.box> PlugIn $plug [func:Funktion] <Datei|Ordner> <pass:Kennwort>\n
Funktionen (func):\n{{{tt}ExPort|<of:Datei>|<pass:Kennwort>|-|Konfig entschlsseln und exportieren
ExTrakt|<of:Ordner>|<pass:Kennwort>|-|Konfig entschlsseln, anzeigen/exportieren (tar)
File|[if:Datei]|[pass:Kennwort]||<of:Datei> - Konfig-Daten entschlsseln}}

Anmeldung mit Logindaten & Fritz!Box mit OS 5 oder neuer erforderlich
Ab OS 6.69 muss die Sicherheits-Besttigungsfunktion deaktiviert werden"
  .((ifset($cfg['help'],'/[ab]/i')) ? "\n\nBeispiele:
$self fritz.box plugin $plug file-decrypt fb.export geheim fbdc.export -d
$self fritz.box pi $plug exdc fb.export geheim -d\n" : ""));
}
elseif($mode = getArg('func','/^(?:e(p|xport)?|(et|(?:extra[ck]t))?|(f(?:ile)?))$/ix')) {	// Parameter berprfen
 $mode = array_pad($mode,4,null);
 $file = getArg('of');
 if(!$pass = getArg('pass'))
  $pass = (ifset($cfg['pass'],'/^[ -~]+$/')) ? $cfg['pass'] : 'geheim';
 if($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {// Login durchfhren
  if(login(false,500)) {
   if($mode[1]) {					// Export
    if(is_dir($file)) {					// Im Ordner schreiben
     makedir($file);					// Verzeichnis erstellen
     $file = false;
    }
    if($cfg['dbug']/(1<<0)%2)				// Debug-Meldung fr cfgexport
     dbug("Hole Konfiguration");
    if($data = cfgexport('array',$pass)) {		// Exportieren mit Entschlsselten Benutzerdaten
     if($data[1] = konfigdecrypt($data[1],$pass,$sid)) {
      out(showaccessdata($data[1]));
      saverpdata($file,$data,'file.export');
     }
     else
      out(errmsg(0,'konfigdecrypt') || errmsg(0,'cfgexdport') || errmsg(0,'request'));
    }
    elseif(!ifset($data))				// Export direkt File
     out(cfgexport(($file) ? $file : true,$pass) ? "Konfiguation wurde erfolgreich exportiert" : errmsg(0,'request'));
    else
     out(($var = errmsg(0,'request')) ? $var : "Keine Konfig erhalten - Mglichlichweise ist noch die Sicherheits-Besttigungsfunktion aktiviert?");
   }
   elseif($mode[2]) {					// Extrakt
    if($data = cfgexport('array',$pass) and $data[1]) {	// Konfigdaten holen
     $mode = ($file) ? ((preg_match($cfg['ptar'],$file,$var)) ? ((ifset($var[1])) ? 3 : 2) : 1) : 0;
     if($mode == 1)
      makedir($file);					// Verzeichnis erstellen
     if($data[2] = konfigdecrypt($data[1],$pass,$sid))	// Konfig Entschlsseln
      out(cfginfo($data[2],$mode,$file,showaccessdata($data[2])));
    }
    else
     out(($var = errmsg(0,'request')) ? $var : "Keine Konfig erhalten - Mglichlichweise ist noch die Sicherheits-Besttigungsfunktion aktiviert?");
   }
   elseif($mode[3]) {					// Kennwrter aus Datei entschlsseln
    if($save = getArg('if'))				// Argumente vertauschen?
     if($save == getArg('if',0,false) and $file == getArg('of',0,false)) {
      $file = getArg('if');
      $save = getArg('of');
     }
    if(is_file($file) and $data = (preg_match($cfg['ptar'],$file)) ? cfgmake(tar2array($file)) : file_contents($file)) {	// Datei laden
     if($data = konfigdecrypt($data,$pass,$sid)) {
      if($save) {					// Datei speichern
       if(preg_match('/^(.*?)[\\\\\/]$/',$save,$var)) {	// Verzeichnis erstellen
        makedir($save);
        $mode = 1;
       }
       elseif(preg_match($cfg['ptar'],$save,$var))
        $mode = (ifset($var[1])) ? 3 : 2;
       else {
        file_contents($save,$data);			// Entschlsselte Konfig sichern
        $mode = 0;
       }
      }
      else
       $mode = 0;
      out(cfginfo($data,$mode,$save,showaccessdata($data)));	// Daten als Text Prsentieren
     }
     else {
      out(errmsg(0,'konfigdecrypt'));
      if(!ifset($pass,'/^[ -~]+$/'))
       out("Hinweis: Das Konfig-Kennwort enthlt Sonderzeichen, die bei unterschiedlicher Zeichenkodierung Probleme bereiten knnen");
     }
    }
   }
   if(!ifset($cfg['bsid']))				// Abmelden
    logout($sid);
  }
  else
   out("Entschlsselung wird von Fritz!OS nicht untersttzt");
 }
 else
  out(errmsg(0,'login'));				// Login fehlgeschlagen
}
else
 out("Parameter mssen korrekt angegeben werden");

?>
