<?php if(!defined('fb_tools')) die("Plugin-File for fb_tools");	// (charset=iso-8859-1 / tabs=8 / lines=cr+lf / lang=de)

 $plugin = "LaborSync 0.05 (c) 23.06.2019 by Michael Engelke";
 $info = "Neue AVM-Laborversionen mit einen Lokalen Pfad Synchronisieren"; /*

Plugingeschichte:
0.01 28.03.2019
 - Erste Version
0.02 10.04.2019
 - NEU: Option -fd fr Dateiliste zu den Downloads erstellen
 - Gendert: Option -fp fr Download-Pattern
0.03 06.05.2019
 - Zustzliche behandlung fr Error 301 implementiert
0.04 24.05.2019
 - Bug: Fehlermeldung wurden nur im Debug-Modus ausgegeben
 - PHP Mindestversion auf 5.6 angehoben (Wegen AVMs HTTPS-Zertifikat)
0.05 23.06.2019
 - NEU: Untersttzung fr benannte Parameter (fb_Tools 0.25+)
 - NEU: Option -md um gelschte Dateien als "Gelscht" zu markieren
 - Kleine nderungen in der Fehlerbeschreibung
*/
 if(!$cfg['ssl'] and !cfgdecrypt(0,'openssl') or (float)$cfg['osn'] < 1 or !ifset($cfg['ver'][10]) or $cfg['ver'][10] < 0.25)
  out(ucfirst($plug)." bentgt mindestens OpenSSL 1.0+ und {$cfg['ver'][1]} 0.25 oder neuer!");
 elseif(ifset($cfg['help']) or !getArg(true)) {			// Hilfe Ausgeben
  out("$plugin\n$info\n\n$self PlugIn $plug [dir:Lokal-Dir] <Option>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:\n$self plugin $plug /Mirror -d
$self plugin $plug . -fl
$self plugin $plug . -fl:laborfiles.txt
$self plugin $plug /media/stick/ -fp:repeater -d
$self plugin $plug c:/AVM-Labor -fp:fritzbox -ow -d" : "")."\n");
  if(!$cfg['help'] or $cfg['help'] === true)
   $cfg['help'] = -1;
  $opts .= "LaborSync:|-dl:|[sec]|Wartezeit zwischen zwei Requests
|-f||Fehler Ignorieren
|-fd:|[Datei]|Zu den Downloads eine Datei-Liste erstellen
|-fp:|[pattern]|Nur diese Datei herunterladen
|-fl:|[Datei]|Nur eine Datei-Liste ausgeben
|-md:|<Datei>|Gelschte Dateien markieren
|-ow||Dateien berschreiben";
 }
 else {
  if($cfg['dbug']/(1<<0)%2)
   dbug("Parse Parameter");
  $local = getArg('dir');						// [Lokal-Dir]
  if(!file_exists($local))
   makedir($local,0);
  if(file_exists($local) and is_dir($local)) {
   $local = str_replace('\\','/',realpath($local));
   $links = array();
   $host = 'avm.de';
   $port = 443;
   $page = '/fritz-labor/';
   if($html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => $page))) {
    if($html['HTTP_Code'] == 301 and preg_match('/'.preg_quote($host,'/').'[^\/]*(\/.*)$/',$html['Location'],$var))
     $html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => $var[1]));
    if($html and $html['HTTP_Code'] == 200 and preg_match_all('/<a[^>]+href=([\'"])(fritz-labor\/(?!#)\S+?)\\1[^>]*>(.*?)<\/a>/is',$html[1],$pages)) {
     foreach($pages[2] as $url) {	// Verschiedene Labor Gruppen durch gehen
      if($url{0} != '/')
       $url = "/$url";
      if($html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => $url))) {
       if($html['HTTP_Code'] == 301 and preg_match('/'.preg_quote($host,'/').'[^\/]*(\/.*)$/',$html['Location'],$var))
        $html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => $var[1]));
       if($html and $html['HTTP_Code'] == 200 and preg_match_all('/<a[^>]+href=([\'"])(\S+?\.zip)\\1[^>]*>(.*?)<\/a>/is',$html[1],$link)) {
        foreach($link[2] as $file)	// Labor-Download durch gehen
         if(!ifset($cfg['opts']['fp']) or stristr($file,$cfg['opts']['fp'])) {	// Nicht filtern oder Filter trifft zu
          if($file{0} != '/')
           $file = "/$file";
          if(ifset($cfg['opts']['fl']))	// Nur eine Dateiliste erstellen
           $links[] = "https://$host$file";
          elseif(ifset($cfg['opts']['ow']) or !file_exists("$local/".basename($file))) {	// Labor ist noch nicht vorhanden oder darf berschrieben werden
           if(ifset($cfg['opts']['fd']))
            $links[] = "https://$host$file";
           out(basename($file)." wird geladen");
           if($head = request(array('method' => "GET-save:$local/", 'host' => $host, 'port' => $port, 'page' => $file)) and $head['HTTP_Code'] == 200) {
            if(ifset($cfg['opts']['dl'],'/^\d+$/'))
             sleep($cfg['opts']['dl']);
           }
           elseif(!ifset($cfg['opts']['f'])) {
            out("Fehler: ".$cfg['http'][0]);
            break;
           }
          }
          else
           out(basename($file)." ist schon vorhanden");
         }
        if($cfg['opts']['md'] and $list = glob("$local/*.zip")) {	// Gelschte Labor-Images Markieren
         $link = preg_replace('/^.*?[\\\\\/](?=[^\\\\\/]+$)/','',$link[2]);
         foreach($list as $file)
          if(!preg_match('/_DEL\.\w+$/',$file) and array_search(basename($file),$link) === false) {
           dbug("$file wurde gelscht");
           if(is_bool($cfg['opts']['md']))
            rename($file,preg_replace('/(?=(\.\w+)?$)/',"_DEL",$file,1));
           elseif($cfg['opts']['md'] == ':')
            out($file);
           else
            file_contents($cfg['opts']['md'],"$file\n",8);
          }
        }
       }
      }
      else
       out("Keine Dateien zum herunterladen gefunden");
     }
    }
    else
     out("Labor hat keine Links");
   }
   else
    out("Kein Labor gefunden");
  }
  else
   out("Kein Lokales Verzeichnis gefunden");
  if($links) {
   $links = implode("\n",$links);
   $file = (ifset($cfg['opts']['fl']) and is_string($cfg['opts']['fl'])) ? $cfg['opts']['fl']
	: ((ifset($cfg['opts']['fd']) and is_string($cfg['opts']['fd'])) ? $cfg['opts']['fd'] : false);
   if($file)
    file_contents($file,$links);
   else
    out($links);
  }
 }

?>
