<?php if(!defined('fb_tools')) die("Plugin-File for fb_tools");	// (charset=iso-8859-1 / tabs=8 / lines=cr+lf / lang=de)

 $plugin = "ManualSync 0.01 (c) 23.06.2019 by Michael Engelke";
 $info = "Alle AVM Handbcher herunterladen"; /*

Plugingeschichte:
0.01 23.06.2019
 - Erste Version
*/
 $cfg['sync'] = ($var = ifset($cfg['opts']['dt'],'/^\d+$/')) ? (int)$var[0] : 2*60*60;	// Erlaube Differenzzeit in Sekunden
 $cfg['dupe'] = (ifset($cfg['opts']['st'])) ? $cfg['opts']['st'] : "_%Y-%m-%d_%H-%M-%S";	// Neuer Name mit Strftime
 if(!$cfg['ssl'] and !cfgdecrypt(0,'openssl') or (float)$cfg['osn'] < 1 or !ifset($cfg['ver'][10]) or $cfg['ver'][10] < 0.25)
  out(ucfirst($plug)." bentgt mindestens OpenSSL 1.0+ und {$cfg['ver'][1]} 0.25 oder neuer!");
 elseif(ifset($cfg['help']) or !getArg(true)) {			// Hilfe Ausgeben
  out("$plugin\n$info\n\n$self PlugIn $plug [dir:Lokal-Dir] <group:Gruppe> <lang:Sprache> <Option>\n{{{tt}Gruppen:|box, fon, wlan, powerline, dect, additional, schnittstellen}}
{{{tt}Sprachen:|be|Belgi||lu|Luxemburg\n|befr|Belgique||nl|Nederland\n|en|English||pl|Polska\n|es|Espaa||at|sterreich\n|it|Italia||ch|Schweiz\n|lufr|Luxembourg||chfr|Suisse}}"
.((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:\n$self plugin $plug /Mirror -d
$self plugin $plug . -fl
$self plugin $plug . -fl:manualfiles.txt
$self plugin $plug /media/stick/ wlan -fp:repeater -d
$self plugin $plug c:/AVM-Handbuch fritzbox -fp:7590 -ow -d" : "")."\n");
  if(!$cfg['help'] or $cfg['help'] === true)
   $cfg['help'] = -1;
  $opts .= "Manual:|-dl:|[sec]|Wartezeit zwischen zwei Requests
|-dt:|[sec]|Erlaubte Differenzzeit zwischen Client/Server
|-f||Fehler Ignorieren
|-fd:|<Datei>|Zu den Downloads eine Datei-Liste erstellen
|-fl:|<Datei>|Nur eine Datei-Liste ausgeben
|-fp:|<pattern>|Nur diese Datei herunterladen
|-md:|<Datei>|Gelschte Dateien markieren
|-ow||Dateien berschreiben
|-st:|[Strftime]|Doppelte Dateien mit Strftime umbenennen";
 }
 else {
  if($cfg['dbug']/(1<<0)%2)
   dbug("Parse Parameter");
  $local = getArg('dir');					// [Lokal-Dir]
  if(!file_exists($local))
   makedir($local,0);
  if(file_exists($local) and is_dir($local)) {
   $local = str_replace('\\','/',realpath($local));
   $links = array();
   $port = 443;
   $host = 'avm.de';						// Deutsche Handbcher
   $page = '/service/handbuecher/';
   $pages = explode(",","fritzbox,fritzfon,fritzwlan,fritzpowerline,fritzdect,additional");	// Alle Gruppen
   if($var = getArg('group','/^\w+$/'))
    if(!$pages = preg_array($val = '/'.preg_quote($var[0],'/').'/i',$pages,2) and preg_match($val,'schnittstellen')) {
     $pages = array('schnittstellen');
     $page = '/service/';
    }
    elseif(!$pages)
     out("Gruppe existiert nicht!");
   if($page != '/service/' and $var = getArg('lang') and $lang = preg_array('/'.preg_quote($var,'/').'/i',array(	// Weitere Sprachen
	'be.Belgi'	=> 'be/service/handboeken/',
	'befr.Belgique'	=> 'be/fr/service/manuels/',
	'en.English'	=> 'en/service/manuals/',
	'es.Espaa'	=> 'es/servicio/manuales-de-usuario/',
	'it.Italia'	=> 'it/assistenza/manuali/',
	'lufr.Luxembourg'=>'lu/fr/service/manuels/',
	'lu.Luxemburg'	=> 'lu/service/handbuecher/',
	'nl.Nederland'	=> 'nl/service/handboeken/',
	'pl.Polska'	=> 'pl/serwis/podreczniki/',
	'at.sterreich'	=> 'at/service/handbuecher/',
	'ch.Schweiz'	=> 'ch/service/handbuecher/',
	'chfr.Suisse'	=> 'ch/fr/service/manuels/'),1)) {
    $host = substr($lang,0,2).".$host";
    $page = substr($lang,2);
   }
   foreach($pages as $url) {					// Verschiedene Handbuch Gruppen durch gehen
    if($html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => "$page$url/"))) {
     if($html['HTTP_Code'] == 301 and preg_match('/'.preg_quote($host,'/').'[^\/]*(\/.*)$/',$html['Location'],$var))// Reload erforderlich?
      $html = request(array('method' => 'GET-array', 'host' => $host, 'port' => $port, 'page' => $var[1]));	// Request wiederholen
     if($html and $html['HTTP_Code'] == 200 and preg_match_all('/<a[^>]+href=([\'"])(\S+\.pdf)\\1[^>]*>(.*?)<\/a>/is',$html[1],$link)) {
      foreach($link[2] as $file)						// Handbuch-Download durch gehen
       if(!ifset($cfg['opts']['fp']) or stristr($file,$cfg['opts']['fp'])) {	// Nicht filtern oder Filter trifft zu
        if(ifset($cfg['opts']['fl']))						// Nur eine Dateiliste erstellen
         $links[] = $file;
        elseif(preg_match('!(https?://([\w.-]+)(?::(\d+))?)?(\S+)!',$file,$http)) {
         if(!$http[1]) {					// Sonderfall Schnittstellen
          $http[2] = $host;
          $http[4] = "/".$http[4];
         }
         if(!$http[3])
          $http[3] = 443;
         out(basename($file)." ... ",2);
         if(file_exists($lile = "$local/".basename($file))) {	// Handbuch existiert schon
          if($head = request(array('method' => "HEAD", 'host' => $http[2], 'port' => $http[3], 'page' => $http[4])) and $head['HTTP_Code'] == 200
		and $head['Content-Length'] == filesize($lile) and abs(strtotime($head['Last-Modified']) - filemtime($lile)) < $cfg['sync']) {
           $http = false;
           out("ist aktuell");					// Handbuch ist noch immer aktuell
          }
          elseif(!ifset($cfg['opts']['ow'])) {			// Altes Handbuch sichern
           $val = preg_replace('/(?=(\.\w+)?$)/',strftime($cfg['dupe'],filemtime($lile)),$lile,1);
           out("ist veraltet - ",2);
           rename($lile,$val);
          }
         }
         if($http) {
          out("starte Download");
          if($head = request(array('method' => "GET-save:$local/", 'host' => $http[2], 'port' => $http[3], 'page' => $http[4])) and $head['HTTP_Code'] == 200) {
           if(ifset($cfg['opts']['fd']))
            $links[] = $file;
           if(ifset($cfg['opts']['dl'],'/^\d+$/'))
            sleep($cfg['opts']['dl']);
          }
          elseif(!ifset($cfg['opts']['f'])) {
           out("Fehler: ".$cfg['http'][0]);
           break;
          }
         }
        }
       }
      if(ifset($cfg['opts']['md']) and $list = glob("$local/*.zip")) {	// Gelschte Handbcher markieren
       $link = preg_replace('/^.*?[\\\\\/](?=[^\\\\\/]+$)/','',$link[2]);
       foreach($list as $file)
        if(!preg_match('/_(DEL|\d{4}(-\d\d){2}_\d\d(-\d\d){2})\.\w+$/',$file) and array_search(basename($file),$link) === false) {
         dbug("$file wurde gelscht");
         if(is_bool($cfg['opts']['md']))
          rename($file,preg_replace('/(?=(\.\w+)?$)/',"_DEL",$file,1));
         elseif($cfg['opts']['md'] == ':')
          out($file);
         else
          file_contents($cfg['opts']['md'],"$file\n",8);
        }
      }
     }
    }
    else
     out("Kein Handbuch gefunden!");
   }
  }
  else
   out("Kein Lokales Verzeichnis gefunden!");
  if($links) {
   $links = implode("\n",$links);
   $file = (ifset($cfg['opts']['fl']) and is_string($cfg['opts']['fl'])) ? $cfg['opts']['fl']
	: ((ifset($cfg['opts']['fd']) and is_string($cfg['opts']['fd'])) ? $cfg['opts']['fd'] : false);
   if($file)
    file_contents($file,$links);
   else
    out($links);
  }
 }

?>
