#!/usr/bin/php
<?php $ver = "fb_tools 0.25 (c) GPL 11.09.2019 by Michael Engelke <https://mengelke.de/.dg>";	#(charset=iso-8859-1 / tabs=8 / lines=cr/lf / lang=de)
/*	This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
	You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>. */
if(!isset($cfg)) {					// $cfg schon gesetzt?
 $cfg = array(
	'sock'	=> 'auto',		// Socket: http, https, ssl, tls
	'host'	=> 'fritz.box',		// Fritz!Box-Addresse
	'pass'	=> 'password',		// Fritz!Box Kennwort
	'uipw'	=> false,		// Fritz!Box Anmeldekennwort (Nur mit Fernwartung)
	'user'	=> false,		// Fritz!Box Username (Optional)
	'port'	=> 80,			// Fritz!Box HTTP-Port (Normalerweise immer 80)
	'fiwa'	=> 100,			// Fritz!Box Firmware (Nur Intern)
	'upnp'	=> 49000,		// Fritz!Box UPnP-Port (Normalerweise immer 49000)
	'sbuf'	=> 4096,		// TCP/IP Socket-Buffergre
	'tout'	=> 30,			// TCP/IP Socket-Timeout
	'pcre'	=> 64*1024*1024,	// pcre.backtrack_limit (RegEx)
	'upda'	=> 60*60*24*100,	// Auto-Update-Check Periode (Kein Update-Check: 0)
	'wrap'	=> 'auto',		// Manueller Wortumbruch (Kein Umbruch: 0)
	'char'	=> 'auto',		// Zeichenkodierung der Console (auto/ansi/oem/utf8)
	'dbfn'	=> 'debug#.txt',	// Template fr Debug-Dateien
	'time'	=> 'Europe/Berlin',	// Zeitzone festlegen
	'drag'	=> 'konfig fcs * -d',	// Drag'n'Drop-Modus
	'fesc'	=> '|<>?*+"/\\:',	// Illegale Dateizeichen
	'frep'	=> '_',			// Ersetzungszeichen fr Illegale Dateizeichen
	'fbtg'	=> 'fbtp_*.php',	// Plugin Glob-Pattern
	'fbtm'	=> 'fbtp_([\w-]+)\.php',// Plugin Preg_Match-Pattern
	'fbtp'	=> 'plugins',		// Plugin-Pfad
	'libs'	=> 'libs',		// PHP-Bibliotheken
	'argn'	=> 'https?:|\w:|[\da-f]{2}:',// Args-Filter
	'help'	=> false,		// Hilfe ausgeben
	'dbug'	=> false,		// Debuginfos ausgeben
	'oput'	=> false,		// Ausgaben speichern
	'zlib'	=> array('mode' => -1),	// ZLib-Funktionen (mode: packlevel)
	'usrcfg'=> 'fb_config.php',	// Filename der Benutzerkonfiguration
 );
}
if(!function_exists('array_combine')) {			// http://php.net/array_combine
 function array_combine($key,$value,$array=array()) {
  if(count($key = array_values($key)) == count($value = array_values($value)))
   foreach($value as $k => $v)
    $array[$key[$k]] = $v;
  return ($array) ? $array : false;
 }
}
if(!function_exists('gzdecode')) {			// http://php.net/gzdecode (Workaround)
 function gzdecode($data) {
  global $cfg;
  if($tmp = tempnam(null,'gz') and $fp = fopen($tmp,'w')) {	// Gepackte Daten speichern
   fwrite($fp,$data);
   fclose($fp);
   $data = null;
   if($fp = $cfg['zlib']['open']($tmp,'rb')) {			// Daten entpackt lesen
    while(!$cfg['zlib']['eof']($fp))
     $data .= $cfg['zlib']['read']($fp,$cfg['sbuf']);
    $cfg['zlib']['close']($fp);
   }
   @unlink($tmp);						// berreste lschen
  }
  return $data;
 }
}
if(!function_exists('hash')) {				// http://php.net/hash (Workaround fr crc32b, md5, sha1 und optional sha256)
 function hash($algo,$data,$raw=false) {
  return ($hash = ($algo == 'crc32b') ? str_pad(sprintf('%x',crc32($data)),8,0,STR_PAD_LEFT) : ((preg_match('/^(md5|sha\d+)$/',$algo) and function_exists($algo))
	? $algo($data) : (($algo == 'sha256' and function_exists('mhash')) ? bin2hex(mhash(MHASH_SHA256,$data)) : false)) and $raw) ? pack("H*",$hash)
	: ((preg_match('/^([\da-f]{2})+$/i',$hash)) ? $hash : base64_decode($hash));
 }
}
function utf8($str,$mode=0) {				// UTF-8 Tool mode: Bit0 -> 0:decode 1:encode
 if(is_array($str) and isset($str[0]) and (isset($str['e']) or isset($str['d']) or isset($str['u']))) {
  $a = $str[0];
  if(isset($str['e'])) {		// Ansi -> UTF8
   if(function_exists('utf8_encode'))
    return utf8_encode($a);
   if(($a = ord($a)) < 128)
    return chr($a);
   $b = "";
   $c = 6;
   while($a >= 1 << $c and --$c) {
    $b = chr($a % 64 | 128).$b;
    $a = $a / 64 | 0;
   }
   return chr((1 << 7 - $c) -1 << ++$c | $a).$b;
  }
  elseif(isset($str['d'])) {		// UTF8 -> Ansi
   if(function_exists('utf8_decode'))
    return utf8_decode($a);
   for($b = ord($a{0}) % (1 << 7 - strlen($a)), $c = 1; $c < strlen($a); $c++)
    $b = $b * 64 + (ord($a{$c}) & 63);
   return ($b < 256) ? chr($b) : "\x7f";
  }
  return $a;
 }
 elseif(is_array($str)) {		// Array -> utf8[mode]
  foreach($str as $key => $var)
   if(is_string($var) or is_array($var))
    $str[$key] = call_user_func(__FUNCTION__,$var,$mode);
 }
 else {
  $p = "[\x80-\xbf]";
  $p = "[\xc0-\xdf]$p|[\xe0-\xef]$p{2}|[\xf0-\xf7]$p{3}|[\xf8-\xfb]$p{4}|[\xfc-\xfd]$p{5}|[\xfe]$p{6}";
  $p = ($mode % 2) ? "/(?P<u>$p)|(?P<e>[\x80-\xff])/" : "/(?P<d>$p)/";
  if((float)phpversion() > 5.2)
   return preg_replace_callback($p,__FUNCTION__,$str);
  elseif(preg_match_all($p,$str,$match,PREG_OFFSET_CAPTURE)) {	// Workaround PHP 4.3 - 5.2
   for($a=count($match[0])-1; $a >= 0; $a--) {
    $var = array($match[0][$a][0]);
    $var[(isset($match['e']) and $match['e'][$a][1] > -1) ? 'e' : ((isset($match['d']) and $match['d'][$a][1] > -1) ? 'd' : 'u')] = $var[0];
    $str = substr_replace($str,utf8($var),$match[0][$a][1],strlen($match[0][$a][0]));
   }
  }
 }
 return $str;
}
function file_contents($file,$data=false,$mode=false) {	// (Gepackte) Datei lesen/schreiben|mode: Bit1 -> Lock, Bit3 -> Append
 global $cfg;
 if($data and is_string($data)) {				// Datei schreiben
  if(strpos($file,'%') !== false)				// strftime auflsen
   $file = strftime($file);
  if(!$mode and preg_match('/\.t?gz$/i',$file) and $fp = $cfg['zlib']['open']($file,'w'.$cfg['zlib']['mode'])) {
   dbug("Schreibe GZip-File: $file",9);
   $data = $cfg['zlib']['write']($fp,$data);
   $cfg['zlib']['close']($fp);
   return $data;
  }
  elseif(function_exists('file_put_contents'))
   return file_put_contents($file,$data,$mode);			// Ungepackt schreiben
  else {							// file_put_contents ($mode ist nicht vollstndig implemmentiert)
   if($fp = fopen($file,($mode & 1<<3) ? 'a' : 'w')) {		// FILE_APPEND -> 8
    if(is_array($data))
     $data = implode('',$data);
    if($mode & 1<<1) {	// LOCK_EX -> 2
     if(flock($fp,2)) {	// flock LOCK_EX
      fputs($fp,$data);
      flock($fp,3);	// flock LOCK_UN
     }
     else {
      fclose($fp);
      return null;
     }
    }
    else
     fputs($fp,$data);
    fclose($fp);
    $fp = strlen($data);
   }
   return $fp;
  }
 }
 elseif(!$data and !$mode and !preg_match('/\.t?gz$/i',$file))	// Datei vollstndig lesen (data:0)
  return file_get_contents($file);
 elseif(is_int($data) and (float)phpversion() >= 5.1) {		// Datei ab Offset lesen (data:offset, mode:length) & PHP 5.1+
  $data = array($file,false,null,filesize($file) + (($data < 0) ? max($data,-filesize($file)) : min($data,filesize($file))));
  if($mode)
   $data[] = $mode;
  return call_user_func_array('file_get_contents',$data);
 }
 elseif(is_int($data) and $fp = fopen($file,'r')) {		// Datei ab Offset lesen (data:offset, mode:length)
  dbug("Lese File: $file ($data/$mode)",9);
  fseek($fp,$data,($data < 0) ? SEEK_END : SEEK_SET);
  $data = "";
  if($mode)
   $data = fread($fp,$mode);
  else
   while(!feof($fp))
    $data .= fread($fp,$cfg['sbuf']);
  fclose($fp);
  return $data;
 }
 elseif($fp = $cfg['zlib']['open']($file,'r')) {		// Datei entpackt lesen
  dbug("Lese gzFile: $file",9);
  $data = "";
  while(!$cfg['zlib']['eof']($fp))
   $data .= $cfg['zlib']['read']($fp,$cfg['sbuf']);
  $cfg['zlib']['close']($fp);
  return $data;
 }
 return false;
}
function listDir($pat,$dirs='',$mode=0,$list=array()) {	// Liest ein Verzeichnis aus (Pattern, Verzeichnis(e), Modus)	// Bit0 > Pattern, Bit1 > PathPat
 if(!($mode & 1<<0)) {		// Simple-Pattern			// Bit2 > basename, Bit3 > noFile, Bit4 > noDir, Bit5 > Recusiv, Bit6 > Sort
  if(!$dirs) {			// Kein Verzeichnis angegeben
   if(file_exists($pat))	// Pattern existiert
    if(is_file($pat)) {		// Pattern ist ein File
     $dirs = dirname($pat);
     $pat = basename($pat);
    }
    else {			// Pattern ist ein Verzeichnis
     $dirs = $pat;
     $pat = '*';
    }
   elseif($var = ifset($pat,'/^(.*?)([^\\\\\/]*[*?][^\\\\\/]*)$/')) {	// Pattern besteht aus Verzeichnis und Pattern (glob)
    $dirs = $var[1];
    $pat = $var[2];
   }
   if(!$dirs)
    $dirs = '.';
  }
  if($pat and !function_exists('fnmatch')) {		// Workaround wenn fnmatch() nicht verfgbar ist
   $pat = "/^".strtr(preg_quote($pat,'/'),array('\*' => '.*', '\?' => '.', '\[' => '[', '\]' => ']'))."$/i";
   $mode |= 1<<0;											 //
  }
 }
 foreach(array_unique((array)$dirs) as $dir) {		// Alle Verzeichnisse durchgehen
  if(file_exists($dir) and $dp = opendir($dir)) {
   $dir = preg_replace('/[\\\\\/]$/','',$dir);		// Letzten Slash entfernen
   while(($file = readdir($dp)) !== false)
    if(!preg_match('/^\.\.?$/',$file)) {		// Kein Current oder Parent
     $fn = (($mode & 1<<1) ? "$dir/" : '').$file;	// Bit 1 -> Filename fr Pattern
     if(!$pat or $mode & 1<<0 and preg_match($pat,$fn) or !($mode & 1<<0) and fnmatch($pat,$fn,FNM_CASEFOLD)	// Bit 0 -> Patterncheck
	and (!($mode & (1<<3 | 1<<4)) or $mode & 1<<3 and !is_file("$dir/$file") or $mode & 1<<4 and !is_dir("$dir/$file"))) {	// Bit3 -> file / Bit4 -> dir
      $fn = ($mode & 1<<2) ? $file : (($dir != '.') ? "$dir/" : "").$file.((is_dir("$dir/$file")) ? '/' : '');
      if($mode & 1<<2)
       $list[realpath("$dir/$file")] = $fn;
      else
       array_push($list,$fn);
      if($mode & 1<<5 and is_dir("$dir/$file") and $array = call_user_func(__FUNCTION__,$pat,"$dir/$file",$mode))	// Bit 5 -> Rekursiv
       if($mode & 1<<2)							// Bit 2 -> Basename
        $list[($mode & 1<<2) ? realpath($file) : $file] = $array;	// Assoc
       else
        $list = array_merge($list,$array);				// List
     }
    }
   closedir($dp);
  }
 }
 if(!$mode & 1<<2)
  $list = array_unique($list);
 if($mode & 1<<6)							// Bit 6 -> Sortieren
  natcasesort($list);
 return ($list) ? $list : false;
}
function ifset(&$x,$y=false) {				// Variabeln prfen und Optional vergleichen (var,test)
 return (isset($x) and $x) ? (($y) ? ((is_string($x) and $y{0} == '/' and (substr($y,-1) == 'a' and preg_match_all(substr($y,0,-1),$x,$z) or preg_match($y,$x,$z)))
	? $z : ((is_array($x)) ? (($y{0} == '/') ? preg_grep($y,$x) : ((is_int($y)) ? count($x) == $y : array_search($y,$x))) : $x === $y)) : ((is_string($x))
	? strlen($x) : ((is_array($x)) ? count($x) : !$y))) : false;
}
function preg_array($x,$y,$z=0) {			// Durchsucht einen Array mit Regulren Ausdruck (preg,array,mode)
 $w = $z & 1<<1 ? array() : false;						// Bit 0: Search 0:value / 1:key	1
 foreach($y as $k => $v)							// Bit 1: Result 0:first / 1:all	2
  if($z & 1<<4 and is_array($v) and $u = call_user_func(__FUNCTION__,$x,$v,$z))	// Bit 2: Result 0:value / 1:key	4
   if($z & 1<<1)								// Bit 3: Search 0:found / 1:not found	8
    $w[$k] = $u;								// Bit 4: 0:iterativ	 / 1:rekusiv	16
   else
    return $z & 1<<2 ? $k : $u;
  elseif($z & 1<<3 xor preg_match($x,$z & 1<<0 ? $k : $v))
   if($z & 1<<1)
    $w[$k] = $v;
   else
    return $z & 1<<2 ? $k : $v;
 return $w;
}
function getArg($name=false,$preg=false,$arg=null) {	// Nchsten Parameter holen (argname, /preg_match/, argname-only & return@false)
 global $cfg,$pset;	// args,argc,argn,arg
 if($name and is_bool($name))								// Ungeprfte Parameter vorhanden?
  $arg = preg_array("/^(".str_replace('\|','|',preg_quote(implode('|',array_keys($cfg['argk'])),'/')).")$/",$cfg['arg'],11);
 elseif($name and isset($cfg['args'][$name]) and is_array($arg = $cfg['args'][$name])) {// Benanntes Argument ist ein Array
  if(is_string($preg) and strlen($preg) == 1)						// Array als CSV zurckgeben?
   $arg = implode($preg,str_replace($preg,$preg.$preg,$arg));
  elseif(!is_array($preg) and ifset($var = current($cfg['args'][$name]),$preg))		// Aktuelles Argument aus Array zurckgeben
   $arg = ($preg) ? $var : current($cfg['args'][$name]);
 }
 elseif($name and $var = ifset($cfg['args'][$name],$preg))				// Benannter Parameter
  $arg = ($preg) ? $var : $cfg['args'][$name];
 elseif(!$name and is_null($arg) and is_array($preg) and $cfg['argc'])			// Alle restlichen Nummerischen Parameter zurckgeben
  for($arg=array(); $name = array_shift($cfg['argc']);)
   $arg[] = $cfg['arg'][$name];
 elseif(is_null($arg) and $cfg['argc'] and $var = ifset($cfg['arg'][reset($cfg['argc'])],$preg)) {	// Nummerierter/Unbenannter Parameter
  if(!$cfg['argn'])									// bergabe/Abfrage vom alten Parameter-System ermglichen
   $pset++;
  $name = array_shift($cfg['argc']);
  $arg = ($preg) ? $var : $cfg['arg'][$name];
 }
 return (is_null($arg) or !$arg) ? false : $cfg['argk'][$name] = ((is_array($preg)) ? (array)$arg : $arg);	// Vorgabe oder false zurckgeben
}
function out($str,$mode=0,$lf="\n") {			// Textconvertierung vor der ausgabe (mode: 0 -> echo / 1 -> noautolf / 2 -> debug)
 global $cfg;
 if($str) {
  if(is_array($str))
   $str = print_r($str,true);
  if(!($mode & 1<<1) and preg_match('/\S$/D',$str))		// AutoLF
   $str .= $lf;
  if($mode & 1<<2)						// Unntige Whitespaces im Debug-Modus lschen
   $str = preg_replace('/(?<=\n\n|\r\n\r\n)\s+$/','',$str);
  if($cfg['oput'] and !($mode & 1<<2))				// Ausgabe speichern
   file_contents($cfg['oput'],$str,8);
  $cp = (ifset($cfg['char'])) ? (array)$cfg['char'] : array('c' => 1);
  if(!(ifset($cp['c']) or ifset($cp['l']))) {			// Wortumbruch fr 1 Byte Chars
   $str = textTable($str,-1);
   if((int)$cfg['wrap'])
    $str = wordwrap($str,$cfg['wrap']-1,$lf,true);
  }
  if(ifset($cp['d']) and preg_match_all('/(.)(.)/',base64_decode(
	"thSnFceA/IHpguKD5ITgheWG54fqiOuJ6Irvi+6M7I3EjsWPyZDmkcaS9JP2lPKV+5b5l/+Y1pncmqOc4aDtofOi+qPxpNGlqqa6p7+orKq9q7ysoa2rrruv3+G15rHx9/aw+Lf6sv2g/"
	.((substr($cp['d'],-3) == 437) ? "6KbpZ0=" : "/ib2J3Xnq6pwbXCtsC3qbiivaW+48bDx6TP8NDQ0crSy9PI1M3WztfP2KbdzN7T4NTi0uP15NXl/ufe6Nrp2+rZ6/3s3e2v7rTvrfC+87b0p/W496j5ufuz/A==")),$m))
   $str = strtr($str,array_combine($m[1],$m[2]));		// DOS
  elseif(ifset($cp['m']) and preg_match_all('/(.)(.)/',"ǀĎɐ֙ܚמ¶",$m))
   $str = strtr($str,array_combine($m[1],$m[2]));		// cp852
  elseif(ifset($cp['u']))
   $str = utf8($str,1);						// UTF8
  elseif(ifset($cp['h']) and preg_match_all('/(.)([\da-z#]+)/','&amp<lt>gt"quot\'#39aumloumluumlszligAumlOumlUuml',$m))
   $str = strtr($str,array_combine($m[1],preg_replace('/.+/','&$0;',$m[2])));	// HTML
  elseif((ifset($cp['c']) or ifset($cp['l']) or !ifset($cp['a'])) and preg_match_all('/([^ -~]+)([ -~]+)/','!GBP|\\S"(c)<<-(R)\'^+-23\'uI\''
	.'.1>>1/41/23/4?AEAeOeUeaeoeuessACEIDNOUݥYpaceinouPyx:',$m)) {
   $a = array();						// 7 Bit ASCII
   foreach($m[1] as $key => $var)
    for($b=0; $b < strlen($var); $b++)
     $a[$var{$b}] = $m[2][$key];
   $str = strtr($str,$a);
   if(ifset($cp['l']) and preg_match_all('/([a-z\d])(.)|(.)(..)/i','1I2Z3E4A5S6G7T8B9g0Oa4A4b8B8c<C(e3E3g6G6h#H#i!I!l1L1o0O0q9Q9s5S5t7T7x+X+z2Z2',$m)
	and preg_match_all('/(.)(.+)/',implode("\n",$m[0]),$m))
    $str = strtr($str,array_combine($m[1],$m[2]));
  }
  if((ifset($cp['c']) or ifset($cp['l']))) {			// Wortumbruch fr Multibyte Chars
   $str = textTable($str,-1);
   if((int)$cfg['wrap'])
    $str = wordwrap($str,$cfg['wrap']-1,$lf,true);
  }
 }
 return ($mode & 1<<0) ? $str : print $str;
}
function dbug($str,$level=0,$mode=4) {			// Debug-Daten ausgeben/speichern (mode: 4 -> Debug)
 global $cfg;
 if($cfg['dbug']/(1<<$level)%2) {			// Nur Entsprechenden Debug-Level ausgaben
  if(is_string($mode))					// Entweder Mode-Angabe oder Dateiname
   if(preg_match('/^(\d+),(.+)$/',$mode,$var)) {
    $mode = $var[1];
    $file = $var[2];
   }
   else {
    $file = $mode;
    $mode = 4;
   }
  else
   $file = false;
  $time = ($cfg['dbug'] & 1<<2 and !($mode & 1<<3)) ? number_format(array_sum(explode(' ',microtime()))-$cfg['time'],3,',','.').' ' : '';
  if($cfg['dbug'] & 1<<1 and $cfg['dbfn'] and $file)	// Debug: Array in separate Datei sichern
   if(strpos($file,'#') and is_array($str))
    foreach($str as $key => $var)			// Debug: Array in mehrere separaten Dateien sichern
     file_contents($cfg['dbcd'].str_replace('#',"-".str_replace('#',$key,$file),$cfg['dbfn']),$time.((is_array($var)) ? print_r($var,true) : $var),8);
   else
    file_contents($cfg['dbcd'].str_replace('#',"-$file",$cfg['dbfn']),$time.((is_array($str)) ? print_r($str,true) : $str),8);	// Alles in EINE Datei Sichern
  else {
   if(is_string($str)) {
    if(preg_match('/^\$(\w+)$/',$str,$var) and isset($GLOBALS[$var[1]]))	// GLOBALS Variable ausgeben
     $str = "$str => ".(is_array($GLOBALS[$var[1]]) ? print_r($GLOBALS[$var[1]],true) : $GLOBALS[$var[1]]);
    elseif(!($mode & 1<<1) and preg_match('/\S$/D',$str))// AutoLF
     $str .= "\n";
   }
   elseif(is_array($str))
    $str = print_r($str,true);
   if($cfg['dbug'] & 1<<1 and $cfg['dbfn']) {		// Debug: Ausgabe/Speichern
    file_contents($cfg['dbcd'].str_replace('#','',$cfg['dbfn']),$time.$str,8);
    if(!$level)						// Nur Level 0 Ausgeben
     out($time.$str,$mode | 4);
   }
   else
    out($time.$str,$mode | 4);
  }
 }
}
function errmsg($msg,$name='main') {			// Fehlermeldung(en) Sichern
 global $cfg;
 if(!ifset($cfg['errmute']))	// Fehleraufzeichnung pausieren?
  if($msg) {			// Fehlermeldung speichern
   dbug("Fehler: $msg",9);
   $cfg['error'][$name][] = trim($msg);
  }
  else {			// Fehlermeldung abrufen
   dbug("Fehler: $name suchen",9);
   while(isset($cfg['error'][$name]) and is_array($cfg['error'][$name]))// Fehlermeldung vorhanden?
    if($val = end($cfg['error'][$name]) and preg_match('/^\w+$/',$val))	// Mglicher Rekusive Fehlermeldung?
     $name = $val;		// Nchste Fehlermeldung suchen
    else
     return $val;		// Fehlermeldung ausgeben
  }
 return false;			// Funktion fehlgeschlagen
}
function makedir($dir,$mode=1) {			// Erstellt ein Verzeichnis und wechselt dorthin
 if(!$dir or $dir == '.')				// Self-Dir nicht bearbeiten
  return true;
 $dir = preg_replace('/[\\\\\/]$/','',$dir);		// Abschlussshlash entfernen
 if(strpos($dir,'%') !== false)				// strftime auflsen (Problematische Zeichen werden umgewandelt)
  $dir = strftime($dir);
 if(preg_match('/^(\w:)?(.*)$/',$dir,$var))
  $dir = $var[1].preg_replace('/[<:*|?">]+/','-',$var[2]);
 if(!file_exists($dir)) {				// Neues Verzeichniss erstellen
  if($mode)						// Debug-Meldung unterdrcken
   dbug("Erstelle Ordner $dir");
  $dirs = preg_split('/[\\\\\/]/',$dir);		// Verzeichniskette erstellen
  $val = '';
  foreach($dirs as $var) {
   $val .= $var;
   if($val and !file_exists($val))
    mkdir($val);
   $val .= '/';
  }
 }
 if($mode and is_dir($dir)) {				// Aktuelles-Dir setzen
  dbug("Wechsle zu Ordner $dir");
  chdir($dir);
  $mode = 0;
 }
 return ($mode) ? false : $dir;
}
function xml2array($xml,$attr="_attribute") {		// Konvertiert eine XML-Datei in ein Array
 if(preg_match_all('/<(\w+)([^>]*)>\s*((?:[^<]|<(?!\/?\1>)|(?R))+)\s*<\/\1>/',$xml,$val)) {
  $xml = array();
  foreach($val[1] as $key => $var) {
   $sub = call_user_func(__FUNCTION__,$val[3][$key],$attr);// Untertag einlesen
   if($val[2][$key] and preg_match_all('/([\w-]+)="((?:[^"]+|\\\\")*)"/',$val[2][$key],$m))
    foreach($m[1] as $k => $v)				// Attribute einlesen
     if($attr)
      $sub[$attr][$v] = $m[2][$k];
     else
      $sub[$v] = $m[2][$k];
   if(isset($xml[$var])) {				// Tag schon vorhanden
    if(!isset($xml[$var][0]) or !is_array($xml[$var]))	// Noch nicht Nummeriert?
     $xml[$var] = array($xml[$var]);			// Eintrge in Nummer 0 verschieben
    $xml[$var][] = $sub;				// Tag hinten dran hngen
   }
   else
    $xml[$var] = $sub;					// Tag normal speichern
  }
 }
 return $xml;
}
function tar2array($file,$preg=false) {			// Liest ein Tar-Archiv vom File als Array ein
 global $cfg;
 if(file_exists($file) and preg_match($cfg['ptar'],$file) and $fp = $cfg['zlib']['open']($file,'r')) {
  dbug("Entpacke Tar-Archiv aus Datei",9);
  $tar = array();
  while($meta = $cfg['zlib']['read']($fp,512) and preg_match('/^[^\0]+/',substr($meta,0,100),$name)) {
   $data = substr_replace($meta,"        ",148,8);
   for($crc=$a=0; $a < 512; $crc += ord($data{$a++}));
   if($crc != octdec(substr($meta,148,6)))
    return errmsg("Defektes Tar-Archiv",__FUNCTION__);
   if($size = octdec(substr($meta,124,11)))
    $data = $cfg['zlib']['read']($fp,$size + 512 - $size % 512);
   if(!$meta{156} and (!$preg or preg_match($preg,$name[0])))
    $tar[$name[0]] = substr($data,0,$size);
  }
  $cfg['zlib']['close']($fp);
  dbug($tar,9,'8,tar2array-#');
  return $tar;
 }
 return errmsg("TAR-Archiv nicht gefunden oder lt sich nicht ffnen",__FUNCTION__);
}
function datatar2array($tar,$preg=false) {		// Parst aus Variable ein Tar-Archiv mit Meta-Daten als Array
 dbug("Entpacke Tar-Archiv aus Variable",9);
 if(preg_match_all('/(\D+)(\d+)/',"name100mode8UID8GID8SIZE12MTIME12CHKSUM8TYPEFLAG1linkname100magic6VERSION2uname32gname32devmajor8devminor8prefix155",$array))
  $array = array_combine($array[1],$array[2]);
 $out = array();
 $pos = 0;
 while($pos < strlen($tar) and $tar{$pos} != "\0") {
  $meta = array();
  $data = substr_replace(substr($tar,$pos,512),"        ",148,8);	// Buffer ohne Checksumme vorbereiten
  for($crc=$a=0; $a < 512; $crc += ord($data{$a++}));	// Checksumme berechnen
  if($crc != octdec(substr($tar,$pos + 148,6)))
   return errmsg("Defektes Tar-Archiv",__FUNCTION__);
  $a = $pos;
  foreach($array as $key => $var) {
   if($data = preg_replace('/\0+$/','',substr($tar,$a,$var)))
    $meta[strtolower($key)] = (strtolower($key) == $key) ? $data : octdec($data);
   $a += $var;
  }
  if($size = $meta['size']) {
   $meta['data'] = substr($tar,$pos + 512,$size);
   $pos += $size + 512 - $size % 512;
  }
  $pos += 512;
  if(!ifset($meta['typeflag']) and (!$preg or preg_match($preg,$meta['name'])))
   $out[$meta['name']] = $meta;
 }
 return $out;
}
function data2tar($name,$data='',$time=0) {		// Erstellt ein Tar-Header
 $data = str_pad($name,100,chr(0))."0100777".chr(0).str_repeat(str_repeat("0",7).chr(0),2).str_pad(decoct(strlen($data)),11,"0",STR_PAD_LEFT).chr(0)
	.str_pad(decoct($time),11,"0",STR_PAD_LEFT).chr(0)."        0".str_repeat(chr(0),100)."ustar".chr(0)."00".str_repeat(chr(0),247)
	.$data.str_repeat(chr(0),(512 - strlen($data) % 512) % 512);
 for($a=$b=0; $a<512; $a++)
  $b += ord($data[$a]);
 return substr_replace($data,str_pad(decoct($b),6,"0",STR_PAD_LEFT).chr(0)." ",148,8);
}
function textTable($table,$cols=0,$col="|",$row="\n",$tab=" ",$sp=" ") {	// Text als Text-Tabelle konvertieren
 if($cols == -1)		// Creole-Aufruf
  return preg_replace_callback('/\{\{\{(?:tt|77)((?:,[^,\}]*)*)\}(.*?)\}\}/s',__FUNCTION__,$table);
 elseif(is_array($table)) {	// Creole-Funktion
  if($var = ifset($table[1],'/,([^,]*)/a')) {
   array_unshift($var[1],$table[2]);
   $opts = $var[1];
   if(ifset($opts[4],'/;/'))
    $opts[4] = explode(';',$opts[4]);
   if(ifset($opts[5],'/;/'))
    $opts[5] = explode(';',$opts[5]);
  }
  else
   $opts = array($table[2]);
  return call_user_func_array(__FUNCTION__,$opts);
 }
 elseif(!$cols and $cols = $GLOBALS['cfg']['wrap'])
  $cols -= 2;
 $lines = explode($row,trim($table));
 $lens = $max = $min = $ali = $table = array();
 $col = array('/(?<!\\\\)'.preg_quote($col,'/').'/','/\\\\(?='.preg_quote($col,'/').')/');
 foreach($lines as $kl => $line) {
  $table[$kl] = preg_replace($col[1],'',preg_split($col[0],$line));
  foreach($table[$kl] as $kr => $rift)
   if(preg_match('/^(\s*)(.*?)(\s*)$/',$rift,$var)) {
    $table[$kl][$kr] = $var[2];
    $ali[$kl][$kr] = ($var[1] and $var[3]) ? STR_PAD_BOTH : (($var[1] and !$var[3]) ? STR_PAD_LEFT : STR_PAD_RIGHT);
    $max[$kr] = max((isset($max[$kr])) ? $max[$kr] : 0, strlen($var[2]));
   }
 }
 if($cols and array_sum($max) + count($max) -1 > $cols) {
  $cols = max($cols,count($max) * 2);
  foreach($table as $kl => $line)
   foreach($line as $kr => $rift)
    $min[$kr] = max((isset($min[$kr])) ? $min[$kr] : 0,max($lens[$kl][$kr] = array_map('strlen',explode((is_array($sp)) ? $sp[$kr] : $sp,$table[$kl][$kr]))));
  while(($cols and array_sum($max) + count($max) -1 > $cols) and array_sum($max) > array_sum($min)) {
   $mlen = array();
   foreach($lens as $kl => $line) {
    $var = count($line) -1;
    $key = array();
    foreach($line as $kr => $rift) {
     $var += array_sum($rift) + count($rift) -1;
     if(!$key or $key[1] < count($rift))
      $key = array($kr,count($rift));
    }
    if(!$mlen or $mlen[1] <= $var and $mlen[3] < $key)
     $mlen = array_merge(array($kl,$var),$key);
   }
   if($mlen)
    array_pop($lens[$mlen[0]][$mlen[2]]);
   else
    break;
   $max = $min;
   foreach($lens as $kl => $line)
    foreach($line as $kr => $rift)
     $max[$kr] = max((isset($max[$kr])) ? $max[$kr] : 0, array_sum($rift) + count($rift) -1);
  }
  while(array_sum($max) + count($max) -1 > $cols)
   $max[array_search(max($max),$max)]--;
 }
 $out = array();
 foreach($table as $tk => $line) {
  $wrap = 0;
  foreach($line as $key => $var) {
   $line[$key] = explode($row,wordwrap($var,$max[$key],$row,true));
   $wrap = max($wrap,count($line[$key]));
  }
  for($a=0; $a < $wrap; $a++) {
   $buf = "";
   foreach($line as $key => $var)
    $buf .= str_pad((isset($line[$key][$a])) ? $line[$key][$a] : "",$max[$key],(is_array($sp)) ? $sp[$key] : $sp,$ali[$tk][$key]).((is_array($tab)) ? $tab[$key] : $tab);
   $out[] = rtrim($buf);
  }
 }
 return implode($row,$out);
}
function request($method,$page='/',$body=0,$head=0,$host=0,$port=0,$sock=0,$user=0,$pass=0) {	// HTTP-Request durchfhren
 global $cfg;
 if(!$method) {		// Unterfunktion: HTTP Auth zusammenstellen ($page,$arg,$auth)
  if(is_string($head) and preg_match('/^(\w+)\s+(.*)$/',$head,$m)) {	// Erste Anmeldung
   $head = array();
   $m[1] = strtolower($m[1]);
   if($m[1] == 'basic') {
    $head['username'] = $body['user'];
    $head['password'] = $body['pass'];
    $head[$m[1]] = "Basic ".base64_encode(implode(":",$head));	// Absolut unknackbar ;-)
    $cfg['auth'] = $head;
   }
   elseif($m[1] == 'digest' and preg_match_all('/(\w+)\s*=\s*(\\\\?["\']?)(.*?)\2(,\s*|\s*$)/',$m[2],$m)) {	// HTTP Auth Digest
    dbug($m,4);
    $head = array_merge(array(
	'username' => $body['user'],
	'nc' => 0,
	'cnonce' => substr(hash('md5',time().rand()),16),
    ),array_combine($m[1],$m[3]));
   }
   if(isset($head['username']))
    dbug("HTTP Auth ".((isset($head['basic'])) ? "Basic" : "Digest")." fr $head[username]",5);
  }
  if(is_array($head))
   if(isset($head['basic']))	// HTTP Auth Basic
    $method = $head['basic'];
   else {			// HTTP Auth Digest
    $head['nc'] = str_pad(intval($head['nc']) + 1,8,0,STR_PAD_LEFT);	// Zhler erhhen
    $head['uri'] = $page;						// Aktuelle Seite
    $hash = (ifset($head['algorithm'])) ? strtolower(str_replace('-','',$head['algorithm'])) : 'md5';	// Hash Methode festlegen
    if($head['response'] = hash($hash,hash($hash,"$head[username]:$head[realm]:$body[pass]")
	.":$head[nonce]:$head[nc]:$head[cnonce]:$head[qop]:".hash($hash,strtoupper(preg_replace('/-.*/','',$body['method'])).":$page"))) {
     $cfg['auth'] = $head;	// Werte sichern
     foreach($head as $key => $var)
      $head[$key] = "$key=\"$var\"";
     $method = "Digest ".implode(', ',$head);		// Anmeldedaten zusammenstellen
    }
   }
  return $method;
 }
 elseif(is_array($method))				// Parameter aus Array holen
  extract($method);
 elseif(is_string($method) and $val = ifset($method,	// Parameter aus String holen (GET-array)
	'/^(https?):(?:\[([^\[\s\]]+)\])?\/\/(?:([^@:\s]+):)?(?:([^@\s]+)@)?
	((?:(?!-)[a-z\d-]+(?<!-)\.)+(?!-)[a-z\d-]+(?<!-)|0*(?:\d{1,2}|1\d{2}|2[0-4]\d|25[0-5])(?:\.0*(?:\d{1,2}|1\d{2}|2[0-4]\d|25[0-5])){3}
	|\[:?(?:[\da-f]{0,4}:){0,7}[\da-f]{0,4}\])(?::(\d{1,5}))?(\/[^\#?\s]*)(?:\?([^\s]*))?$/ix')) {
  foreach(explode(',','sock,mode,user,pass,host,port,page,body') as $key => $var)
   if(ifset($val[$key+1]))
    $$var = $val[$key+1];
  if(isset($host))					// IPv6 anpassen
   $host = preg_replace('/^\[|\]$/','',$host);
  $method = (ifset($mode)) ? $mode : 'GET';
 }
 foreach(explode(',','sock,host,port,user,pass') as $var)// Host, Port, user & pass setzen
  if(!$$var)
   $$var = $cfg[$var];
 if(!$head)						// Head Initialisieren
  $head = $cfg['head'];
 if($mode = preg_match('/^(\w+)(?:-(.+))?/',$method,$var)) {
  $method = strtoupper($var[1]);
  $mode = (isset($var[2])) ? $var[2] : (($var[1] == strtolower($var[1])) ? 'array' : false);	// Result-Modus festlegen
 }
 $arg = array_flip(explode(',','method,mode,sock,host,port,page,head,body,user,pass'));	// Parameter sichern
 foreach($arg as $key => $var)
  $arg[$key] = $$key;
 $http = $sock;
 if($sock = ($sock == 'auto' and ($port == 80 or $port == 8080 or $port == 49000) or $sock == 'http') ? '' : ((ifset($sock,'/^(ssl|tls)$/')) ? "$sock://" : 'ssl://'))
  if(!$cfg['ssl'])
   if($var = cfgdecrypt(0,'openssl')) {
    $cfg['ssl'] = $var['openssl'];
    dbug("OpenSSL nachgeladen: $var[openssl]",9);
   }
   else
    return errmsg("OpenSSL nicht verfgbar",__FUNCTION__);
 dbug("$sock$host:$port",5);
 if(function_exists('stream_socket_client') and $fp = @stream_socket_client((($sock) ? $sock : "tcp://")
	."$host:$port",$errnr,$errstr,$cfg['tout'],STREAM_CLIENT_CONNECT,stream_context_create((ifset($http,'/auto|https/i'))
	? array('ssl' => array('verify_peer' => false, 'verify_peer_name' => false)) : array()))
	or $fp = @fsockopen($sock.$host,$port,$errnr,$errstr,$cfg['tout'])) {	// Verbindung aufbauen
  if($cfg['tout'])
   stream_set_timeout($fp,$cfg['tout']);		// Timeout setzen
//  stream_set_blocking($fp,0);
  if($method == 'POST') {				// POST-Request vorbereiten
   if(is_array($body)) {				// Multipart-Post vorbereiten
    $row = "---".hash('md5',rand().time());
    foreach($body as $key => $var) {
     $val = array('','');
     if(is_array($var))					// Unter-Header im Header
      foreach($var as $k => $v)
       if($k == '')					// Content
        $var = $v;
       elseif($k == 'filename')				// Weitere Angaben im Header
        $val[0] .= "; $k=\"$v\"";
       else						// Sub-Header
        $val[1] = "$k: $v\r\n";
     $body[$key] = "$row\r\nContent-Disposition: form-data; name=\"$key\"$val[0]\r\n$val[1]\r\n$var\r\n";
    }
    $body = implode('',$body)."$row--\r\n";
    $var = "multipart/form-data; boundary=$row";
   }
   else
    $var = 'application/x-www-form-urlencoded';		// Standard Post
   if(!isset($head['content-type']))
    $head['content-type'] = $var;
   if(!isset($head['content-length']))
    $head['content-length'] = strlen($body);
   $body = "\r\n$body";
  }
  elseif($method == 'GET' and $body) {			// GET-Request vorbereiten
   $page .= "?$body";
   $body = "\r\n";
  }
  else
   $body = "\r\n";
  if(!isset($head['host']))				// Host zum Header hinzufgen
   $head['host'] = $host;
  if($cfg['auth'] and $auth = call_user_func(__FUNCTION__,0,$page,$arg,$cfg['auth']))// HTTP Auth in folge
   $head['Authorization'] = $auth;
  if(!isset($head['connection']))			// Connection zum Header hinzufgen
   $head['connection'] = "close";
  foreach($head as $key => $var)			// Header vorbereiten
   $head[$key] = ucwords($key).": $var";
  $sp = preg_match('/^(?:save|down(?:load)?):(.*?(\.gz)?)$/i',$mode,$file);
  $head = "HTTP/1.1\r\n".implode("\r\n",$head)."\r\n";	// Header Finalisieren
  dbug("$method $page".(($cfg['dbug'] & 1<<7) ? " $head$body\n\n" : ''),5,__FUNCTION__);	// Debug Request
  fwrite($fp,"$method $page $head$body");		// Request Absenden
  if($mode == 'putonly')				// Nur Upload durchfhren
   return fclose($fp);
  $head = array();
  $header = "";
  while($a = trim($b = fgets($fp,$cfg['sbuf']))) {	// Alle Header herunterladen
   $header .= $b;
   if(preg_match('/^([\w-]+):\s*(.*)$/',$a,$b))
    $head[ucwords($b[1])] = $b[2];
   elseif(preg_match('!^HTTP/[\d.]+\s*(\d+)\s*(.+?)\s*$!im',$a,$b)) {	// HTTP_Code abfangen
    $head[] = $a;
    $head['HTTP_Code'] = $b[1];	// Error-Code
    $head['HTTP_Info'] = $b[2];	// Error-Name
   }
  }
  $cfg['http'] = $head;					// Header Global sichern
  if($method == 'HEAD' or $mode == 'header') {		// Nur Header herunterladen
   fclose($fp);
   return $head;
  }
  if($head['HTTP_Code'] >= 400) {			// Blacklist erkennen
   fclose($fp);
   if($head['HTTP_Code'] == 401 and !isset($arg['head']['Authorization']) and isset($head['WWW-Authenticate'])
	and $auth = call_user_func(__FUNCTION__,0,$page,$arg,$head['WWW-Authenticate'])) {	// HTTP Auth
    $arg['head']['Authorization'] = $auth;
    return call_user_func(__FUNCTION__,$arg);
   }
   return errmsg("HTTP-Fehler: $head[HTTP_Code] $head[HTTP_Info] $page",__FUNCTION__);
  }
  $size = (ifset($head['Content-Length'])) ? $head['Content-Length'] : 0;
  $rp = "";
  if($sp) {						// Download -> Datei
   $gz = ifset($file[2]);				// GZip komprimieren?
   if(!feof($fp)) {					// Nur weitermachen wenn noch Daten kommen
    $file[1] = preg_replace('/(?<=[\\\\\/])$|^\.?$/',preg_replace($cfg['fesc'],$cfg['frep'],(ifset($file[1],'/^[.\\\\\/]*$/')
	and $var = ifset($head['Content-Disposition'],'/^(?:attachment;\s*)?filename=(["\']?)(.*?)\1$/mi'))
	? $var[2] : basename(urldecode($page))),$file[1]);
    dbug("Downloade '".basename($file[1])."'".(($size) ? " ".number_format($size,0,'.',',')." Bytes" : ""));
    $a = $b = 0;					// Antwort vorbereiten
    if($sp = ($gz) ? $cfg['zlib']['open']($file[1],'w'.$cfg['zlib']['mode']) : fopen($file[1],'w')) {
     if(ifset($head['Transfer-Encoding'],'chunked'))	// Chunked decodieren
      while(!feof($fp) and $var = fgets($fp,$cfg['sbuf'])) {				// Chunk-Lnge holen
       $len = (preg_match('/^([\da-f]+)\s*$/i',$var,$m)) ? hexdec($m[1]) : 0;		// Chunk-Lnge ermitteln
       while(!feof($fp) and $buf = ($len > $cfg['sbuf']) ? $cfg['sbuf'] : $len) {	// Buffer-Lnge nicht berschreiten
        $len -= $buf;					// Restlnge bestimmen
        $var = "";					// Buffer setzen
        while(strlen($var) < $buf)			// Soll-Daten WIRKLICH gelesen?
         $var .= fread($fp,$buf-strlen($var));		// Daten in Buffer lesen
        if($gz)						// Buffer schreiben
         $cfg['zlib']['write']($sp,$var);
        else
         fwrite($sp,$var);
        $a += strlen($var);				// Fortschritts-Anzeige berechnen
        $c = ($size) ? floor($a / max($a,$size) * max($cfg['wrap']-1,10)) - $b : 1;
        dbug(str_repeat(".",$c),0,10);			// Download-Anzeige
        $b += $c;
       }
       fgets($fp,$cfg['sbuf']);				// Pad-Daten berspringen
      }
     else						// Normaler Download
      while(!feof($fp) and $var = fread($fp,$cfg['sbuf'])) {
       if($gz)
        $cfg['zlib']['write']($sp,$var);
       else
        fwrite($sp,$var);
       $a += strlen($var);
       $c = ($size) ? floor($a / max($a,$size) * max($cfg['wrap']-1,10)) - $b : 1;
       dbug(str_repeat(".",$c),0,10);			// Download-Anzeige
       $b += $c;
     }
     if($gz)
      $cfg['zlib']['close']($sp);
     else
      fclose($sp);
     dbug("\n",0,8);					// Download-Anzeige abschlieen
     if(!$a) {						// Wurde wirklich was heruntergeladen?
      unlink($file[1]);
      return errmsg("Download Fehlgeschlagen: Keine Daten erhalten",__FUNCTION__);
     }
     else
      touch($file[1],(isset($head['Last-Modified'])) ? strtotime($head['Last-Modified']) : time());
    }
    else
     return errmsg("$file[1] kann nicht zum Schreiben geffnet werden",__FUNCTION__);
   }
   else
    return errmsg("Download abgebrochen: Keine Daten erhalten",__FUNCTION__);
  }
  else {						// Daten nur lesen
   if(preg_match('/^seek:([-+]?)(\d+)(?:-(\d+))?$/i',$mode,$var)) {	// Nur einen Teil lesen (Seek:-+<offset>-<size>)
    fseek($fp,intval($var[2]),(ifset($var[1])) ? SEEK_CUR : SEEK_SET);
    if(ifset($var[3]))
     $size = intval($var[3]);
   }
   while(!feof($fp) and $var = fread($fp,$cfg['sbuf'])) {
    $rp .= $var;
    dbug(".",6,10);					// Download-Anzeige
   }
   if(ifset($head['Transfer-Encoding'],'chunked'))	// Chunked decodieren
    for($vas=$rp, $rp=''; $vas; $vas=trim($vas)) {
     $rp .= substr($vas,$pos = strpos($vas,"\r\n") +2,$len = intval($vas,16));
     $vas = substr($vas,$pos + $len);
    }
  }
  $meta = stream_get_meta_data($fp);
  if($meta['timed_out'] )
   $err = "Timeout: Keine Reaktion nach $cfg[tout] Sekunden";
  elseif(!$meta['eof'] and !$sock)			// Sollte nie auftreten und macht bei ssl probleme
   $err = "Es wurden nicht alle Daten gelesen";
  if(ifset($err))
   dbug($meta,7,'Stream-Metadata');
  fclose($fp);
  dbug("\n",6,8);					// Download-Anzeige abschlieen
  dbug((($cfg['dbug'] & 1<<7) ? "$header$rp" : preg_replace('/\n.*$/s','',"$header\n$rp"))."\n\n",6,__FUNCTION__);	// Debug Response
  if($mode == 'array') {				// Ausgabe mit HTTP-Header
   $fp = $head;
   $fp[1] = $rp;
  }
  elseif(substr($mode,0,4) == 'save')
   $fp = $head;
  else							// Nur Netto-Daten zurckgeben
   $fp = $rp;
 }
 else
  $err = "$host:$port - Fehler $errnr: $errstr";
 if(ifset($err))
  errmsg($err,__FUNCTION__);
 return $fp;
}
function login($pass=0,$user=0,$uipw=0,$sid=0) {	// In der Fritz!Box einloggen
 global $cfg;
 if(is_array($pass)) {					// Login-Response berechnen
  dbug($pass[0],9);
  if(preg_match('!<Challenge>(\w+)</Challenge>!',$pass[0],$var) or preg_match('/security:status\/challenge.*?"?(\w+)"?,?\s*$/m',$pass[0],$var)) {
   dbug("Kodiere Kennwort aus Challenge: $var[1]",9);
   $hash = "response=$var[1]-".hash('md5',preg_replace('!.!',"\$0\x00","$var[1]-$pass[1]"));
   if($pass[2] and $GLOBALS['cfg']['fiwa'] == 100)
    $GLOBALS['cfg']['fiwa'] = (substr($pass[2],-4) == '.lua') ? '530' : '474';
   return $hash;
  }
  else
   return errmsg("Keine Challenge erhalten (".((substr($pass[2],-4) == '.lua') ? 'lua' : 'xml').")",__FUNCTION__);
 }
 elseif(is_bool($pass) and !$pass and !$sid) {		// Firmware-Version ermitteln
  dbug("Ermittle Boxinfos");
  if($cfg['fiwa'] == 100 and $data = request('GET','/jason_boxinfo.xml') and preg_match_all('/<([jeq]:(\w+))>([^<>]+)<\/\1>/m',$data,$array)) {	// BoxInfos holen
   dbug($array,4);
   $cfg['boxinfo'] = array_combine($array[2],$array[3]);
   $cfg['boxinfo']['Time'] = strtotime($cfg['http']['Date']);
   if(preg_match('/^\d+\.0*(\d+?)\.(\d+)(-\d+)?$/',$cfg['boxinfo']['Version'],$var))	// Firmware-Version sichern
    $cfg['fiwa'] = $var[1].$var[2];
  }
//  elseif(!$data and !$err)
//   $err = ($var = errmsg(0,'request')) ? ", $var" : ", keine Antwort";
  return (($fw = $cfg['fiwa']) != 100 and ($user and $fw < $user or $uipw and $fw > $uipw)) ? false : $fw;
 }
 else {							// Normaler Aufruf
  foreach(array('user','pass','uipw') as $var)		// User & Pass setzen
   if(!$$var)
    $$var = $GLOBALS['cfg'][$var];
  if($uipw) {						// Passwordanmeldung mit Fernwartung
   $pass = $uipw;
   $user = false;
  }
  $bug = (($user) ? " $user@" : " ")."$cfg[host] - Methode";
  $login = array("/login_sid.lua","/cgi-bin/webcm?getpage=../html/login_sid.xml","/login.lua");
  $page = explode('?',$login[1]);
  $preg = '/<SID>(\w+)<\/SID>/i';
  if($sid) {						// SID-Session besttigen lassen
   if($rp = request('GET',"$login[0]?sid=$sid") and preg_match($preg,$rp,$var) and $var[1] == $sid) {
    if($cfg['fiwa'] == 100)
     $cfg['fiwa'] = 530;
   }
   elseif($rp = request('GET',"$login[1]&sid=$sid") and preg_match($preg,$rp,$var) and $var[1] == $sid) {
    if($cfg['fiwa'] == 100)
     $cfg['fiwa'] = 474;
   }
   else
    return false;
  }
  else
   $sid = $rp = $err = false;
  call_user_func(__FUNCTION__,false);
  if(!$sid and ($cfg['fiwa'] == 100 or $cfg['fiwa'] > 529)) {	// Login lua ab 05.29
   dbug("Login$bug SID.lua (5.30)");
   if($rp = request('GET',$login[0]) and ($auth = call_user_func(__FUNCTION__,array($rp,$pass,$login[0]))) and $rp = request('POST',$login[0],(($user) ? "$auth&username=$user" : $auth)) and preg_match($preg,$rp,$var) ) {
    if($cfg['fiwa'] == 100)
     $cfg['fiwa'] = 530;
    if(hexdec($var[1]) != 0)
     $sid = $var[1];
    else
     $err = ", SID.lua ist ungltig";
   }
   elseif(!$rp and !$err)
    $err = ", keine Antwort";
  }
  if(!$sid and ($cfg['fiwa'] == 100 or $cfg['fiwa'] > 473)) {	// Login cgi ab 04.74 (Zwischen 4.74 bis 5.29)
   dbug("Login$bug SID.xml (4.74)");
   if(($rp = request('GET',$login[1]) and $auth = call_user_func(__FUNCTION__,array($rp,$pass,$page[0])) or $rp = request('GET',$login[2]) and $auth = call_user_func(__FUNCTION__,array($rp,$pass,$page[0])))
	and $rp = request('POST',$page[0],"$page[1]&login:command/$auth") and preg_match($preg,$rp,$var)) {
    if($cfg['fiwa'] == 100)
     $cfg['fiwa'] = 474;
    if(hexdec($var[1]) != 0)
     $sid = $var[1];
    elseif(!$err)
     $err = ", SID.xml ist ungltig";
   }
  }
  if(!$sid and ($cfg['fiwa'] == 100 or $cfg['fiwa'] < 490)) {	// Login classic bis 4.89 (z.B. FRITZ!Repeater N/G)
   dbug("Login$bug PlainText");
   if($var = request('POST',$page[0],"login:command/password=$pass") and !preg_match('/Anmeldung|logincheck\.lua/',$var))
    $sid = true;
   elseif(!$var and !$err)
    $err = ", keine Antwort";
  }
  elseif($sid and $var = xml2array($rp) and ifset($var['SessionInfo']))
   $cfg['sessioninfo'] = $var['SessionInfo'];
  return ($cfg['sid'] = $sid) ? $sid : errmsg("Anmeldung fehlgeschlagen$err".((!ifset($pass,'/^[ -~]+$/')) ?
	"\nHinweis: Das Login-Kennwort enthlt Sonderzeichen, die bei unterschiedlicher Zeichenkodierung Probleme bereiten knnen" : ""),__FUNCTION__);
 }
}
function logout($sid=0) {				// Aus der Fritz!Box ausloggen
 if(!$sid)
  $sid = $GLOBALS['cfg']['sid'];
 dbug("Logout ".$GLOBALS['cfg']['host']);
 if(is_string($sid) and $sid)				// Ausloggen
  request('GET',(($GLOBALS['cfg']['fiwa'] < 529) ? "/cgi-bin/webcm" : "/login_sid.lua"),"security:command/logout=1&logout=1&sid=$sid");
}
function supportcode($str = false) {			// Supportcode aufschlsseln
 dbug("Entschlssele Supportcode");
 return ($str or $str = request('GET','/cgi-bin/system_status')) ? ((preg_match('!
	^\s*(?:(?:<[^>]+>\s*)*|System Status[^-]*-*[\s\r\n]*)?
	(([^<>]+?)-
	([AB]|Kabel|Cable|Ohne)-
	([01]\d|2[0-3])([0-2]\d|3[01])(0\d|1[01])-
	(\d\d)(\d\d)([0-2]\d|3[01])-
	([0-7]{6})-([0-7]{6})-
	(1[49]|21|78|8[35])(67|79)(\d\d)
	(?:-(\d{2,3})(\d\d)(\d\d)-(\d+))?
	(?:-((?=[^-]*[a-z])\w+))?
	(?:-([a-z]+))?
	|([^<>]+?)\W(\w+)\W(\d\d)(\d\d)(\d\d)\W(\d\d)(\d\d)(\d\d)(?:\W(\d{6})\W(\d{6}))?
	(?:\W(\d\d)(\d\d)(\d\d))?
	(?:\W(\d{2,3})(\d\d)(\d\d)\W(\d+))?
	(?:\W(\w+))?
	(?:\W(\w+))?)
	!ix',$str,$a))
  ? dbug($a,4).$a[1].((ifset($a[21]) and array_splice($a,2,19)) ? " (Ungltig)".dbug($a,4) : "")."\n\n".textTable("Modell|$a[2]"
	.(ifset($a[15]) ? "\nFirmware|$a[15].$a[16].$a[17]\nVersion|$a[18]" : "")
	.(ifset($a[20]) ? "\nSprache|$a[20]" : "")
	.(ifset($a[19]) ? "\nMarke|$a[19]" : "")
	."\nAnnex|$a[3]"
	."\n|\nLaufzeit|".preg_replace(array('/\b0*(\d+)(\D+)/','/(\b1\D+?)\D(?=,|$)/','/\b0+\D+/','/^\s+|,\s*$/','/^\s*$/'),array(' $1 $2','$1','','',0),"$a[7]Jahre,$a[6]Monate,$a[5]Tage,$a[4]Stunden,")
	."\nNeustarts|".($a[8] * 32 + $a[9])
	.($a[10] ? "\n|\nCRC32 (Bootloader)|".strtoupper(str_pad(dechex((intval($a[10],8) >> 2) ^ 65535).str_pad(substr(dechex(intval($a[11],8) ^ 65535),-4),4,0,STR_PAD_LEFT),8,0,STR_PAD_LEFT))
		. " (".str_pad(decbin(intval(substr($a[10],-1).substr($a[11],0,1),8) >> 1 & 15),4,0,STR_PAD_LEFT).")" : "")
	.($a[12] ? "\n|\ndebug.cfg|".(($a[12] % 64 == 14) ? "Nicht v" : "V")."erfgbar"
	."\nFirmware-Attribut|".(($a[12] < 64) ? "Gendert" : "Unverndert")
	."\n|\nOEM|".(($a[13] == 67) ? "Custom" : "Original")
	."\nRunClock|$a[14]" : "")."\n")
  :	errmsg(($var = ifset($str,'/<title>(.*?)<\/title>/i')) ? "Fehler: $var[1]" : "Unbekannt: $str",__FUNCTION__)) : errmsg('request',__FUNCTION__);
}
function boxinfo($data=false) {				// jason_boxinfo.xml / juis_boxinfo.xml auslesen und auswerten
 global $cfg;
 if(!$data and $data = request('GET','/jason_boxinfo.xml')) {
  $date = $cfg['http']['Date'];
  $data .= request('GET','/juis_boxinfo.xml');
 }
 dbug($cfg['http'],6);
 dbug($data,6);
 if(preg_match_all('/<([jeq]:(\w+))>([^<>]+)<\/\1>/m',$data,$array)) {
  dbug($array,4);
  $jason = array(
	'Name'		=> 'Modell',
	'HW'		=> 'Hardware-Version',
	'Version'	=> 'Firmware-Version',
	'Revision'	=> 'Firmware-Revision',
	'OEM'		=> 'Marke',
	'Annex'		=> 'Annex (Festnetz)',
	'Lab'		=> 'Labor',
	'Country'	=> 'Land-Vorwahl',
	'Major'		=> 'Hauptversion',
	'Minor'		=> 'Nebenversion',
	'Patch'		=> 'Unterversion',
	'Buildnumber'	=> 'Firmware-Revision',
	'Firmware_attrib' => 'Firmware-Attribut',
	'Serial'	=> array('MAC-Adresse (LAN)',array('/\w\w(?!$)/','$0:')),
	'Buildtype'	=> array('Firmware-Typ',array(
		array(1001 => 'Frisch aus der Entwicklung', 1 => 'Normal'))),
	'UpdateConfig'	=> array('Aktualisierung',array(
		array("-/-","Benachrichtigen","Benachrichtigen & Sicherheitsaktualisierungen","Automatische Aktualisierungen"))),
	'Lang'		=> array('Sprache',array(
		array('de' => "Deutsch", 'en' => "English", 'es' => "Espaol", 'fr' => "Franais", 'it' => "Italiano", 'pl' => "Polski"))),
	'Flag'		=> array('Flags',array(
		array(	'crashreport' => "Absturzbericht", 'avm_acs' => "TR-069 (AVM)", 'prov_acs' => "TR-069 (Provider)",
			'myfritz_letsencrypt' => "HTTPS mit LetsEncrypt", 'botnet_detection' => "Viren Erkennung",
			'mesh_master_no_trusted' => "Einsame Mesh-Zentrale", 'mesh_repeater_no_trusted' => "Einsamer Mesh-Teilnehmer",
			'mesh_master' => "Mesh mit Teilnehmern", 'mesh_repeater' => "Mesh-Teilnehmer", 'nomini' => "Kein FRITZ!Mini"))),
  );
  $boxinfo = array();
  foreach($array[2] as $key => $var)
   $boxinfo[$var][] = $array[3][$key];
  $array = array();
  foreach($boxinfo as $key => $var) {
   $var = array_unique($var);
   if(isset($jason[$key]))
    if(is_array($jason[$key])) {
     if(ifset($jason[$key][1]))
      $var = (count($jason[$key][1]) == 2) ? preg_replace($jason[$key][1][0],$jason[$key][1][1],$var)
	: str_replace(array_keys($jason[$key][1][0]),array_values($jason[$key][1][0]),$var);
     $title = $jason[$key][0];
    }
    else
     $title = $jason[$key];
   else
    $title = $key;
   $array[$title] = "$title|".implode(", ",$var);
  }
  if($date)
   $array['Boxtime'] = 'Aktuelle Uhrzeit|'.date('d.m.Y H:i:s',strtotime($date));
  return textTable(implode("\n",$array));
 }
 else
  return '';
}
function upnprequest($page,$ns,$rq,$exp=false) {	// UPnP Request durchfhren
 global $cfg;
 dbug("Setzte UPnP request ab: $page - $rq",9);
 if($rp = request(array(
	'method' => 'POST-array',
	'page' => $page,
	'body' => utf8("<?xml version=\"1.0\" encoding=\"utf-8\"?>\n"
	."<s:Envelope xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\" s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">\n"
	."<s:Body><u:$rq xmlns:u=$ns /></s:Body>\n</s:Envelope>",1),
	'head' => array_merge($GLOBALS['cfg']['head'],array('content-type' => 'text/xml; charset="utf-8"', 'soapaction' =>  "\"$ns#$rq\"")),
	'port' => $GLOBALS['cfg']['upnp']))) {
  if($cfg['fiwa'] != 100 and $var = ifset($rp['SERVER'],'/0*([1-9])\.(\d{2})\s*$/'))	// Firmware-Version auslesen
   $cfg['fiwa'] = intval($var[1].$var[2]);
  if($exp and is_string($exp))				// Nur einen Wert extrahieren
   return (preg_match("!<$exp>(.*?)</$exp>!",$rp[1],$var)) ? $var[1] : errmsg('Kein Erwartetes Ergebnis erhalten',__FUNCTION__);
  elseif(is_array($exp) and preg_match_all('!<(\w+)>(.+?)</\1>!',$rp[1],$array)) {	// Alle Werte in ein Array packen
   dbug($array,4,__FUNCTION__);
   foreach($array[1] as $key => $var)			// Ergebnisse zusammenstellen
    $exp[$var] = $array[2][$key];
   return $exp;
  }
  else							// Response RAW zurckgeben
   return $rp;
 }
 else							// Fehler aufgetreten
  return errmsg('request',__FUNCTION__);
}
function getupnppath($urn) {				// Helper fr UPnP-Requests
 dbug("Ermittle UPnP Pfad: $urn",9);
 if($rp = request(array('method' => 'GET', 'page' => '/igddesc.xml', 'port' => $GLOBALS['cfg']['upnp']))
	and preg_match("!<(service)>.*?<(serviceType)>(urn:[^<>]*".$urn."[^<>]*)</\\2>.*?<(controlURL)>(/[^<>]+)</\\4>.*?</\\1>!s",$rp,$var)) {
  dbug($var,4);
  $rp = array($var[3],$var[5]);
 }
 else
  $rp = errmsg('request',__FUNCTION__);
 return $rp;
}
function getexternalip() {				// Externe IPv4-Adresse ber UPnP ermitteln
 global $cfg;
 dbug("Ermittle IP-Adresse ber UPnP fr $cfg[fiwa]");
 $ip = array();
 if($val = getupnppath('WANIPConnection')) {
  if($var = upnprequest($val[1],$val[0],'GetExternalIPAddress','NewExternalIPAddress'))
    $ip['IPv4'] = $var;
  if($cfg['http']['HTTP_Code'] == 200 and ($cfg['fiwa'] >= 550 or $cfg['fiwa'] == 100)) {	// IPv6 und DNS bei neueren Boxen
   $k = "X_AVM_DE_Get";
   if($var = upnprequest($val[1],$val[0],$k.'ExternalIPv6Address','NewExternalIPv6Address'))
    $ip['IPv6'] = $var;
   if($var = upnprequest($val[1],$val[0],$k.'IPv6Prefix',array()) and ifset($var['NewIPv6Prefix']))
    $ip['IPv6-Prefix'] = "$var[NewIPv6Prefix]/$var[NewPrefixLength]";
   if($var = upnprequest($val[1],$val[0],$k.'DNSServer',array()) and $var = preg_array('/New(IPv4)?DNSServer/',$var,3))
    $ip['DNSv4'] = implode(", ",$var);
   if($var = upnprequest($val[1],$val[0],$k.'IPv6DNSServer',array()) and $var = preg_array('/NewIPv6DNSServer/',$var,3))
    $ip['DNSv6'] = implode(", ",$var);
  }
  if($ip)
   return $ip;
 }
 return errmsg('request',__FUNCTION__);
}
function forcetermination() {				// Internetverbindungen ber UPnP neu aufbauen
 dbug("WAN Neueinwahl ber UPnP");
 return ($val = getupnppath('WANIPConnection') and $var = upnprequest($val[1],$val[0],'ForceTermination'))
  ? $var : errmsg('request',__FUNCTION__);
}
function saverpdata($file,$data,$name) {		// HTTP-Downloads in Datei speichern
 global $cfg;
 if(file_exists($file) and is_dir($file)) {
  $dir = str_replace('\\','/',realpath($file))."/";
  $file = false;
 }
 else {
  $dir = "./";
  if(!file_exists($file))
   $file = basename($file);
 }
 $cfg['file'] = $file = preg_replace($cfg['fesc'],$cfg['frep'],(!$file and isset($data['Content-Disposition']) and preg_match('/filename="(.*)"/',$data['Content-Disposition'],$var)) ? $var[1] : (($file) ? $file : $name));
 dbug("Speichere Daten in $dir$file",9);
 return file_contents($dir.$file,$data[1]);
}
function supportdata($file=false,$tm=false,$sid=0) {	// Supportdaten anfordern
 dbug("Hole Supportdaten");
 if(!$sid)
  $sid = $GLOBALS['cfg']['sid'];
 $array = array();
 if(!is_bool($sid))
  $array['sid'] = $sid;
 $mode = 'SupportData';
 if($tm !== false) {
  if($GLOBALS['cfg']['fiwa'] < 680 and $GLOBALS['cfg']['fiwa'] >= 650) {	// Telemetrie ab OS6.5 aktivieren
   dbug("Telemetrie wird ".(($tm) ? '' : 'de') ."aktiviert");
   request('POST','/data.lua',"xhr=1&sid=$sid&lang=de&no_sidrenew=".(($tm) ? '&supportdata_enhanced=on' : '')."&support_plus=&oldpage=/support.lua");
  }
  elseif($GLOBALS['cfg']['fiwa'] >= 680 and !$tm) {
   dbug("Aktiviere Telemetrie");
   $mode .= 'Enhanced';
  }
 }
 $array[$mode] = '';
 $data = ($file) ? (bool)request("POST-save:$file",'/cgi-bin/firmwarecfg',$array) : request("POST-array",'/cgi-bin/firmwarecfg',$array);
 return ($data) ? $data : errmsg('request',__FUNCTION__);
}
function supportdataextrakt($data,$mode=0,$file='') {	// Supportdaten extrahieren
 global $cfg;
 $info = array();
 if(is_array($mode) and $mode[0] == 'sec') {
  $preg = '/^#{5} +BEGIN +SECTION +(\S+) *([^\r\n]+\s*)?(.*?)^#{5} +END +SECTION +\1\s+/sim';
  if(preg_match_all($preg,$data,$array)) {
   dbug($array,4,'SupportDataExtrakt-#');
   foreach($array[1] as $key => $var)
    if(trim($array[3][$key]))
     $info = array_merge($info,(($val = trim(preg_replace($preg,'',$array[3][$key]))) ? array($var => $array[2][$key].$val) : array()),call_user_func(__FUNCTION__,$array[3][$key],array('sec')));
  }
 }
 else {
  dbug("Zerlege Supportdaten");
  $mstr = $mlen = array(0,0);
  $val = $list = array();
  if(substr($data,0,5) == '#####')
   $array = call_user_func(__FUNCTION__,$data,array('sec'));
  elseif(preg_match('/^Support Data\n-+\n/',$data)
	and preg_match_all('/([()\/\w@:. -]+)\n-+\n([\s\S]+?)(?=End Of Support Data\s*$|\n\n[()\/\w@:. -]+\n-+\n|$)/i',$data,$array))
   $array = array_combine($array[1],$array[2]);
  if($array) {
   if($mode and $file) {				// Tar-Archiv Initialisieren
    $fp = ($mode == 1) ? fopen($file,'w') : $cfg['zlib']['open']($file,'w'.$cfg['zlib']['mode']);
    $date = (preg_match('/^#{5} +TITLE +Datum +(.+)/mi',$data,$var)) ? strtotime($var[1]) : 0;
   }
   foreach($array as $key => $var) {			// Maximale Lngen ermitteln
    $key = preg_replace($cfg['fesc'],$cfg['frep'],$key);
    $list[] = array($key,number_format(strlen($var),0,",","."));
    if($mode == 2 and $fp)
     $cfg['zlib']['write']($fp,data2tar("$key.txt",$var,$date));
    elseif($mode == 1 and $fp)
     fwrite($fp,data2tar("$key.txt",$var,$date));
    elseif($file)
     file_contents("$key.txt",$var);
   }
   if($mode and $fp) {					// Tar-Archiv abschlieen
    $data = str_repeat(chr(0),512);
    if($mode == 2) {
     $cfg['zlib']['write']($fp,$data);
     $cfg['zlib']['close']($fp);
    }
    else {
     fwrite($fp,$data);
     fclose($fp);
    }
   }
   for($a=0; $a < ceil(count($list)/2); $a++)
    foreach(array($a,$a+ceil(count($list)/2)) as $b)
     if(isset($list[$b]))
      $val[$a] = ((isset($val[$a])) ? $val[$a]."||" : "").$list[$b][0]."| ".$list[$b][1]." Bytes";
    $info = textTable(implode("\n",$val));
  }
  else
   dbug("Das zerlegen der Supportdaten ist fehlgeschlagen");
 }
 return $info;
}
function dial($dial,$fon=false,$sid=0) {		// Wahlhilfe
 if(!$sid)
  $sid = $GLOBALS['cfg']['sid'];
 $sid = (!is_bool($sid)) ? "&sid=$sid" : '';
 $dial = preg_replace('/[^\d*#]+/','',$dial);
 $rdial = urlencode($dial);
 $fon = ($var = ifset($fon,'/^((?P<i>[1-4]|5[0-8]|6[0-5])|(?P<s>fon[1-4]?|isdn[0-8]?|dect[0-6]?))$/i'))
	? ((ifset($var['i'])) ? intval($var['i']) : (($var = ifset($var['s'],'/(\D+)(\d?)/')) ? ((ifset($var[1],'/fon/i')) ? ((ifset($var[2])) ? intval($var[2]) : 1)
	: ((ifset($var[0],'/isdn|dect0?$/i')) ? 50 : 59) + intval($var[2])) : 0)) : false;
 if($GLOBALS['cfg']['fiwa'] >= 530) {
  if($fon) {
   dbug("Dial: ndere Anruf-Telefon auf $fon");
   request('POST',"/fon_num/dial_fonbook.lua","clicktodial=on&port=$fon&btn_apply=$sid");
  }
  dbug("Dial: ".(($dial) ? "Whle $dial" : "Auflegen"));
  request((($GLOBALS['cfg']['fiwa'] >= 708) ? 'POST' : 'GET'),"/fon_num/fonbook_list.lua",(($dial) ? "dial=$rdial" : "hangup=&orig_port=$fon").$sid);
 }
 else {
  request('POST',"/cgi-bin/webcm","telcfg:settings/UseClickToDial=1"
	.(($dial) ? "&telcfg:command/Dial=$rdial" : "&telcfg:command/Hangup=")
	.(($fon) ? "&telcfg:settings/DialPort=$fon" : "").$sid);
  dbug("Dial: ".(($dial) ? "Whle $dial".(($fon) ? " fr Telefon $fon" : "") : "Auflegen"));
 }
 return ($dial) ? $dial : "-";
}
function cfgexport($mode,$pass=false,$sid=0) {		// Konfiguration Exportieren (NUR Exportieren)
 dbug("Exportiere Konfig");
 $body = array('ImportExportPassword' => $pass, 'ConfigExport' => false);
 $path = '/cgi-bin/firmwarecfg';
 if(!$sid) {
  $sid = $GLOBALS['cfg']['sid'];
  if(!is_bool($sid))
   $body = array_merge(array('sid' => $sid),$body);
 }
 return ($mode)	? (($mode === 'array')	? request('POST-array',$path,$body)
					: request('POST-save:'.(($mode === true) ? './' : $mode),$path,$body))
		: request('POST',$path,$body);
}
function cfgcalcsum($data) {				// Checksumme fr die Konfiguration berechnen
 if(preg_match_all('/^(\w+)=(\S+)\s*$|^(\*{4}) (?:CRYPTED)?(CFG|BIN)FILE:(\S+)\s*(.*?)\3 END OF FILE \3\s*$/sm',$data,$array)) {
  dbug("Berechne Konfig-Checksumme",9);
  dbug($array,4,'CfgCalcSum-#');
  foreach($array[4] as $key => $var)
   $array[0][$key] = ($array[1][$key]) ? $array[1][$key].$array[2][$key]."\0"
	: $array[5][$key]."\0".(($var == 'BIN') ? pack('H*',preg_replace('/[^\da-f]+/i','',$array[6][$key])) : preg_replace('/\r|\\\\(?=\\\\)/','',substr($array[6][$key],0,-1)));
  dbug($array[0],4,'8,CfgCalcSumArray-#');
  dbug(join('',$array[0]),4,'8,CfgCalcSumData');
 }
 return ($array and preg_match('/(?<=^\*{4} END OF EXPORT )[A-Z\d]{8}(?= \*{4}\s*$)/m',$data,$key,PREG_OFFSET_CAPTURE))
	? array($key[0][0],$var = strtoupper(hash('crc32b',join('',$array[0]))),substr_replace($data,$var,$key[0][1],8)) : errmsg('Keine Konfig-Datei',__FUNCTION__);
}
function cfgimport($file,$pass='',$mode=false,$sid=0) {	// Konfiguration importieren (Wird vermutlich bald berarbeitet)
 global $cfg;
 if($file and (	is_file($file) and preg_match($cfg['ptar'],$file) and ($data = cfgmake(tar2array($file)))
		or is_file($file) and ($data = file_contents($file))
		or is_dir($file) and ($data = cfgmake($file))
	) or !$file and $data = $mode and substr($mode,0,4) == '****') {
  if($mode and $var = cfgcalcsum($data))
   $data = $var[2];
  dbug("Upload Konfig-File an ".$cfg['host']);
  $body = array('ImportExportPassword' => $pass,
	'ConfigImportFile' => array('filename' => $file, 'Content-Type' => 'application/octet-stream', '' => $data),
	'apply' => false);
  if(!$sid) {
   $sid = $cfg['sid'];
   if(!is_bool($sid))
    $body = array_merge(array('sid' => $sid),$body);
  }
  return request('POST','/cgi-bin/firmwarecfg',$body);
 }
 else
  return errmsg('Import-Datei/Ordner nicht gefunden',__FUNCTION__);
}
function cfginfo($data,$mode=0,$file='',$text=false) {	// Konfiguration in Einzeldateien sichern (mode: 0->show, 1->Dir, 2->Tar, 3->tgz)
 global $cfg;
 if(preg_match_all('/^(?:
	\*{4}\s(.*?)\sCONFIGURATION\sEXPORT|(\w+=\S+))\s*$		# 1 Fritzbox-Modell, 2 Variablen
	|^\*{4}\s(?:CRYPTED)?(CFG|BIN)FILE:(\S+)\s*?\r?\n(.*?)\r?\n	# 3 Typ, 4 File, 5 Data
	^\*{4}\sEND\sOF\sFILE\s\*{4}\s*?$/msx',$data,$array) and $array[1][0] and $crc = cfgcalcsum($data)) {
  $list = $val = $vars = array();
  $mstr = $mlen = array(0,0);
  dbug($array,4,'CfgInfo-#');
  $fp = ($mode >= 2 and $file) ? (($mode == 2) ? fopen($file,'w') : $cfg['zlib']['open']($file,'w'.$cfg['zlib']['mode'])) : false;	// tar/tgz initialisieren
  foreach($array[3] as $key => $var)			// Config-Dateien aufteilen
   if($var) {
    if($array[3][$key] == 'CFG') {
     $bin = preg_replace('/\r|\\\\(?=\\\\)/','',$array[5][$key]);
     if(!isset($vars['Date']) and preg_match('/^\s\*\s([\s:\w]+)$/m',$bin,$var))
      $vars['Date'] = strtotime($var[1]);
    }
    else
     $bin = pack('H*',preg_replace('/[^\da-f]+/i',"",$array[5][$key]));
    $list[] = array($array[3][$key],$array[4][$key],number_format(strlen($bin),0,",","."));
    if($fp and $mode == 3)
     $cfg['zlib']['write']($fp,data2tar($array[4][$key],$bin,$vars['Date']));
    elseif($fp and $mode >= 2)
     fwrite($fp,data2tar($array[4][$key],$bin,$vars['Date']));
    elseif($mode >= 1)
     file_contents($array[4][$key],$bin);
    unset($array[2][$key]);
   }
   elseif($var = ifset($array[2][$key],'/^(\w+)=(.*)$/'))
    $vars[$var[1]] = $var[2];
   else
    unset($array[2][$key]);
  $name = "index.txt";				// Konfig-Schablone sichern
  $data = preg_replace('/^(\*{4}\s(?:CRYPTED)?(?:CFG|BIN)FILE:\S+\s*?\r?\n).*?\r?\n(^\*{4}\sEND\sOF\sFILE\s\*{4}\s*?)$/msx','$1$2',$data);
  $list[] = array("TXT",$name,number_format(strlen($data),0,",","."));
  if($fp and $mode == 3)
   $cfg['zlib']['write']($fp,data2tar($name,$data,$vars['Date']));
  elseif($fp and $mode >= 2)
   fwrite($fp,data2tar($name,$data,$vars['Date']));
  elseif($mode >= 1)
   file_contents($name,$data);
  if($text) {						// Zugangsdaten sichern
   $name = "zugangsdaten.txt";
   $list[] = array("TXT",$name,number_format(strlen($text),0,",","."));
   if($fp and $mode == 3)
    $cfg['zlib']['write']($fp,data2tar($name,$text,$vars['Date']));
   elseif($fp and $mode >= 2)
    fwrite($fp,data2tar($name,$text,$vars['Date']));
   elseif($mode >= 1)
    file_contents($name,$text);
  }
  if($fp) {						// tar/tgz finalisieren
   $data = str_repeat(chr(0),512);
   if($mode == 3) {
    $cfg['zlib']['write']($fp,$data);
    $cfg['zlib']['close']($fp);
   }
   elseif($mode == 2) {
    fwrite($fp,$data);
    fclose($fp);
   }
  }
  for($a=0; $a < ceil(count($list)/2); $a++)
   foreach(array($a,$a+ceil(count($list)/2)) as $b)
    if(isset($list[$b]))
     $val[$a] = ((isset($val[$a])) ? $val[$a]."||" : "").$list[$b][0].":|".$list[$b][1]."| ".$list[$b][2]." Bytes";
  $list = "\nModell:   {$array[1][0]}\n";
  if(ifset($vars['Date']))
   $list .= "Datum:    ".date('d.m.Y H:i:s',$vars['Date'])."\n";
  if(ifset($vars['FirmwareVersion']))
   $list .= "Firmware: $vars[FirmwareVersion]\n";
  return $list."Checksum: $crc[0] (".(($crc[0] == $crc[1]) ? "OK" : "Inkorrekt! - Korrekt: $crc[1]").")\n\n"
	.textTable(implode("\n",$val))."\n".((!$mode and $text) ? $text : '');
 }
 else
  return errmsg('Keine Konfig-Datei',__FUNCTION__);
}
function cfgmake($dir,$mode='',$file=false) {		// Konfiguration wieder zusammensetzen
 if(is_array($dir) and isset($dir[0]) and !$mode and !$file) {		// Helper fr Preg_Replace CfgMake
  if(is_array($GLOBALS['val']) and isset($GLOBALS['val'][$dir[3]]))
   $mode = $GLOBALS['val'][$dir[3]];
  elseif(file_exists("$GLOBALS[val]/$dir[3]"))
   $mode = file_contents("$GLOBALS[val]/$dir[3]");
  return $dir[1].(($dir[2] == 'BIN') ? wordwrap(strtoupper(implode('',unpack('H*',$mode))),80,$dir[4],1) : str_replace("\\","\\\\",$mode)).$dir[4].$dir[5];
 }
 elseif($dir and (is_array($dir) and $data = preg_array('/^(index|pattern)\.txt$/',$dir,1) or ($var = glob("$dir/{index,pattern}.txt",GLOB_BRACE))
	and ($data = file_contents($var[0]))) and preg_match('/^\*{4}\s+\w+.*CONFIGURATION EXPORT/',$data,$array)) {
  dbug("Setze Konfig-Daten aus ".((is_array($dir)) ? "TAR" : $dir)." zusammen");
  $GLOBALS['val'] = $dir;
  $data = preg_replace_callback('/(^\*{4}\s(?:CRYPTED)?(CFG|BIN)FILE:(\S+)\s*?(\r?\n))(^\*{4}\sEND\sOF\sFILE\s\*{4}\s*?$)/m',__FUNCTION__,$data);
  if(preg_match('/^\*{4}\s(.*?)\sCONFIGURATION\sEXPORT.*?FirmwareVersion=(\S+)/s',$data,$array) and $crc = cfgcalcsum($data)) {
   $val = "Modell:   $array[1]\nFirmware: $array[2]\nChecksum: $crc[0] ";
   $val .= (($crc[0] == $crc[1]) ? "(OK)" : "Inkorrekt! - Korrekt: $crc[1]")."\n";
   $data = ($mode) ? $crc[2] : $data;
   if($file)
    file_contents($file,$data);
   return ($file) ? $val : $data;
  }
 }
 return errmsg("Keine Konfig-Daten - Konfig-Schablone nicht gefunden",__FUNCTION__);
}
function cfgdecrypt($data=false,$pass=false) {		// Konfig-Datei entschlsseln
 global $cfg;
 if(is_array($pass) and substr($copy = $data,0,4) == '$$$$') {	// Fritz Decrypt
  for($base = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ123456', $bits = log(strlen($base),2), $a=$b=$c=0, $d=""; $a < strlen($data); )	// Unbase32
   if(($e = strpos($base,$data{$a++})) !== false)
    for($c = ($c << $bits) + $e, $b += $bits; $b >= 8; $c %= 1 << $b)
     $d .= chr($c >> ($b -= 8));
  $a = substr($d,0,16);						// AES iv
  $b = substr($d,16).str_pad("\0",16 - strlen($d) % 16);	// AES data.pad
  foreach($cfg['aes'] as $aes => $var) {			// Alle AES-Bibliotheken durchprobieren
   for($c=count($pass)-1; $c >= 0; $c--) {			// Alle Kennwter durchprobieren
    if($pass[$c] == 1)						// Letzter Schlssel im Bund
     $data = false;
    elseif($aes == 'openssl')					// Extension: OpenSSL
     $data = openssl_decrypt($b, "AES-256-CBC", $pass[$c], OPENSSL_RAW_DATA | OPENSSL_ZERO_PADDING, $a);
    elseif($aes == 'mcrypt')					// Extension: MCrypt
     $data = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $pass[$c], $b, MCRYPT_MODE_CBC, $a);
    elseif($aes == 'aes5')					// Script: Aes.php
     $data = eval('$d = new PhpAes\Aes($pass[$c], "CBC", $a); return $d->decrypt($b);');
    elseif($aes == 'aes4') {					// Script: AES_4.class.php
     $d = new Aes($pass[$c], "CBC", $a);
     $data = $d->decrypt($b);
    }
    if(substr(hash('md5',substr($data,4,strlen($data) - 20),true),0,4) == substr($data,0,4)) {					// Checksum
     $data = substr($data,8,hexdec(bin2hex(substr($data,4,4))));								// Extract
     return (end($pass) == 1) ? preg_replace(array('/\0?$/','/[\\"]/'),array('','\\\\$0'),$data) : $data;
    }
   }
  }
  dbug("Fail: $copy",4);
  return false;
 }
 elseif(preg_match('/^\*{4} .*? CONFIGURATION EXPORT$/mi',$data) and $pass) {	// Konfig einlesen und zur entschlsselung vorbereiten
  dbug($data,4,'12,CfgDeCrypt-Crypted');
  if(preg_match('/^\s*(?:([A-Z](?:0[1-9]|[1-4]\d|5[0-3])[1-7]\.?\d{3}\.?\d{2}(?:\.?\d{3}){2})\W)?((?:[\dA-F]{2}([:-]|(?=\s*$))){6})\s*$/i',$pass,$var)) // Alternative zur Konfiguationen ohne Kennwort
   $pass = ((ifset($var[1])) ? str_replace('.','',$var[1]) : str_repeat('0',16))."\n".strtoupper(str_replace('-',':',$var[2]))."\n";	// Seriennummer und MacA-Adresse als Kennwort
  $pass = array(str_pad(hash('md5',$pass,true),32,"\0"));
  if(preg_match_all('/(Password\d*=)(\${4}\w+)/i',$data,$match,PREG_OFFSET_CAPTURE))
   for($a=count($match[0])-1; $a >= 0; $a--)
    if($key = call_user_func(__FUNCTION__,$match[2][$a][0],$pass) and strlen($key) == 32 and substr($key,0,16) == substr($key,16)) {	// Schlssel extraieren
     $pass[] = str_pad(substr($key,16),32,"\0");									// Schlssel merken
     $data = substr_replace($data,strtoupper(bin2hex(substr($key,16))),$match[2][$a][1],strlen($match[2][$a][0]));	// Schlssel in Plaintext
    }
  if(count($pass) > 1 and preg_match_all('/(\${4}\w+)(?="|$)|^(\*{4} BINFILE:.*\s*)([\dA-F\s]*?(?:24\s*){4}(?:[46][1-9A-F]|[57][0-9A]|3\d|\s*)+[\dA-F\s]*)(?=\s+\*{4})|^(\*{4} CRYPTEDBINFILE:.*\s*)([\dA-F\s]+)(?=\s+\*{4})/im',$data,$match,PREG_OFFSET_CAPTURE)) {
   $pass[] = 1;				// Schlsselring anschlieen
   for($a=count($match[0])-1; $a >= 0; $a--) {
    if($match[1][$a][0])
     $data = substr_replace($data,call_user_func(__FUNCTION__,$match[1][$a][0],$pass),$match[1][$a][1],strlen($match[1][$a][0]));
    else {
     if($match[4][$a]) {
      $match[2][$a] = $match[4][$a];
      $match[3][$a] = $match[5][$a];
     }
     $b = $match[2][$a][0];
     $c = pack("H*", preg_replace('/[^\w]+/','',$match[3][$a][0]));
     if(isset($match[4][$a][0]) and $match[4][$a][0] == $b) {	// CryptedBin
      foreach($cfg['aes'] as $aes => $var) {
       $d = $c.str_pad("\0",16 - strlen($c) % 16);
       if($aes == 'openssl')
        $d = openssl_decrypt($d, "AES-256-ECB", $pass[0], OPENSSL_RAW_DATA | OPENSSL_ZERO_PADDING);
       elseif($aes == 'mycrypt')
        $d = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $pass[0], $d, MCRYPT_MODE_ECB, substr($d,0,16));
       elseif($aes == 'aes5')
        $d = eval('$d = new PhpAes\Aes($pass[0], "ECB"); return $d->decrypt($d);');
       elseif($aes == 'aes4') {
        $f = new Aes($pass[0], "ECB");
        $d = $f->decrypt($d);
       }
       $f = -1;				// Workaround fr strrpos
       while($e = strpos($d,"AVM\0",$f + 1))
        $f = $e;
       if($aes and $f > 0) {		// $f = strrpos($d,"AVM\0")
        $c = substr($d,4,hexdec(bin2hex(substr($d,$f + 12,4))));
        $b = str_replace('CRYPTED','',$b);
        break;
       }
      }
     }
     elseif(preg_match_all('/\${4}\w+(?="|$)/',$c,$var,PREG_OFFSET_CAPTURE))
      for($d=count($var[0])-1; $d >= 0; $d--)
       $c = substr_replace($c,call_user_func(__FUNCTION__,$var[0][$d][0],$pass),$var[0][$d][1],strlen($var[0][$d][0]));
      $data = substr_replace($data,$b.preg_replace('/.{80}/',"\$0\n",strtoupper(bin2hex($c))),$match[0][$a][1],strlen($match[0][$a][0]));
    }
   }
   return $data;
  }
  else
   return errmsg('Falsches Konfig-Kennwort',__FUNCTION__);
 }
 elseif(!$data) {						// AES init
  if(!ifset($cfg['php'][5])) {
   ob_start();
   phpinfo();
   if(preg_match('/^Configuration File.*?=>\s*(.*)$/m',ob_get_contents(),$array))
    $cfg['php'][5] = $array[1];
   ob_end_clean();
  }
  $ext = array();
  foreach(array(
	'openssl' =>	array('ext' => 1, 'min' => 5.4, 'func'	=> 'openssl_decrypt',	'preg' => '/\b(php_)?openssl\.(so|dll)/i'),
	'mcrypt' =>	array('ext' => 1, 		'func'	=> 'mcrypt_decrypt',	'preg' => '/\b(php_)?mcrypt\.(so|dll)/i'),
	'mhash' =>	array('ext' => 1, 'max' => 5.1, 'func'	=> 'mhash',		'preg' => '/\b(php_)?mhash\.(so|dll)/i'),
	'aes5' =>	array('php' => 1, 'min' => 5.3, 'obj'	=> 'PhpAes\Aes',	'preg' => '/\baes\.php/i'),
	'aes4' =>	array('php' => 1, 'max' => 7.1, 'obj'	=> 'Aes',		'preg' => '/\baes_?4.*?\.php/i'),
	'sha256' =>	array('php' => 1, 'max' => 1,	'func'	=> 'sha256',		'preg' => '/\bsha.?256\.php/i'),
	'sha512' =>	array('php' => 1, 'max' => 1,	'func'	=> 'sha512',		'preg' => '/\bsha.?512\.php/i')) as $key => $var)
   if(!isset($ext[$key]) and (!$pass or strstr($pass,$key))
	and ($pass and strstr($pass,$key) or (!isset($var['min']) or $cfg['php'][3] >= $var['min']) and (!isset($var['max']) or $cfg['php'][3] < $var['max']))
	and ((isset($var['ext']) and ((isset($var['func']) and $val = function_exists($var['func']) or isset($var['obj']) and $val = class_exists($var['obj']))
	or @ini_get('enable_dl') and (defined('PHP_BINARY') and $val = listDir($var['preg'],dirname(PHP_BINARY),1)
	or $cfg['php'][5] and $val = listDir($var['preg'],dirname($cfg['php'][5]),1) or $val = listDir($var['preg'],realpath(@ini_get('extension_dir')),1))))
	or (isset($var['php']) and ((isset($var['func']) and $val = function_exists($var['func']) or isset($var['obj']) and $val = class_exists($var['obj']))
	or $val = listDir($var['preg'],$cfg['fbtl'],1)))) and (is_bool($val) or $val = ifset($val,$var['preg']))) {
    if(is_array($val)) {
     $val = array_values($val);
     if(isset($var['ext'])) {
      if(realpath(@ini_get('extension_dir')) != dirname($val[0]))
       @ini_set('extension_dir',dirname($val[0]));
      @dl(basename($val[0]));
     }
     if(isset($var['php']))
      include $val[0];
    }
    if(isset($var['func']) and function_exists($var['func']) or isset($var['obj']) and class_exists($var['obj'])) {	// AES einrichten
     $ext[$key] = (is_array($val)) ? ((count($val) > 1) ? $val : $val[0]) : $val;
     dbug($key." nachgeladen",9);
    }
   }
  if($pass == 'openssl' and $ext['openssl'] = (defined('OPENSSL_VERSION_TEXT')) ? OPENSSL_VERSION_TEXT : ((defined('OPENSSL_NO_PADDING')) ? "OpenSSL 0.9x" : false)) {
   if(substr($cfg['head']['User-Agent'],-1) == ' ')
    $cfg['head']['User-Agent'] .= $ext['openssl'];
   $cfg['osn'] = ($var = ifset($ext['openssl'],'/[\d.]+/')) ? (float)$var[0] : false;
  }
  $cfg['aes'] = array_merge($cfg['aes'],$ext);
  return $ext;
 }
 else
  return ($pass) ? errmsg('Keine Konfig-Datei',__FUNCTION__) : false;
}
function konfig2array($data) {				// FRITZ!Box-Konfig -> Array
 $config = array();
 if($data{0} == '*')
  dbug("Konvertiere Fritz!Konfig...");
 if($data{0} == '*' and preg_match_all('/^(?:\*{4}\s(.*?)\sCONFIGURATION\sEXPORT|(\w+)=(\S+))\s*$
	|^\*{4}\s(?:CRYPTED)?(CFG|BIN)FILE:(\S+)\s*?\r?\n(.*?)\r?\n^\*{4}\sEND\sOF\sFILE\s\*{4}\s*?$/msx',$data,$array)) {
  dbug($array,4,'Konfig2Array-#');			// Debugdaten Speichern
  foreach($array[4] as $key => $var)
   if(ifset($array[1][$key]))				// Routername
    $config['Name'] = $array[1][$key];
   elseif(ifset($array[2][$key]))			// Variablen
    $config[$array[2][$key]] = $array[3][$key];
   elseif(ifset($array[4][$key],'BIN'))			// BinData
    $config[$array[5][$key]] = pack('H*',preg_replace('/[^\da-f]+/i','',$array[6][$key]));
   elseif(ifset($array[4][$key],'CFG') and preg_match_all('/^(\w+)\s(\{\s*$.*?^\})\s*$/smx',
	str_replace(array("\r","\\\\"),array("","\\"),$array[6][$key]),$match))	// CfgData
    foreach($match[1] as $k => $v)
     $config/*[$array[5][$key]]*/[$v] = call_user_func(__FUNCTION__,$match[2][$k]);
  dbug($config,4,'Konfig2Array');			// Debugdaten Speichern
 }
 elseif($data{0} == '{' and preg_match_all('/\{\s*?$.*?^\}/msx',$data,$array)) {
  dbug($array,4,'Konfig2Array-Multi-#');		// Debugdaten Speichern
  if(count($array[0]) > 1)				// Ein oder Multi-Array
   foreach($array[0] as $var)				// Weitere Matches auf selber Ebene
    $config[] = call_user_func(__FUNCTION__,$var);
  elseif(preg_match_all('/^\s{8}(?:(\w+)\s(?:=\s(?:([^\s"]+)|(".*?(?<!\\\\)"(?:,\s*)?));|(\{\s*$.*?^\s{8}\}))\s*$)$/msx',$data,$match)) {
   dbug($match,4,'Konfig2Array-Sub-#');			// Debugdaten Speichern
   foreach($match[1] as $key => $var)			// Array durch arbeiten
    if(ifset($match[2][$key]))				// Einfache Werte
     $config[$var] = ($match[2][$key] == 'yes') ? true  : (($match[2][$key] == 'no') ? false : ((ifset($match[2][$key],'/^\d+(\.\d+)?$/')) ? (int)($match[2][$key]) : $match[2][$key]));
    elseif(ifset($match[3][$key]) and preg_match_all('/"(.*?)(?<!\\\\)"/',$match[3][$key],$val))	// String(s)
     $config[$var] = str_replace('\"','"',(count($val[1]) > 1) ? $val[1] : $val[1][0]);
    elseif(ifset($match[4][$key]))			// Verschachteltes Array
     $config[$var] = call_user_func(__FUNCTION__,preg_replace('/^\s{8}/m','',$match[4][$key]));
  }
 }
 else
  return errmsg('Keine Konfig-Datei',__FUNCTION__);
 return $config;
}
function showaccessdata($data) {			// Die Kronjuwelen aus Konfig-Daten heraussuchen
 if(is_array($data))
  return chr(intval($data[1],8));
 $text = '';
 $config = array();
 if($konfig = konfig2array($data)) {			// Konfig als Array umwandeln
  dbug("Stelle Zugangsdaten zusammen...");
  $access = array(
   'Mobile-Stick'		=> array(&$konfig['ar7cfg']['serialcfg'],'=number,provider,username,passwd'),
   'DSL'			=> array(&$konfig['ar7cfg']['targets'],'-name,>local>username,>local>passwd'),
   'IPv6'			=> array(&$konfig['ipv6']['sixxs'],'=ticserver,username,passwd,tunnelid'),
   'DynamicDNS'			=> array(&$konfig['ddns']['accounts'],'=domain,username,passwd'),
   'MyFRITZ!'			=> array(&$konfig['jasonii'],'=user_email,user_password,box_id,box_id_passphrase,dyn_dns_name'),
   'FRITZ!Box-Oberflche'	=> array(&$konfig['webui'],'=username,password'),
   'Fernwartung'		=> array(&$konfig['websrv']['users'],'=username,passwd'),
   'GUI-Unterordner'		=> array(&$konfig['websrv.subfolder']['=name,passwd']),
   'TR-064'			=> array(&$konfig['TR_064'],'=username,password'),
   'TR-069-Fernkonfiguration'	=> array(&$konfig['tr069cfg']['igd']['managementserver'],'=url,username,password,ConnectionRequestUsername,ConnectionRequestPassword'),
   'Diagnose/Wartung'		=> array(&$konfig['tr069cfg']['lab'],'=CRUsername,CRPassword','+username,password,domain_name,update_url'),
   'Netzwerkumgebung'		=> array(&$konfig['landevices']['landevices'],'-ip,name,neighbour_name,remotelogin_username,remotelogin_password'),
   'Telekom-Mediencenter'	=> array(&$konfig['t_media'],'=refreshtoken,accesstoken'),
   'Google-Play-Music'		=> array(&$konfig['gpm'],'=emailaddress,password,partition,servername'),
   'Onlinespeicher'		=> array(&$konfig['webdavclient'],'=host_url,username,password'),
   'WLAN'			=> array(&$konfig['wlancfg'],'/^(((guest|sta)_)?(ssid(_scnd)?|pskvalue)|(sta_)?key_value\d|wps_pin|wds_key)$/i'),
   'Push-Dienst'		=> array(&$konfig['emailnotify'],'=From,To,SMTPServer,accountname,passwd','+To,arg0'),
   'DECT-eMail'			=> array(&$konfig['configd'],'!<\?xml.*?<list>.*?<email>.*?<pool>(.*?)</pool>!s','!((name)|user_name|(?:smtp_)?server|user|pass|uipin|port)="([^"]+)"!s'),
   'FRITZ!Box-Benutzer'		=> array(&$konfig['boxusers']['users'],'-name,email,passwd,password'),
   'InternetTelefonie'		=> array(&$konfig['voipcfg'],'_name,username,authname,passwd,registrar,stunserver,stunserverport,gui_readonly'),
   'IP-Telefon'			=> array(&$konfig['voipcfg']['extensions'],'-extension_number,username,authname,passwd,clientid'),
   'Online-Telefonbuch'		=> array(&$konfig['voipcfg']['onlinetel'],'-pbname,url,serviceid,username,passwd,refreshtoken,accesstoken'),
   'FRITZ!NAS Share'		=> array(&$konfig['usbhost.filelinks'],'-id,path'),
   'Virtual-Privat-Network'	=> array(&$konfig['vpncfg']['connections'],'-name,>localid<fqdn,>remoteid<fqdn,>localid<user_fqdn,>remoteid<user_fqdn,key,>xauth>username,>xauth>passwd'),
  );
  foreach($access as $key => $var)		// Accessliste durcharbeiten
   if(ifset($var[0])) {
    if($var[1]{0} == '/') {			// Regulre Ausdrcke verwenden (Schlsselname)
     foreach($var[0] as $k => $v)
      if(preg_match($var[1],$k) and $var[0][$k])// Schlssel Suchen und Prfen
       $config[$key][$k] = $var[0][$k];
    }
    elseif($var[1]{0} == '!' and preg_match($var[1],$var[0],$val) and preg_match_all($var[2],$val[1],$val)) {	// Regulre Ausdrcke verwenden (Inhalt)
     foreach($val[3] as $k => $v)
      if(ifset($val[2][$k]))
       $name = $v;
      else
       $config[$key][$name][$val[1][$k]] = $v;
    }
    elseif($var[1]{0} == '=') {			// Normal abfragen
     $keys = explode(',',substr($var[1],1));
     foreach($keys as $k)
      if(ifset($var[0][$k]))			// Schlssel Testen
       $config[$key][$k] = $var[0][$k];
    }
    if(preg_match('/^([-+_])(.+)$/',$var[(isset($var[2])) ? 2 : 1],$keys)) {	// Eine Schlssel-Ebene berspringen
     if($keys[1] == '-' and count(array_filter(array_keys($var[0]),'is_string')) > 0)
      $var[0] = array($var[0]);
     $keys[3] = explode(',',$keys[2]);
     foreach($var[0] as $k => $v)
      if((preg_match('/\d+\s*$/',$k,$val) or $keys[1] == '+') and is_array($v)) {	// Neue Ebene gefunden
       $name = ($val) ? false : $k;
       foreach($keys[3] as $val)
        if($val{0} == '>' and preg_match('/(\w+)([<>])(\w+)/',$val,$va1) and ifset($var[0][$k][$va1[1]][$va1[3]]))	// Mit Regulre Ausdrcke noch eine Ebene berspringen
         if($name === false)
          $name = (string)$var[0][$k][$va1[1]][$va1[3]];
         else
          $config[$key][$name][(($va1[2] == '<') ? $va1[1] : $va1[3])] = $var[0][$k][$va1[1]][$va1[3]];	// Den Vorigen Schlssel verwenden?
        elseif(ifset($var[0][$k][$val]))		// Auf der neuen Ebene Prfen
         if($name === false)
          $name = (string)$var[0][$k][$val];
         else
          $config[$key][$name][$val] = $var[0][$k][$val];
      }
    }
   }
  dbug($config,4,'ShowAccessData');			// Alle Fundstcke ungefiltert sichern
  if(ifset($config['InternetTelefonie']))		// Filter: StunServerPort 3478 filtern
   foreach($config['InternetTelefonie'] as $key => $var)
    if(ifset($var['stunserverport'],3478))
     unset($config['InternetTelefonie'][$key]['stunserverport']);
  if(ifset($config['IPv6']) and ifset($config['IPv6']['ticserver']) and count($config['IPv6']) == 1)	// Filter: IPv6 tivserver
   unset($config['IPv6']);
  if(ifset($config['TR-069-Fernkonfiguration']) and ifset($config['TR-069-Fernkonfiguration']['url']) and count($config['TR-069-Fernkonfiguration']) == 1)	// Filter: TR069 url
   unset($config['TR-069-Fernkonfiguration']);
  if(ifset($config['Mobile-Stick']) and ifset($config['Mobile-Stick']['username'],'ppp') and ifset($config['Mobile-Stick']['passwd'],'ppp'))	// Filter: Surf-Stick ppp
   unset($config['Mobile-Stick']);
  if(ifset($config['DECT-eMail']))									// Filter: DECT-eMail
   foreach($config['DECT-eMail'] as $key => $var) {
    if(ifset($var['server']) and ifset($var['port'])) {	// Server & Port zusammenfhren
     $config['DECT-eMail'][$key]['server'] .= ":$var[port]";
     unset($config['DECT-eMail'][$key]['port']);
    }
    if(ifset($var['user'],$key))			// Doppelte Namen
     unset($config['DECT-eMail'][$key]['user']);
    if(ifset($var['user_name'],$key))
     unset($config['DECT-eMail'][$key]['user_name']);
   }
  if(ifset($config['Netzwerkumgebung']))								// Filter: Netzwerkumgebung
   foreach($config['Netzwerkumgebung'] as $key => $var)	// Hosts ohne Kennwort
    if(!ifset($var['remotelogin_password']))
     unset($config['Netzwerkumgebung'][$key]);
  if(ifset($config['TR-064']) and !ifset($config['TR-064']['password']))				// Filter: TR-064
   unset($config['TR-064']);
  if(is_null($config['TR-069-Fernkonfiguration']['url']))						// Filter: TR-069
   unset($config['TR-069-Fernkonfiguration']['url']);
  $a = array('/^\${4}\w+/','(Verschlsselt)');								// Verschlsselte Eintrge umschreiben
  foreach($config as $key => $var)
   if($var) {
    if($val = preg_array($a[0],$var,3)) {	// Array-Schlssel umbennenen
     foreach($val as $k => $v) {
      $config[$key][] = $v;
      unset($config[$key][$k]);
     }
     $var = $config[$key];
    }
    foreach($var as $k => $v)
     if(is_array($v)) {				// Unterwert umschreiben
      foreach($v as $kk => $vv)
       if(ifset($vv,$a[0]))
        $config[$key][$k][$kk] = $a[1];
     }
     elseif(ifset($v,$a[0]))			// Hauptwert umschreiben
      $config[$key][$k] = $a[1];
   }
  foreach($config as $name => $keys)									// Array in Text Umwandeln
   if($keys) {
    foreach($keys as $key => $data) {
     if(is_array($data))
      foreach($data as $k => $v)
       $data[$k] = "$k=$v";
     $keys[$key] = "|$key|->|".str_replace('|','\|',implode(', ',(array)$data));
    }
    $text .= "\n$name\n".textTable(implode("\n",$keys))."\n";
   }
 }
 else
  dbug("showaccessdata fehlgeschlagen");
 return $text;
}
function getevent($filter='aus',$sep="\t",$sid=0) {	// Ereignisse abrufen
 global $cfg;
 $filters = array('aus','system','internet','telefon','wlan','usb');
 $filter = (($var = ifset($filters,$filter)) !== false) ? $var : 0;
 dbug("Hole Ereignisse (Filter: {$filters[$filter]})");
 if(!$sid)
  $sid = $cfg['sid'];
 $sid = (!is_bool($sid)) ? "&sid=$sid" : '';
 if($cfg['fiwa'] < 500)
  $data = request('POST-array','/cgi-bin/webcm',"getpage=../html/de/system/ppSyslog.html&logger:settings/filter=$filter$sid");
 elseif($cfg['fiwa'] < 669)
  $data = request('GET-array',"/system/syslog.lua?tab={$filters[$filter]}&event_filter=$filter&stylemode=print$sid");
 if(ifset($data) and preg_match_all(($cfg['fiwa'] < 500) ? '!<p class="log">(\S*)\s*(\S*)\s*(.*?)</p>!'
	: '!<tr><td[^>]*>(?:<div>)?(.*?)(?:</div>)?</td><td[^>]*>(.*?)</td><td[^>]*><a[^>]*>(.*?)</a></td></tr>!',$data[1],$array)) {
  dbug($array,4,'GetEvent');
  foreach($array[1] as $key => $var)
   $array[0][$key] = $array[1][$key].$sep.$array[2][$key].$sep.$array[3][$key];
  $array = implode("\r\n",array_reverse($array[0]))."\r\n";
  if(ifset($data['Content-type'],'/utf-?8/i'))
   $array = utf8($array);
  return html_entity_decode($array,ENT_QUOTES,'ISO-8859-1');
 }
 elseif($cfg['fiwa'] >= 669 and $data = request('POST-array','/data.lua',"xhr=1$sid&lang=de&page=log&xhrId=log&filter=$filter&no_sidrenew=")
	and preg_match('/"log":\[((?:[^\[\]]++|\[(?1)\])*)\]/',$data[1],$array))
  return utf8(implode("\r\n",array_reverse(explode("\n",preg_replace(
	array('/\["(.*?)(?<!\\\\)","(.*?)(?<!\\\\)","(.*?)(?<!\\\\)"(,".*?(?<!\\\\)"){3}\],?/','!\\\\(?="|/)!'),
	array("$1 $2 $3\n",""),$array[1])))));
 else {
  if(ifset($data))
   dbug($data,4,'GetEvent-data');
  if(ifset($array))
   dbug($array,4,'GetEvent_array');
  return errmsg("Keine Ereignisse bekommen".(($var = errmsg(0,'request')) ? " ($var)" : ""),__FUNCTION__);
 }
}
function smarthome($cmd=0,$ain=0,$set=0,$sid=0) {	// SmartHome Gerteliste, Infos, Schalten
 global $cfg;
 if($cmd == 'temp')	// Temperatur entschlsseln
  $out = ($ain == 0 or $ain == 253) ? "aus" : (($ain == 1 or $ain == 254) ? "an" : ($ain/2)."C");
 else {
  if(!$sid)
   $sid = $cfg['sid'];
  dbug("Hole SmartHome Gerteliste");
  $out = false;
  $link = '/webservices/homeautoswitch.lua';
  $parm = "sid=$sid&switchcmd=";
  $device = array();
  if($xml = request('GET',$link,$parm."getdevicelistinfos") and preg_match_all('!<(device|group)\s([^>]+)>(.*?)</\1>!s',preg_replace('/[\r\n]+/','',$xml),$list)) {
   dbug($xml,9);
   dbug($list,4);
   foreach($list[2] as $k => $v) {				// Devices und Gruppen durchgehen
    $device[$k] = xml2array($list[3][$k],false);		// Device Infos einlesen
    if(preg_match_all('/([\w-]+)="([^"]+)"/',$v,$m))		// Device Attribute einlesen
     foreach($m[1] as $key => $var)
      $device[$k][$var] = $m[2][$key];
    if(ifset($device[$k]['functionbitmask']) and $val = $device[$k]['functionbitmask']) {	// Device Bitmaske entschlsseln
     $name = explode(',',"HANFUN Gert,Bit1,Bit2,Bit3,Alarm-Sensor,Taster,Heizkrperregler,Energie Messgert,Temperatursensor,Schaltsteckdose,"
	."AVM DECT Repeater,Mikrofon,Gruppe,HANFUN Unit,Bit14,Bit15");
     foreach($name as $key => $var) {
      if($val % 2)
       $device[$k]['functionbitname'][$key] = $var;
      $val = $val / 2 | 0;
     }
    }
   }
   $idx = array();						// ID-Index anlegen
   foreach($device as $key => $var)
    $idx[$var['id']] = $key;
   dbug($device,9);
   if($ain) {							// Einzelnen Aktor Schalten oder auslesen
    foreach($device as $v)
     if($ain == $v['id'] or preg_replace('/\W/','',strtoupper($ain)) == preg_replace('/\W/','',$v['identifier']) or strtolower($ain) == strtolower($v['name'])) {
      dbug("Aktor/Gruppe '$ain' gefunden",9);
      $ain = $v;
      break;
     }
    if(is_array($ain))
     if($cmd == 'info') {
      $out = "Hauptdaten|Name:|$ain[name]
|AIN:|$ain[identifier]
|ID:|$ain[id]
|Hersteller:|$ain[manufacturer]".((ifset($ain[productname])) ? "\n|Modell:|$ain[productname]" : "")."
|Firmware:|$ain[fwversion]
|Funktionen:|".implode(", ",$ain['functionbitname'])."
|Verbindung:|".(($ain['present']) ? "Online" : "Offline")
.((ifset($ain['battery'])) ? "\n|Batterie:|$ain[battery]%".(($ain['batterylow']) ? " (Schwach)" : "") : "")."\n";
      if(ifset($ain['groupinfo'])) {
       $array = explode(',',$ain['groupinfo']['members']);
       foreach($array as $key => $var) {
        $val = $device[$idx[intval($var)]];
        $array[$key] = (ifset($val['name'])) ? $val['name'] : $val['identifier'];
       }
       $out .= "Gruppe|Mitglieder:|".implode(", ",$array)."\n";
       if(ifset($ain['groupinfo']['masterdeviceid'])) {
        $var = $device[$idx[$ain['groupinfo']['masterdeviceid']]];
        $out .= "|Master:|".(($var['name']) ? $var['name'] : $var['identifier'])."\n";
       }
      }
      if(ifset($ain['switch']) and $x = $ain['switch'] or ifset($ain['hkr']) and $x = $ain['hkr'])
       $out .= "Schloss|Taster:|".(($x['devicelock']) ? "Gesperrt" : "Frei")."
|Fernsteuerung:|".(($x['lock']) ? "Gesperrt" : "Frei")."\n";
      if(ifset($ain['powermeter']) and $x = $ain['powermeter'])
       $out .= "Energie Messgert|Spannung:|".number_format($x['voltage']/1e3,2,",",".")." Volt
|Leistung:|".number_format($x['power']/1e3,3,",",".")." Watt
|Stromzhler:|".number_format($x['energy']/1e3,3,",",".")." KiloWattStunden\n";
      if(ifset($ain['switch']) and $x = $ain['switch'])
       $out .= "Schaltsteckdose|Schaltzustand:|".(($x['state']) ? "An" : "Aus")."
|Modus:|".ucfirst($x['mode'])."\n";
      if(ifset($ain['temperature']) and $x = $ain['temperature'])
       $out .= "Temperatur|Sensor:|".($x['celsius']/10)."C".(($x['offset']) ? "\n|Offset:|".preg_replace('/^(?=\d)/','+',$x['offset']/10) : "")."\n";
      if(ifset($ain['hkr']) and $x = $ain['hkr'])
       $out .= "Heizregler|Aktuell:|".call_user_func(__FUNCTION__,'temp',$x['tist'])."
|Eingestellt:|".call_user_func(__FUNCTION__,'temp',$x['tsoll'])."
|Spar:|".call_user_func(__FUNCTION__,'temp',$x['absenk'])."
|Komfort:|".call_user_func(__FUNCTION__,'temp',$x['komfort'])."
|Nchste nderung:|".strftime('%d.%m.%G %X',$x['nextchange']['endperiod'])." Uhr auf ".call_user_func(__FUNCTION__,'temp',$x['nextchange']['tchange'])."
|Fenster:|".(($x['windowopenactiv']) ? "Offen" : "Geschlossen")."
|Sommerpause:|".(($x['summeractive']) ? "Aktiviert" : "Aus")."
|Urlaub:|".(($x['holidayactive']) ? "Aktiv" : "Aus")."
|Letzter Fehler:|".(($y = explode("\n","Kein Fehler
Keine Adaptierung mglich
Ventilhub zu kurz oder Batterieleistung zu schwach
Keine Ventilbewegung mglich
Die Installation wird gerade vorbereitet
Der Heizkrperregler ist im Installationsmodus und kann auf das Heizungsventil montiert werden
Der Heizkrperregler passt sich nun an den Hub des Heizungsventils an")) ? ((ifset($y[$x['errorcode']])) ? $y[$x['errorcode']] : "Unbekannt ($x[errorcode])") : "")."\n";
      if(ifset($ain['button'])) {
       $array = (ifset($ain['button'][0])) ? $ain['button'] : array($ain['button']);
       foreach($array as $k => $v)
        $out .= "Schalter #".($k + 1)."|Name:|$v[name]
|AIN:|$v[identifier]
|ID:|$v[id]".((ifset($v['lastpressedtimestamp'])) ? "\n|Zuletzt bettigt:|".strftime('%d.%m.%G %X',$v['lastpressedtimestamp'])." Uhr" : "")."\n";
      }
      dbug($ain);
     }
     elseif($ain['present']) {
      $do = array('on' => 'setswitchon', 'off' => 'setswitchoff', 'trip' => 'setswitchtoggle');
      if(ifset($ain['functionbitname'][9]))			// Schaltsteckdosen
       if(ifset($cmd,'/test/'))					// test
        $out = "$ain[name] ist A".(($ain['switch']['state']) ? "N" : "US")." geschaltet!";
       elseif(ifset($ain['switch']['lock']))
        $out = errmsg("Aktor ist fr die Fernwartung gesperrt!",__FUNCTION__);
       elseif(ifset($cmd,'/on|off|trip/'))			// on / off / trip
        $out = request('GET',$link,$parm.$do[$cmd]."&ain=".str_replace(' ','',$ain['identifier']));
      if(ifset($ain['functionbitname'][6]))			// Heizkrperregler
       if($cmd == 'test')
        $out = "$ain[name] ist ".preg_replace('/^(?=\d)/','auf ',call_user_func(__FUNCTION__,'temp',$ain['hkr']['tsoll']))." gestellt";
       elseif(ifset($ain['hkr']['lock']))
        $out = errmsg("Aktor ist fr die Fernwartung gesperrt!",__FUNCTION__);
       elseif(ifset($cmd,'/on|off|trip|set/')) {
        $do = array('on' => 254, 'off' => 253, 'trip' => ($ain['hkr']['tsoll'] == 253) ? 254 : 253,
	'set' => ($set == 'spar') ? $ain['hkr']['absenk'] : (($set == 'komfort') ? $ain['hkr']['komfort']
	: (($set == 'an') ? 254 : ((!$set or $set == 'aus') ? 253 : floor(floatval($set)*2)))));
        $out = request('GET',$link,$parm."sethkrtsoll&param=".$do[$cmd]."&ain=".urlencode($ain['identifier']));
       }
      if(!$out)
       $out = errmsg("Aktor untersttzt diese Funktion nicht!",__FUNCTION__);
      elseif(ifset($out,'/^\d+$/'))
       $out = "$ain[name] wurde ".preg_replace('/^(?=\d)/','auf ',call_user_func(__FUNCTION__,'temp',$out))." gestellt!";
     }
     else
      $out = errmsg("Aktor ist nicht verbunden bzw. OFFLINE!",__FUNCTION__);
    elseif(ifset($cmd,'/on|off|trip/') and $set) {
     $do = array('on' => 'setswitchon', 'off' => 'setswitchoff', 'trip' => 'setswitchtoggle');
     $out = request('GET',$link,$parm.$do[$cmd]."&ain=".urlencode($ain));
    }
    else
     $out = errmsg("Aktor '$ain' nicht gefunden!",__FUNCTION__);
   }
   elseif($cmd == 'json')
    $out = (function_exists('json_encode')) ? json_encode(utf8($device,1)) : errmsg("JSON_Encode von PHP {$cfg['php'][0]} ist fehlgeschlagen",__FUNCTION__);
   else {							// Device-Liste zurckgeben
    $list = array();
    $spar = array(0,0);
    foreach($device as $k => $v) {
     $array = array('ID' => 'id', 'AIN' => 'identifier', 'Name' => 'name', 'Modell' => 'productname', 'OS' => 'fwversion');
     foreach($array as $key => $var)
      $list[$k][$key] = (ifset($v[$var])) ? $v[$var] : false;
     if(!$list[$k]['Modell'] and ifset($v['groupinfo'])) {
      $var = count(explode(',',$v['groupinfo']['members']));
      $list[$k]['Modell'] = "Gruppe ($var Mitglied".(($var == 1) ? "" : "er").")";
     }
     $list[$k]['Batterie'] = (isset($v['battery'])) ? ($spar[0] = "$v[battery]%") : "-";
     $val = "-";
     if(ifset($v['temperature'])) {				// Temperatur
      $x = $v['temperature'];
      $val = ($x['celsius']/10)."C";
      if($x['offset'])
       $val .= " (".preg_replace('/^(?=\d)/','+',$x['offset']/10).")";
      $spar[1] = $val;
     }
     elseif(ifset($v['hkr']) and ifset($v['hkr']['tist']))	// Alternative Mglichkeit ber HKR
      $val = call_user_func(__FUNCTION__,'temp',$v['hkr']['tist']);
     $list[$k]['Temperatur'] = $val;
     $val = "offline";						// Status
     if($v['present']) {
      if(isset($v['switch']['state'])) {			// Schaltsteckdose
       if(($val = ($v['switch']['state']) ? "an" : "aus") == 'on' and isset($v['powermeter']['power']))
        $val .= " (".($v['powermeter']['power']/1e3)."W)";
      }
      elseif(isset($v['hkr']['tsoll']))				// Heizkrperregler
       $val = call_user_func(__FUNCTION__,'temp',$v['hkr']['tsoll']);
      else
       $val = "online";						// Unbekannt
     }
     $list[$k]['Status'] = $val;
    }
    if($spar != array(0,0))					// Unntze Spalten einsparen
     foreach($list as $key => $var)
      if($spar[0])
       unset($list['Batterie']);
      elseif($spar[1])
       unset($list['Temperatur']);
    if($cmd == 'csv') {						// CSV-Ausgabe
     if(!$set)
      $set = ";";
     $out = implode($set,array_keys($list[0]))."\n";
     foreach($list as $var)
      $out .= implode($set,preg_replace('/'.preg_quote($set,'/').'/','\\$0',$var))."\n";
    }
    elseif($cmd == 'list') {					// Text-Ausgabe
     $out = implode('|',array_keys($list[0]))."\n";
     foreach($list as $var)
      $out .= implode('|',preg_replace('/'.preg_quote('|','/').'/','\\$0',$var))."\n";
    }
    else							// RAW-Ausgabe
     $out = $list;
   }
  }
  else
   $out = errmsg("Keine Aktoren gefunden!",__FUNCTION__);
 }
 return $out;
}
function init($ver) {					// Fritz!Box Tools Initialisieren
 global $cfg,$script,$self,$Self;
 if((float)phpversion() > 4.3 and $ver = ifset($ver,'/^(\w+) ([\d.]+) \(c\) (?:GNU )?GPL (\d\d)\.(\d\d)\.(\d{4}) by ([\w ]+?) <(\w+:\/\/[\w.-]+)(.*?)>$/')) {
  define($ver[1],1);					// Feste Kennung fr Plugins etc.
  $ver[] = intval($ver[5].$ver[4].$ver[3]);		// fb_tools Datum (9)
  $ver[] = floatval($ver[2]);				// fb_tools Version (10)
  $script = (ifset($_SERVER['argv'][0])) ? (($var = realpath($_SERVER['argv'][0])) ? $var : realpath($_SERVER['argv'][0].".bat")) : $_SERVER['PHP_SELF'];
  $self = basename($_SERVER['argv'][0]);		// Exec-Script (Wie von der Konsole aufgerufen)
  $Self = basename($script);				// Script_Name
  $cfg['dir'] = preg_replace(array('/\\\\/','/\/$/'),array('/',''),dirname($script));
  $cfg['ver'] = $ver;					// FB_Tools Versionsstring
  $cfg['ext'] = strtolower(preg_replace('/\W+/','',pathinfo($script,PATHINFO_EXTENSION))); // Extension fr Unix/Win32 unterscheidung
  $cfg['php'] = array(phpversion(),php_uname(),php_sapi_name(),(float)phpversion(),(defined('PHP_INT_SIZE')) ? PHP_INT_SIZE * 8 : 32);
  $cfg['ssl'] = (defined('OPENSSL_VERSION_TEXT')) ? OPENSSL_VERSION_TEXT : false;
  $cfg['osn'] =  ($var = ifset($cfg['ssl'],'/[\d.]+/')) ? (float)$var[0] : false;
  $cfg['ptar'] = '/\.t(ar(\.gz)?|gz)$/i';		// Tar-Ausdruck
  $cfg['dbcd'] = realpath('.').'/';			// Current_Dir fr Debug-Daten
  $cfg['desc'] = '/['.preg_quote(preg_replace('!/.*$!','',$cfg['fesc']),'/').']+/';
  $cfg['fesc'] = '/['.preg_quote($cfg['fesc'],'/').']+/';
  $cfg['head'] = array('User-Agent' => "$Self $ver[2] {$cfg['php'][1]} PHP {$cfg['php'][0]}/{$cfg['php'][2]} ({$cfg['php'][4]} Bit) $cfg[ssl]"); // Fake UserAgent
  $cfg['uplink'] = array(preg_replace('/^.*?(?=[\w.-]+$)/','',$ver[7]),"/Projekte;",$ver[1],"fbt_plugins");	// Update-Link
  if(($cfg['os'] = strtolower(PHP_OS)) == 'winnt')	// Sonderarten von Windows erkennen
   $cfg['os'] .= (count(preg_array('/^(HOME|SYSTEM(DRIVE|ROOT)|APPDATA|WINDIR)$/',$_SERVER,3)) == 5) ? '-busybox'
	: ((count(preg_array('/^(SystemDrive|SYSTEMROOT|APPDATA|windir|WINE(LOADER|SERVER)?)$/',$_SERVER,3)) == 7) ? '-wine' : '');
  foreach(array('l' => $cfg['libs'], 'a' => $cfg['fbtp']) as $key => $var)	// Verzeichnisliste fr Libs/Plugins vorab berechnen
   $cfg["fbt$key"] = array(".",$var,strtoupper($var),ucwords($var),"$cfg[dir]","$cfg[dir]/$var","$cfg[dir]/".strtoupper($var),"$cfg[dir]/".ucwords($var));
  if(ifset($_SERVER['argc']) and !preg_match('/cli/',$cfg['php'][2]) and function_exists('header_remove')) {	// HTTP-Header lschen wenn PHP-CGI eingesetzt wird
   header('Content-type:');
   header_remove('Content-type');
   header_remove('X-Powered-By');
  }
  if(function_exists('php_ini_loaded_file') and $var = php_ini_loaded_file())	// PHP.ini Location speichern
   $cfg['php'][] = $var;
  foreach(array(".",$cfg['dir']) as $var)				// Benutzerkonfig suchen
   if(file_exists($var = realpath($var)."/".basename($cfg['usrcfg']))) {// Benutzerkonfig gefunden und laden
    dbug("Lade Benutzer-Konfig: $var");					// Debug-Meldung (dbug muss im Haupt-Quelltext aktiviert werden)
    include $var;
    break;
   }
  if(@ini_get('pcre.backtrack_limit') < $cfg['pcre']) 	// Bug ab PHP 5 beheben (Fr Groe RegEx-Ergebnisse)
   @ini_set('pcre.backtrack_limit',$cfg['pcre']);
  if($cfg['time'])					// Zeitzone festlegen
   @ini_set('date.timezone',$cfg['time']);
  $gz = (function_exists("gzopen") or function_exists("gzopen64")) ? true : false;	// ZLib Funktionen initialisieren
  foreach(explode(',','open,close,eof,file,gets,puts,read,write,seek,tell,Encode,Decode,Deflate,Inflate') as $key)
   $cfg['zlib'][strtolower($key)] = ($key == strtolower($key)) ? (($gz and function_exists("gz$key")) ? "gz$key"
	: (($gz and function_exists("gz$key64")) ? "gz$key64" : $key)) : strtolower("gz$key");
  $cfg['a1st'] = (date('nj') == 41) ? explode("~",$cfg['zlib']['inflate'](base64_decode(	/* Test-Funktion */"
	XZBBT8JAEIXv/IrxtpsICdFTNTRFIwejaZDogXBYu9N2adnW2SkiIf3ZnnpwC3LQ45s3+d68GczRIcfKuc+K9GF4eEHeM9iGQCsHkd1gqbFAa73PoJoU3pAK
	h8Y6xrJsbIYW9g11SSHGcrAwSYE8Q4ukuCIPnCJhkltkyLqSTYZw2nGQdj7EIDwaq5GcSXIkzxNXl9eyPYgwvqV6Mhf9gTKMxe+NMpRHj7PJQhxJMpyJc6B3
	22VKhvej92q3guWm0hj8LVlrP6+9Cu4xVU3JcLZW7Wn/fwvOepJKVPDQoy+m1Q6eorthpAmdw1X7Wjew7lRa+79R7gVtFSlY5+qD0E+/ezUewXOC2y+4Gcof"))) : false;
  $cfg['time'] = (ifset($_SERVER['REQUEST_TIME_FLOAT'])) ? $_SERVER['REQUEST_TIME_FLOAT'] : array_sum(explode(' ',microtime()));	// Startzeit sichern
  foreach(explode(',','aes,arg,argc,argk,args,opts,auth') as $var)	// Leeres Array setzen
   $cfg[$var] = array();
  if(!function_exists('hash_algos'))			// SHA-256 nachinstallieren
   $cfg['mods'] = cfgdecrypt(0,'mhash sha256 sha512');
  return true;
 }
 return false;
}

# Eigentlicher Programmstart
if(ifset($argc) and ifset($argv) and init($ver)) {	## CLI-Modus ##
 $pmax = $argc;		// Anzahl der Parameter
 $pset = 1;		// Argumentenzhler
 $opts = "";		// Kontext-Optionen

# Drag'n'Drop Modus
 if(ifset($cfg['drag']) and $pset+1 == $pmax and file_exists($argv[$pset]) and is_file($argv[$pset])) {
  dbug("Nutze Drag-Parameter: ".str_replace('*'," {$argv[$pset]} ",$cfg['drag']));	// Debug-Meldung (Kann nicht mit -d angezeigt werden)
  $drag = explode('*',$cfg['drag']);
  array_splice($argv,$pmax,0,explode(' ',trim($drag[1])));
  array_splice($argv,$pset,0,explode(' ',trim($drag[0])));
  $pmax = $argc = count($argv);
 }

# Optionen setzen
 while(ifset($argv[$pmax-1],'/^-/') and ($pmax == $argc and !ifset($argv[$pmax-2],'/^-/')
  and preg_match_all('/-([a-z]+)(?:[:_=]([(\/\w%#~;,.!+)]+))?(?=-|$)/i',$argv[$pmax-1],$array) or preg_match('/^-(\w+)(?:[:=](.+))?$/',$argv[$pmax-1],$array))) {
  if(is_string($array[0]))
   $array = array(array($array[0]),array($array[1]),array((ifset($array[2])) ? $array[2] : false));
  $pmax--;
  foreach($array[1] as $key => $var) {
   $vas = $array[2][$key];
   $cfg['opts'][$var] = ($vas !== "" and $vas !== false) ? $vas : true;	// Option speichern
   if($var == 'h')	// Help
    $cfg['help'] = ($vas) ? $vas : true;
   elseif($var == 'd') {// Debug
    $cfg['dbug'] = ($val = ifset($vas,'/^(\d+)(?:.(.+))?$/')) ? intval($val[1]) : true;
    if(ifset($val[2]) and (file_exists($val[2]) and is_dir($val[2]) or !file_exists($val[2]) and $val[2] = makedir($val[2],0)))
     $cfg['dbcd'] = realpath($val[2]).'/';	// CD Setzen
   }
   elseif($var == 'w')	// Wrap
    $cfg['wrap'] = (ifset($vas,'/^[1-9]\d+$/')) ? intval($vas) : 80;
   elseif($var == 'c')	// Char
    $cfg['char'] = strtolower($vas);
   elseif($var == 't')	// Timeout
    $cfg['tout'] = (ifset($vas,'/^\d+$/')) ? intval($vas) : 0;
   elseif($var == 'b')	// Buffer
    $cfg['sbuf'] = (ifset($vas,'/^[1-9]\d{2,}$/') ) ? intval($vas) : 4096;
   elseif($var == 'p')	// Protokoll
    $cfg['sock'] = ($v = ifset($vas,'/^(auto|https?|ssl|tls)$/i') ) ? strtolower($v[0]) : 'auto';
   elseif($var == 's') {// SID
    if(preg_match('/^[\da-f]{16}$/i',$vas,$val) or file_exists($vas) and preg_match('/^[\da-f]{16}$/i',file_contents($vas),$val))	// SID direkt bernehmen
     $cfg['sid'] = $val[0];
    elseif(file_exists($vas) and preg_match('/a:\d+:\{.*\}/',file_contents($vas),$val))
     $cfg = array_replace($cfg,unserialize($val[0]));
    if($cfg['sid'] and $sid = login(0,0,0,$cfg['sid'])) {
     $cfg['bsid'] = $cfg['sid'] = $sid;
     dbug("Recycle Login-SID: $sid von $cfg[host]");
    }
   }
   elseif($var == 'gz')						// GZip Crunchlevel
    $cfg['zlib']['mode'] = ($v = ifset($vas,'/^-?\d[fhR]?$/')) ? $v[0] : -1;
   elseif($var == 'pe' and $vas)				// PHP-Extension nachladen
    @dl($vas);
   elseif($var == 'fw' and $v = ifset($vas,'/^(\d+\.0)?([1-9])\.?(\d{2})(-\d+)?$/'))	// Fritz!Box Firmware-Version
    $cfg['fiwa'] = (int)($v[2].$v[3]);
   elseif($var == 'ua' and $v = ifset($vas,'/^[[:print:]]+$/'))	// UserAgent
    $cfg['head']['User-Agent'] = $v[0];
   else
    foreach(array('o' => 'oput', 'un' => 'user', 'pw' => 'pass', 'ui' => 'uipw', 'fb' => 'host', 'pt' => 'port') as $k => $v)	// Optionen mit Zwangsparameter
     if($var == $k and $vas)
      $cfg[$v] = $vas;
  }
 }

# Fritz!Box Parameter ermitteln und auswerten
 if($pset < $pmax and @preg_match('/^(?!-) (?:(https?):\/\/)? (?:([^:]+):)? (?:([^@]+)@)? ([\w.-]+\.[\w.-]+|(?<=@)[\w.-]+|\[[a-f\d:]+\]|'
	.strtr(preg_quote(implode("\t",array_keys($cfg['preset'])),'/'),"\t",'|').') (?::(\d{1,5}))? (?:\#(.+))?$/ix',$argv[$pset],$array)) {	// Fritz!Box Anmeldedaten holen
  dbug("Presets: ".implode(', ',array_keys($cfg['preset'])),9);
  $cfg['host'] = $array[4];
  if(isset($cfg['preset'][$array[4]])) {			// Voreingestellte Fritz!Boxen Erkennen und Eintragen
   dbug("bernehme Preset: $array[4]");
   foreach($cfg['preset'][$array[4]] as $key => $var)
    $cfg[$key] = $var;
  }
  if(ifset($array[1])) {
   $cfg['sock'] = $array[1];
   if($array[1] == 'https')
    $cfg['port'] = 443;
  }
  if(ifset($array[2]))
   $cfg['user'] = $array[2];
  if(ifset($array[3]))
   $cfg['pass'] = $array[3];
  if(ifset($array[5]))
   $cfg['port'] = $array[5];
  if(ifset($array[6]))
   $cfg['uipw'] = $array[6];
  $pset++;
 }
 unset($cfg['preset']);					// Preset-Daten werden nicht mehr bentigt!

# Benannte und Nummerische Argumente setzen
 if($pset < $pmax) {
  for($a=$pset; $a < $pmax; $a++)
   if(preg_match("/^((?!$cfg[argn])\w+)(?:\[(.)\])?[:=]([\"']?)(.*?)\\3$/i",$argv[$a],$var)) {	// Benanntes Argument
    if($var[2] and preg_match_all('/(?:[^'.preg_quote($var[2],'/').'\\\\]+|\\\\'.preg_quote($var[2],'/').'?)+/',$var[4],$array))	// Ketten-Argumente (test[,]=foo,bar)
     $var[4] = $array[0];
    if(isset($cfg['args'][$var[1]]))	// Existiert schon?
     if(is_array($cfg['args'][$var[1]]))// Ein Array?
      $cfg['args'][$var[1]][] = $var[4];// Array erweitern
     else
      $cfg['args'][$var[1]] = (is_array($var[4])) ? array_merge($cfg['args'][$var[1]],$var[4]) : array($cfg['args'][$var[1]],$var[4]);	// In Array umwandeln
    else
     $cfg['args'][$var[1]] = $var[4];	// Normal speichern
   }
   elseif(isset($argv[$a]{0}) and $argv[$a]{0} != '-')	// Nummeriertes Argument
    $cfg['arg'][$a] = $argv[$a];
  $cfg['argc'] = array_keys($cfg['arg']);
  if($cfg['args'])
   $cfg['arg'] += $cfg['args'];		// Alle Argumente zusammenfhren
  else
   $cfg['argn'] = false;		// Alten Parametermodus aktivieren
 }

 # PHP-Fehler Protokollieren
 if($cfg['dbug'] & 1<<8) {
  set_error_handler(create_function('$no,$str,$file,$line','
  $a = preg_split("/\s+/","ERROR WARNING PARSE NOTICE CORE_ERROR CORE_WARNING COMPILE_ERROR COMPILE_WARNING
	USER_ERROR USER_WARNING USER_NOTICE STRICT RECOVERABLE_ERROR DEPRECATED USER_DEPRECATED UNKNOWN");
  foreach($a as $b => $c)
   if($no == pow(2,$b))
    break;
  $a = "$str on line $line";
  $b = &$GLOBALS["cfg"]["error"][$c][$file];
//  $b["backtrace"][] = debug_backtrace();
  if(!isset($a,$b) or array_search($a,$b) === false)
   $b[] = $a;
  return false;'));
 }
 else
  error_reporting(0);					// Fehler-Meldungen deaktivieren

# Consolen Breite automatisch ermitteln
 if($cfg['wrap'] == 'auto') {
  if(ifset($cfg['os'],'/darwin|linux/'))	// Linux/Mac
   $cfg['wrap'] = (file_exists('/usr/bin/tput') and $a = (int)@exec('tput cols')
	or file_exists('/bin/stty') and $a = (int)preg_replace('/^\d+\D*/','',@exec('stty size'))) ? $a : 0;
  elseif((ifset($cfg['os'],'/^winnt(?!-wine)/') or file_exists(getenv('windir')."/system32/mode.com")) and (@exec('mode con',$var) or true)	// Windows
	and is_array($var) and preg_match_all('/(?:(zeilen|lines)|(spalten|columns)|(code\s?page)):\s*(\S+)/',strtolower(implode('',$var)),$val))
   foreach($val[4] as $key => $var) {
    if(ifset($val[2][$key]))			// Breite sichern
     $cfg['wrap'] = $var;
    if(ifset($val[3][$key]))			// Codepage merken
     $char = "cp".(($var == 65001 and ifset(($cfg['php'][1]),'/Windows NT[\s\w_-]*(6\.[01])/i')) ? 850 : $var);
   }
  if($cfg['wrap'] == 'auto')			// Auto fehlgeschlagen -> Wrap deaktiviert
   $cfg['wrap'] = 0;
 }

# Char ermitteln und festlegen
 if(ifset($cfg['char'],'auto')) {
  if(preg_match('/(13)[73]((\1)37)/',date('dnHi'),$var))
   $cfg['char'] = $var[2];
  elseif(ifset($char))
   $cfg['char'] = $char;
  elseif($var = ifset($_SERVER['LANG'],'/(UTF-?8)|((?:iso-)?8859-1)/i') and ($var[1] and !isset($cfg['utf8'])) or ifset($var[2]))	// Linux/Ubuntu
   $cfg['char'] = ($var[1]) ? 'utf-8' : 'iso-8859-1';
  elseif(isset($_SERVER['HOME']) and isset($_SERVER['USER']) and isset($_SERVER['TERM']) and isset($_SERVER['SHELL'])	// Unix/Linux/Mac
	and file_exists('/usr/bin/locale') and preg_match('/(utf-?8)|(ansi|iso-?8859-?1|ascii)/i',@exec('locale charmap'),$var))
   $cfg['char'] = (ifset($var[1]) and !isset($cfg['utf8'])) ? 'utf8' : ((ifset($var[2])) ? strtolower(str_replace('-','_',$var[2])) : 'utf7');
  elseif(isset($_SERVER['SystemDrive']) and isset($_SERVER['SystemRoot']) and isset($_SERVER['APPDATA']))	// Windows
   $cfg['char'] = 'oem';
  else
   $cfg['char'] = '7bit';
 }
 $cfg['char'] = ($a = '(c(odepage|p))?' and $val = ifset($cfg['char'],"/^((?P<d>$a(437|850)|dos|oem)|(?P<a>$a(1252|851|28591)|iso.?8859.?1|ansi|ascii)|(?P<m>$a(1250|852|28952)|iso.?8859.?2)"
	."|(?P<c>{$a}65000|7bit|asc|utf-?7)|(?P<u>{$a}65001|utf-?8)|(?P<h>x?html?)|(?P<l>\x31\x33{2}\x37)|(?P<n>auto|none))$/i")) ? $val : array(0 => "char ($cfg[char])", 'c' => 1);
 dbug(array('char' => $cfg['char']),4);

# Auto-Update (Check)
 if($cfg['upda'] and $cfg['uplink'] and count($cfg['uplink']) == 4) {
  $val = time() & ~1;
  $key = "Bitte nutzen Sie die Update-Funktion!\n\nBeispiel:\n$self info update\n\n";
  if($val-max(filemtime($script),(file_exists($plug = dirname($script)."/$cfg[fbtp]")) ? filemtime($plug) : 0) > $cfg['upda']) {
   dbug("Prfe auf Updates...");
   foreach(array(443,80) as $var)
    if($fbnet = request('GET',$cfg['uplink'][1].$cfg['uplink'][2].'.md5',0,0,$cfg['uplink'][0],$var))
     break;
   if($fbnet and preg_match("/\((\w+)\s([\d.]+)\)/",$fbnet,$var) and floatval($var[2]) > $cfg['ver'][10] and $val++)
    out("Ein Update ist verfgbar ($var[1] $var[2]) - $key");
   if(!touch($script,$val)) {
    fclose(fopen($script,'a'));
    if(file_exists($plug) and @file_contents($var = "$plug/.touch","touch"))
     @unlink($var);
   }
  }
#  elseif(filemtime($script) & 1)
#   out($key);
 }

# Parameter auswerten
 if($val = getArg('mode','/^
	((?P<bi>BoxInfo|bi)	|(?P<pi>PlugIns?|pi)	|(?P<gip>G(et)?IP)		|(?P<lio>Log(in(-?test)?|out)|l(o|it?))
	|(?P<rc>ReConnect|rc)	|(?P<sd>SupportDaten|sd)|(?P<ss>(System)?S(tatu)?s)	|(?P<k>K(onfig)?)	|(?P<i>I(nfo)?|UpGrade|ug)
	|(?P<e>E(reignisse)?)	|(?P<led>led)		|(?P<al>AnrufListe?|al)		|(?P<sh>SmartHome?|sh)	|(?P<wh>Dial|d|WahlHilfe|wh)
	'.(($cfg['a1st']) ? $cfg['a1st'][1] : "").'|(?P<pit>[\w-]+))$/ix')) {
  dbug(array('mode' => $val, 'opts' => $cfg['opts'], 'argk' => $cfg['argk'], 'arg' => $cfg['arg'], 'argc' => $cfg['argc'], 'args' => $cfg['args']),3);
  if(ifset($val['al'])) {				// Anrufliste
   if(ifset($cfg['help'])) {						// Hilfe Ausgeben
    out("$self <fritz.box> [mode:AnrufListe|al] <file:Datei/Ordner> <from:zeit> <to:zeit>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:anrufliste file:calllist-%y%m%d.csv -cs:\"\\t\"
$self fritz.box al
$self fritz.box al from:2018-01-01 \"to:2018-12-31 23:59\"
$self fritz.box mode:anrufliste file:call_%G-%m-%d.csv -ch -lf" : "")."\n");
  if(!$cfg['help'] or $cfg['help'] === true)
   $cfg['help'] = -1;
  $opts .= "AnrufListe:|-ch||Schreibt in der Datei ein CSV-Header
|-cs:|<Seperator>|CSV-Separator festlegen (;)
|-lf||Schreibt die Daten als Logfile";
   }
   elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {
    dbug("Download der Anrufliste anfordern");
    $pfile = getArg('file');
    $from = ($var = getArg('from') and $val = strtotime($var) and $val != -1) ? $val : false;
    $to = ($var = getArg('to') and $val = strtotime($var) and $val != -1) ? $val : false;
    $file = ($pfile and strpos($pfile,'%') !== false) ? strftime($pfile) : ((!$pfile or ifset($pfile,'/^[:*]$/')) ? false : $pfile);
    if(($cfg['fiwa'] > 530 and $data = request('get','/fon_num/foncalls_list.lua',"sid=$sid&apply=&csv=")	// Download der Anrufliste
     or $data = request('get','/cgi-bin/webcm',"getpage=../html/de/FRITZ!Box_Anrufliste.csv&sid=$sid"))
	and $psep = preg_quote($sep = (preg_match('/^sep=(.+)/',$data[1],$var)) ? $var[1] : ';','/')
	and preg_match_all("/^".($preg = "([0-4]$psep(\d\d)\.(\d\d)\.(?:20)?(\d\d)\s+([\d:]+)($psep(.*?)){4,5})\s*$/")."m",$data[1],$array)) {
     dbug($array,4);			# 1	     2	     3		    4	     5	     6     7
     $count = 0;
     $preg = array("/^[\s\S]*?$preg",'20$4-$3-$2 $5');
     foreach($array as $key => $var)					// Komplette Matchliste umdrehen
      $array[$key] = array_reverse($var);
     $csv = (!$file or ifset($cfg['opts']['ch'])) ? preg_replace('/\d[\s\S]*$/','',$data[1]) : "";	// CSV-Header
     $call = array();							// Zeitbereich auswhlen
     foreach($array[1] as $key => $var)
      if($time = strtotime(preg_replace($preg[0],$preg[1],$var))
		and (!$from or $time >= $from) and (!$to or $time <= $to))
       $call["$time#$key"] = preg_replace(array('/^1/','/^2/','/^[34]/'),array('in','ring','out'),$var);
     $data[1] = implode("\r\n",$call);
     dbug(count($call).((count($call) != count($array[1])) ? "/".count($array[1]) : "")." Anruf(e) wurden ausgelesen");
     if(!$file)								// Anrufliste auf den Bildschirm ausgeben
      out("{{{tt}".utf8(preg_replace(array('/\|/',"/$psep/"),array('\\|','|'),$csv.implode("\n",$call)))."}}");
     else {								// CSV-Datei speichern
      if(ifset($cfg['opts']['cs']) and $sep != ($new = str_replace('\t',"\t",$cfg['opts']['cs']))) {	// Seperator fr CSV-Datei ndern
       $preg = array(array('/'.preg_quote($new,'/').'/',"/$psep/"),array("\\$new",$new));
       $csv = preg_replace($preg[0],$preg[1],$csv);
       $call = preg_replace($preg[0],$preg[1],$call);
      }
      if(ifset($cfg['opts']['lf'])) {					// Logmodus
       dbug("Anrufliste im Logfile-Modus speichern");
       $last = -1;
       foreach($call as $key => $var) {
        if($file != ($val = (strpos($pfile,'%') !== false) ? strftime($pfile,intval($key)) : $pfile))
         $file = $val;
        if(file_exists($file))
         $date = ($data = file_contents($file,-256) and preg_match($preg[0],$data,$val)) ? strtotime(preg_replace($preg[0],$preg[1],$data)) : 0;
        else {
         $val = array(0,$var);
         $date = 0;
         if($csv)
          file_contents($file,$csv);					// CSV-Header anlegen
        }
        if(intval($key) > $date or intval($key) == $last) {		// or intval($key) == $date and $var != $val[1]
         file_contents($file,"$var\r\n",8);				// Anruf speichern
         $last = intval($key);
         $count++;
        }
       }
      }
      else {								// Anrufliste normal in Datei speichern
       if(file_exists($file)) {
        $date = ($data = file_contents($file,-256) and preg_match($preg[0],$data)) ? strtotime(preg_replace($preg[0],$preg[1],$data)) : 0;
        foreach($call as $key => $var)
         if(intval($key) <= $date)
          unset($call[$key]);
        file_contents($file,implode("\r\n",$call)."\r\n",8);		// Anruf speichern
       }
       else
        file_contents($file,$csv.implode("\r\n",$call)."\r\n");		// Anruf speichern
       $count = count($call);
      }
     }
     if($count)
      out("Es wurde".(($count == 1) ? " 1 neuer Eintrag" : "n $count neue Eintrge")." gespeichert");
    }
    else
     out("Keine Anrufliste erhalten!");
    if(!ifset($cfg['bsid']))						// Abmelden
     logout($sid);
   }
   else
    out(errmsg(0,'login'));						// Login fehlgeschlagen
  }
  elseif(ifset($val['bi'])) {				// Jason Boxinfo
   if(ifset($cfg['help']))
    out("$self <fritz.box> [mode:BoxInfo|bi] <file:jason_boxinfo.xml>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:boxinfo file:/media/stick/jason_boxinfo.xml
$self fritz.box bi
$self boxinfo" : ""));
   elseif($data = boxinfo(($arg = getArg('file') and file_exists($arg)) ? file_contents($arg) : false))
    out("Boxinfos:\n".$data);
   elseif($data === '')
    out("Keine BoxInfos erhalten");
   else
    out(errmsg(0,'request'));
  }
  elseif(ifset($val['gip'])) {				// Get Extern IP
   if(ifset($cfg['help']))
    out("$self <fritz.box> [mode:GetIP|gip] <filter>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:getip filter:ipv4
$self fritz.box gip
$self getip
$self gip dns" : ""));
   elseif($array = getexternalip()) {
    if($var = getArg('filter','/[-\w]+/'))
     $array = preg_array("/$var[0]/i",$array,3);
    foreach($array as $key => $var)
     $array[$key] = "$key:|$var";
    out("{{{tt}".implode("\n",$array)."}}");
   }
   elseif($var = errmsg(0,'getexternalip'))
    out($var);
   else
    out("UPnP Deaktiviert oder keine IP-Adressen erhalten");
  }
  elseif(ifset($val['i'])) {				// Info (Intern)
   if(ifset($cfg['help'])) {
    out("$self [mode:Info|i] <func|Datei> <Parameter>\n
Funktionen (func):\n{{{tt}
Arg <arg>|-|Geparste Argumente ausgeben
Cat [file]|-|Dateiinhalt mit Terminal-Charset ausgeben
Dir <dir>|-|Verzeichnis auflisten
Echo <str>|-|Parameter ausgeben
ExTension|-|Verfgbarkeit der PHP-Erweiterungen anzeigen
Globals|-|Alle PHP-Variabeln ausgeben
OpenSsl|-|Verfgbarkeit der OpenSSL-Bibliotek ausgeben
PanGramm|-|Kodierungstest mit Umlauten und ASCII-Art
PHP|-|PHPInfo() ausgeben
PhpIni <find:Suchname>|-|Werte aus der PHP.ini ausgeben
StrfTime <str> <time>|-|Alle Zeit-Angaben von strftime ausgeben
UpDate <opt:Check>|-|FB_Tools ber das Internet aktualisieren
WebGet [url] <file\|:>|-|Datei herunterladen und HTTP-Header ausgeben
<Datei>|-|Verschiedene Hashes von einer Datei berechnen}}".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self info
$self info cat fb_config.php
$self info dir
$self info echo \"Hello World!\"
$self info fb_config.php
$self info update
$self info wg https://".implode(',',$cfg['uplink'])."php.gz -ua:Wget/1.10
$self info strftime '%d.%m.%y %H:%M:%S'
$self i pg -c:ansi
$self i -d" : ""));
    if(!$cfg['help'] or $cfg['help'] === true)
     $cfg['help'] = -1;
    $opts .= "Update:|-f|Force|Fehler Ignorieren";
   }
   elseif($arg = getArg('func','/^(?:(?P<php>PHP)|(?P<pi>pi|phpini)|(?P<g>G(?:LOBALS)?)|(?P<pg>P(?:anGramm|g))|(?P<ud>U(?:pdate|d))|(?P<c>c|Cat)|(?P<e>e|Echo)
	|(?P<wg>wg|W(eb)?Get)|(?P<st>st|StrfTime)|(?P<os>os|OpenSSL)|(?P<et>et|ExTension)|(?P<a>a|Arg)|(?P<t>t|Test)|(?P<d>d|Dir))$/ix')
	or ifset($val['i'],'/upgrade|ug/')) {
    if(ifset($arg['pg']))				// Pangramm mit Kitty
     out(wordwrap("Welch fieser Katzentyp qult da se Vgel blo zum Jux?\n",min((($cfg['wrap']) ? (int)$cfg['wrap'] : 80),42)).$cfg['zlib']['inflate'](base64_decode(
	"TY0xDsMwDAP3APkDN9qAaC/ZDOQD/YIRa+2epUCQt1dOl2ohJR4o4H+u/tNhZpLMxrrciTuwe36Sal5E5/QqQFNrk0JFAAlPwWWbEHuWjVJajzuc4roQxwQOOMD4QKZRQyIX+8h4vc/z8wU")));
    elseif(ifset($arg['c']) and $var = getArg('file') and file_exists($var))	// Cat
     out(file_contents($var));
    elseif(ifset($arg['os']))				// OpenSSL
     out(($var = cfgdecrypt(0,'openssl') and ifset($var['openssl'])) ? $var['openssl'] : "Nicht vorhanden - Kein SSL/HTTPS mglich!");
    elseif(ifset($arg['d']))				// Dir
     out(implode("\n",(array)listDir(getArg('dir'),false,(int)getArg('opt'))));
    elseif(ifset($arg['t']))				// Test{}
     out(";-)");
    elseif(ifset($arg['a'])) {				// Args
     $array = array('system' => $argv, 'consign' => $cfg['argk'], 'arguments' => $cfg['arg'], 'available keys' => $cfg['argc'], 'labeled' => $cfg['args']);
     $var = getArg('arg','/^(?:(arg[cksv]?|'.implode('|',array_keys($array)).')|\w+)$/i');
     out((isset($cfg['arg'][$var[0]])) ? $cfg['arg'][$var[0]] : ((isset($cfg[$var[1]])) ? $cfg[$var[1]] : ((isset($array[$var[1]])) ? $array[$var[1]] : $array)));
    }
    elseif(ifset($arg['php'])) {			// PHPInfo()
     ob_start();
     phpinfo();
     $data = ob_get_contents();
     ob_end_clean();
     out($data);
    }
    elseif(ifset($arg['pi']) and $array = ini_get_all()) {// PHP.ini
     $preg = ($var = getArg('find')) ? "/".preg_quote($var,'/')."/i" : false;
     $ini = array();
     foreach($array as $key => $var) {
      $main = (preg_match('/^(\w+)\./',$key,$val)) ? $val[1] : "PHP";
      $key = preg_replace('/^\w+\./','',$key);
      if(!$preg or ifset($main,$preg) or ifset($key,$preg))
       foreach(array('global_value','local_value','access') as $val) {
        $vas = ($val == 'access') ?(($var[$val]&4) ? 's' : '-').(($var[$val]&2) ? 'p' : '-').(($var[$val]&1) ? 'u' : '-') : $var[$val];
        $ini[$main][$key][] = $vas;
       }
     }
     foreach($ini as $key => $var) {
      foreach($var as $k => $v)
       $var[$k] = trim("$k|$v[2]|".(($v[0] != $v[1]) ? (($v[0]) ? "$v[0] \| $v[1]" : $v[1]) : $v[0]));
      $ini[$key] = strtoupper("||\n[$key]\n").implode("\n",$var);
     }
     cfgdecrypt(0,'php');
     out($cfg['php'][5]."\n{{{tt}".implode("\n",$ini)."}}");
    }
    elseif(ifset($arg['g'])) {				// PHP-GLOBALS
     $_CLASS = get_declared_classes();
     $_CONSTANT = get_defined_constants();
     $_EXTENSION = get_loaded_extensions();
     $_FUNCTION = get_defined_functions();
     $_PHPINI = ini_get_all();
     out($GLOBALS);
    }
    elseif(ifset($arg['et'])) {				// PHP-Extension
     $ext = cfgdecrypt();
     if(isset($cfg['mods']))
      $ext = array_merge($ext,$cfg['mods']);
     $array = array();
     foreach($ext as $key => $var) {
      $var = (is_array($var)) ? realpath($var[0]) : ((is_string($var)) ? realpath($var) : 'Intern oder bereits geladen');
      if($key == 'openssl')
       $array[$key] = OPENSSL_VERSION_TEXT;
      elseif($key == 'mcrypt') {
       ob_start();
       phpinfo();
       $data = ob_get_contents();
       ob_end_clean();
       $array[$key] = (preg_match('/mcrypt.*?version.*?(\d[\d\w.]+)/si',$data,$val)) ? $val[1] : '-/-';
      }
      elseif(ifset($key,'/(aes\d*|sha(256|512))/'))
       $array[$key] = preg_match('/\/\/\s*\b[\w-]+ ([\d\.]+)/',file_contents($var),$val) ? $val[1] : '-/-';
      else
       $array[$key] = "Unbekannt";
      $array[$key] = "$key||".$array[$key]."||$var";
     }
     out(($array) ? "{{{tt}".implode("\n",$array)."}}" : "Keine Erweiterungen gefunden!");
    }
    elseif(ifset($arg['e'])) {				// Echo
     $var = getArg('str',array(),0) or $var = getArg(0,array());
     if($cfg['dbug']) {
      ob_start();
      var_dump($var);
      $data = ob_get_contents();
      ob_end_clean();
      dbug($data);
     }
     else
      out(trim(implode(' ',$var)));
    }
    elseif(ifset($arg['st'])) {				// strftime
     $arg = getArg('str');
     $time = ($var = getArg('time') and $var = strtotime($var)) ? $var : time();
     if($arg)
      out(strftime(trim($arg),$time));
     else {
      $out = $array = array();
      for($a=1; $a <= 26; $a++)		// Alle Buchstaben
       for($b=0; $b < 2; $b++)		// Gross und kleinschreibung
        for($c=0; $c < 2; $c++) {	// Positiv und Negativ
         $key = (($c) ? '-' : "").chr($a + 64 + 32 * $b);
         $var = strftime("%$key",$time);
         $val = str_replace(array("\n","\t"),array('\n','\t'),str_pad("%$key",4," ")."= $var");
         if($var and !ifset($var,"/%?$key/") and !ifset($key,"/-?$var/") and (!$c or preg_replace('/^%-?(\w)\s*/','%$1  ',$val) != $array[substr($key,1)])) {
          $array[$key] = str_replace('|','\|',$val);
         }
        }
//	ksort($array);
      $array = array_values($array);
      for($a=0; $a < ceil(count($array)/2); $a++)
       $out[] = $array[$a]."|".$array[$a+ceil(count($array)/2)];
      out("{{{tt}".implode("\n",$out)."}}\n\nWeitere Hinweise finden Sie auf strftime.org");
     }
    }
    elseif(ifset($arg['wg']) and $var = getArg('url','/^(?:(https?):\/\/)?([.\w-]+)(?::(\d+))?(.*)$/i')) {	// WGet
     $opt = array(
	'host' => $var[2],
	'sock' => ($var[1]) ? $var[1] : 'auto',
	'page' => ($var[4]) ? $var[4] : '/',
	'method' => ($file = getArg('file')) ? (($file == ':') ? 'GET' : 'GET-save:'.$file) : 'GET-save:./');
     $opt['port'] = ($var[3]) ? $var[3] : ((strlen($opt['sock']) == 5) ? 443 : 80);
     out(($val = request($opt)) ? $val : (($cfg['http']) ? $cfg['http'] : "Aufruf fehlgeschlagen"));
    }
    elseif(ifset($cfg['uplink'],4) and (ifset($arg['ud']) or ifset($val['i'],'/upgrade|ug/i'))) {	// FB_Tools Update
     foreach(array(443,80) as $port)
      if($fbnet = request('GET-array',$cfg['uplink'][1].$cfg['uplink'][2].'.md5',0,0,$cfg['uplink'][0],$port))
       break;
     if($fbnet) {	// Update-Check
      if(preg_match("/((\d\d)\.(\d\d)\.(\d{4}))\s[\d:]+\s*\((\w+)\s([\d.]+)\)(?:.*?(\w+)\s\*\w+\.$cfg[ext](?=\s))?/s",$fbnet[1],$up)) {
       $val = ($var = getArg('opt','/^(C(?:heck)?)$/i')) ? $var : false;
       if(intval($up[4].$up[3].$up[2]) > $cfg['ver'][9] and floatval($up[6]) > $cfg['ver'][10] or ifset($cfg['opts']['f'])) {
        out("Ein Update ist verfgbar: $up[5] $up[6] vom $up[1]");
        if(!$val[1] or ifset($cfg['opts']['f'])) {
         out("Installiere Update ... ");
         $manuell = "!\nBitte installieren Sie es von http://{$cfg['uplink'][0]}/.dg manuell!";
         if(ifset($up[7]) and $up[8] = @request('GET',$cfg['uplink'][1].$cfg['uplink'][2].".$cfg[ext].gz",0,0,$cfg['uplink'][0],80)) {
          $rename = preg_replace('/(?=(\.\w+)?$)/',"_{$cfg['ver'][2]}.bak",$script,1);	// Neuer Name fr alte Version
          if($var = $cfg['zlib']['decode']($up[8]) and hash('md5',$var) == $up[7] and @rename($script,$rename)) {	// Update ab PHP5
           file_contents($script,$var);
           @chmod($script,intval(fileperms($rename),8));
           out("abgeschlossen!");
          }
          else
           out("fehlgeschlagen$manuell");
         }
         else
          out("Automatisches Update ist nicht verfgbar$manuell");
        }
       }
       else {
        out("Kein neues Update verfgbar!");
        if(ifset($up[6],$cfg['ver'][10]) and $up[7] != hash('md5',file_contents($script)))	// MD5-Check
         out("Hinweis: $Self wurde verndert");
       }
       if(!@touch($script,time() & ~1)) {				// Aktuelles Datum setzen
        fclose(fopen($script,'a'));
        if(file_exists($var = dirname($script)."/$cfg[fbtp]") and @file_contents($var = "$var/.touch","touch"))
         @unlink($var);
       }
      }
      else								// fb_tools.md5 nicht verfgbar
       out("Update-Server sagt NEIN!");
      if(ifset($fbnet['X-Cookie']))					// Coolen Spruch ausgeben
       out("\n".$fbnet['X-Cookie']);
     }
     else								// Kein Netzwerk/Internet verfgbar
      out("Computer sagt NEIN!");
    }
    else
     out("Unerwartete Parameter bergeben!");
   }
   else {						// FB_Tools-Version, PHP Kurzinfos und Hashes ausgeben
    $var = array("PHP {$cfg['php'][0]}/{$cfg['php'][2]} ({$cfg['php'][4]} Bit)",$cfg['php'][1]);
    out($cfg['ver'][0]."\n".implode(($cfg['wrap'] and strlen($var[0].$var[1])+3 < $cfg['wrap']) ? " - " : "\n",$var)
	."\nTerminal-Infos: Breite: $cfg[wrap], Zeichensatz: {$cfg['char'][0]}, OS: ".strtoupper($cfg['os']));
    if($file = getArg('func') and file_exists($file)) {	// Hashes berechnen
     $a = $b = 0;
     $hash = array();
     $size = filesize($file);
     $algo = array('crc32b','md5','sha1','sha256','sha512');
     if(function_exists('hash_init') and $fp = fopen($file,'r')) { // Hash direkt beim Laden erstellen
      foreach($algo as $var)		// Init Hashes
       $hash[$var] = hash_init($var);
      while(!feof($fp)) {		// Read Data
       $data = fread($fp,$cfg['sbuf']);
       foreach($hash as $var)		// Calc Hashes
        hash_update($var,$data);
       $a += strlen($data);		// Fortschritts-Anzeige berechnen
       $c = floor($a / max($a,$size) * max($cfg['wrap']-1,10)) - $b;
       dbug(str_repeat(".",$c),0,10);	// Download-Anzeige
       $b += $c;
      }
      dbug("\n",0,8);			// Download-Anzeige abschlieen
      foreach($hash as $key => $var)	// Finalize Hashes
       $hash[$key] = hash_final($var);
      fclose($fp);
     }
     else
      foreach($algo as $var)		// Daten laden und dann ein Hash davon berechnen
       $hash[$var] = hash($var,file_contents($file,0));
     $out = "File:|$file\nSize:|".number_format($size,0,0,'.')." Bytes\n";
     foreach($hash as $key => $var)	// Hashes ausgeben
      if($var = preg_replace('/(?<=\w)(?=(\w{8})+$)/i',' ',$var))
       $out .= preg_replace('/\D$/','',strtoupper($key)).":|$var\n";
     out("{{{tt}$out}}");
    }
   }
  }
  elseif(ifset($val['e'])) {				// Ereignisse
   if(ifset($cfg['help'])) {
    out("$self <fritz.box> [mode:Ereignisse|e] <file> <filter> <from:zeit> <to:zeit>\n
Folgende Filter sind Mglich: alle, telefon, internet, usb, wlan, system".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:Ereignisse file:event-internet.csv filter:internet -cs:;
$self fritz.box Ereignisse event.csv
$self fritz.box e -pw:secret
$self fritz.box e logs-%y%m%d.log alle -lf" : ""));
    if(!$cfg['help'] or $cfg['help'] === true)
     $cfg['help'] = -1;
    $opts .= "Ereignisse:|-cs:|<Seperator>|CSV-Separator festlegen ( )
|-lf||Schreibt die Daten als Logfile";
   }
   elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {	// Einloggen
    $pfile = getArg('file');
    $file = (strpos($pfile,'%') !== false) ? strftime($pfile) : ((ifset($file,'/^[:*]$/')) ? false : $pfile);
    $filter = ($var = getArg('filter','/^(a(lle)?|t(elefon)?|i(nternet)?|u(sb)?|w(lan)?|s(ystem)?)$/i')) ? strtr(strtolower($var[0]),
	array('a' => 'alle', 't' => 'telefon', 'i' => 'internet', 'u' => 'usb', 'w' => 'wlan', 's' => 'system')) : 'alle';
    $from = ($var = getArg('from') and $val = strtotime($var) and $val != -1) ? $val : false;
    $to = ($var = getArg('to') and $val = strtotime($var) and $val != -1) ? $val : false;
    $sep = (ifset($cfg['opts']['cs'])) ? $cfg['opts']['cs'] : " ";	// Seperator fr CSV-Dateien
    $psep = preg_quote($sep,'/');
    $count = 0;	// 1	   2		  3	     4		  5
    $preg = array("(\d\d)\.(\d\d)\.(?:20)?(\d\d)$psep([\d:]+)$psep(.*)\s*$/","20$3-$2-$1 $4");
    if($data = getevent($filter,$sep)) {
     $array = explode("\r\n",trim($data));				// Ereignisse holen
     $event = array();							// Zeitbereich auswhlen
     foreach($array as $key => $var)
      if($time = strtotime(preg_replace("/^$preg[0]",$preg[1],$var))
		and (!$from or $time >= $from) and (!$to or $time <= $to))
       $event["$time#$key"] = $var;
     $data = implode("\r\n",$event);
     dbug(count($event).((count($event) != count($array)) ? "/".count($array) : "")." Event(s) wurden ausgelesen");
     if($file and ifset($cfg['opts']['lf'])) {				// Logmodus
      dbug("Ereignisse im Logfile-Modus speichern");
      $last = -1;
      foreach($event as $key => $var) {
       if($file != ($val = (strpos($pfile,'%') !== false) ? strftime($pfile,intval($key)) : ((ifset($file,'/^[:*]$/')) ? false : $pfile)))
        $file = $val;
       if(file_exists($file))
        $date = ($data = file_contents($file,-256) and preg_match("/$preg[0]",$data,$val)) ? strtotime(preg_replace("/^.*?$preg[0]s",$preg[1],$data)) : 0;
       else {
        $val = array(0,$var);
        $date = 0;
       }
       if(intval($key) > $date or intval($key) == $last) {		// or intval($key) == $date and $var != $val[1]
        file_contents($file,"$var\r\n",8);				// Ereignisse speichern
        $last = intval($key);
        $count++;
       }
      }
     }
     elseif($file) {							// Ereignisse normal in Datei speichern
      dbug("Ereignisse normal speichern");
      if(file_exists($file)) {
       $date = ($data = file_contents($file,-256) and preg_match("/$preg[0]",$data)) ? strtotime(preg_replace("/^.*?$preg[0]s",$preg[1],$data)) : 0;
       foreach($event as $key => $var)
        if(intval($key) <= $date)
         unset($event[$key]);
      }
      file_contents($file,implode("\r\n",$event)."\r\n",8);		// Ereignisse speichern
      $count = count($event);
     }
     elseif($event)							// Ereignisse auf den Bildschirm ausgeben
      out("{{{tt}".preg_replace(array('/\|/',"/^([\d.]+{$psep}[\d:]+)$psep(.*?)\s*$/m"),array('\\|','$1|$2'),implode("\n",$event))."}}");
     if($count)
      out("Es wurde".(($count == 1) ? " 1 neuer Eintrag" : "n $count neue Eintrge")." gespeichert");
    }
    else
     out(errmsg(0,'getevent'));
    if(!ifset($cfg['bsid']))					// Ausloggen
     logout($sid);
   }
   else
    out(errmsg(0,'login'));
  }
  elseif(ifset($val['k'])) {				// Konfig
   if(ifset($cfg['help']) or !getArg(true))
    out("$self <fritz.box> [mode:Konfig|k] [func:Funktion] <Datei|Ordner> <Kennwort>\n
Funktionen (func):\n{{{tt}
ExPort|<of:file> <pass>|-|Konfig exportieren(1)
ExPort-DeCrypt|<of:file> <pass>|-|Konfig entschlsseln und exportieren(1,3)
ExTrakt|<of:dir> <pass>|-|Konfig entpackt anzeigen/exportieren(1)
ExTrakt-DeCrypt|<of:dir> <pass>|-|Konfig entpackt entschl./anz./exp.(1,3)
File|[if:file] <of:dir>|-|Konfig aus Datei entpacken und anzeigen(2)
File|[if:dir] [of:file]|-|Konfig-Ordner in Datei zusammenpacken(2)
File-CalcSum|[if:file/dir] [of:file]|-|Konfig-Datei/Ordner fr Import Vorbereiten(2)
File-JSON|[if:file] [of:file]|-|Konfig-Daten in JSON konvertieren(2)
File-DeCrypt|[if:file] [pass:list/file]||<of:file> - Konfig-Daten entschlsseln(2,3,4)
ImPort|[if:file/dir] <pass>|-|Konfig importieren(1)
ImPort-CalcSum|[if:file/dir] <pass>|-|Vernderte Konfig importieren(1)}}\n
(1) Anmeldung mit Logindaten erforderlich / (2) Ohne Fritz!Box nutzbar
(3) Eins von (php_openssl, php_mcrypt, aes.php, aes_4.class.php) erforderlich
(4) Mehrere Angaben mglich (pass:foo pass:bar pass:test oder pass[/]:foo/bar/test)
[ ] Pflicht | < > Optional | ( ) Auswahl
Ab OS 6.69 muss die Sicherheits-Besttigungsfunktion deaktiviert werden".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box konfig export
$self fritz.box konfig extrakt
$self konfig file fritzbox.export.gz
$self konfig file-decrypt fb.export geheim fbdc.export -d
$self fritz.box konfig extract archiv.tar.gz
$self k fcs Export-Ordner fritzbox.export
$self fritz.box konfig import \"fb 7170.export\"
$self fritz.box konfig import archiv.tar.gz
$self fritz.box k ipcs \"FRITZ.Box Fon WLAN 6360 85.04.86_01.01.00_0100.export\"
$self k fdc if:fb7390_nopass.export pass:admin123 pass:11:23:58:13:21:34 pass:passwd.txt
$self k fdc if:fb7530_nopass.export of:fb7530_decrypt.export pass:K175.678.30.000.196-98:9B:CB:30:01:96" : ""));
   elseif($mode = getArg('func','/^(					# 1:Alle
	|i(p|mport)(cs|-calcsum)?					# 2:Import 3:CalcSum
	|e(p|xport)(?:(dc|-de(?:crypt|code))?)				# 4:Export 5:DeCrypt
	|(et|(?:extra[ck]t))?(?:(dc|-de(?:crypt|code))?)		# 6:Extrakt 7:DeCrypt
	|(f(?:ile)?)(?:(cs|-calcsum)?|(dc|-de(?:crypt|code))?|(-?json)?)# 8:File 9:CalcSum 10:DeCrypt 11:JSON
		)$/ix')) {
    dbug($mode,3);					// Debug Parameter
    $mode = array_pad($mode,12,null);
    $file = getArg('if');
    if($pw = getArg('pass',array()))			// Multipass ;-)
     $pass = reset($pw);
    $save = getArg('of');
    if(($mode[5] or $mode[7] or $mode[10]) and !cfgdecrypt()) {
     out("Die Entschlsselung wird von ihren System nicht untersttzt!\nBitte Installieren Sie die AES-Scripte aus dem Archiv: fb_Tools.7z\n\n");
     $mode[5] = $mode[7] = $mode[10] = false;
    }
    if(($mode[2] or $mode[4] or $mode[6])) {		// Login Optionen
     if($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {
      $file = getArg('of',false,$file);			// Arg[of]
      if(($mode[5] or $mode[7]) and !$pass)		// Im DeCode-Modus kein leeres Kennwort zulassen
       $pass = (ifset($cfg['pass'],'/^[ -~]+$/')) ? $cfg['pass'] : 'geheim';
      if($mode[4]) {					// Export
       if(is_dir($file)) {				// Im Ordner schreiben
        makedir($file);					// Verzeichnis erstellen
        $file = false;
       }
       if($mode[5] and $pass and $data = cfgexport('array',$pass) and $data[1]) {	// Exportieren mit Entschlsselten Benutzerdaten
        if($data[1] and $data[1] = cfgdecrypt($data[1],$pass)) {
         out(showaccessdata($data[1]));
         saverpdata($file,$data,'file.export');
        }
        else
         out(errmsg(0,'cfgdecrypt') || errmsg(0,'cfgexdport') || errmsg(0,'request'));
       }
       elseif(!ifset($data))					// Export direkt File
        out(cfgexport(($file) ? $file : true,$pass) ? "Konfiguation wurde erfolgreich exportiert" : errmsg(0,'request'));
       else
        out(($var = errmsg(0,'request')) ? $var : "Keine Konfig erhalten - Mglichlichweise ist noch die Sicherheits-Besttigungsfunktion aktiviert?");
      }
      elseif($mode[6]) {					// Extrakt
       if($data = cfgexport('array',$pass) and $data[1]) {	// Konfigdaten holen
        $mod = ($file) ? ((preg_match($cfg['ptar'],$file,$var)) ? ((ifset($var[1])) ? 3 : 2) : 1) : 0;
        if($mod == 1)
         makedir($file);					// Verzeichnis erstellen
        if($mode[7] and $pass and $data[2] = cfgdecrypt($data[1],$pass,$sid))	// Konfig Entschlsseln
         out(cfginfo($data[2],$mod,$file,showaccessdata($data[2])));
        else
         out(cfginfo($data[1],$mod,$file));
       }
       else
        out(($var = errmsg(0,'request')) ? $var : "Keine Konfig erhalten - Mglichlichweise ist noch die Sicherheits-Besttigungsfunktion aktiviert?");
      }
      elseif($mode[2] and $file and file_exists($file))		// Import-Konfig
       out((cfgimport($file,$pass,$mode[3])) ? "Konfig wurde hochgeladen und wird nun bearbeitet" : errmsg(0,'cfgimport'));
      else
       out("$file kann nicht geffnet werden!");
      if(!ifset($cfg['bsid']))
       logout($sid);
     }
     else
      out(errmsg(0,'login'));
    }
    elseif($file = getArg('if',false,$file) and $mode[8] and !$mode[10] and !$mode[11] and is_file($file) and $data = file_contents($file) and preg_match('/^\*{4}\s+\w+.*CONFIGURATION EXPORT/',$data)) {	// Converter-Modus File -> Dir
     $mod = ($save = getArg('of',false,$pass)) ? ((preg_match($cfg['ptar'],$save,$var)) ? ((ifset($var[1])) ? 3 : 2) : 1) : 0;
     if($mod == 1 and (!file_exists($save) or !is_dir($save)) and $var = cfgcalcsum($data)) {
      out((file_contents($save,$var[2])) ? "Konfig-Checksumme ".(($var[0] == $var[1]) ? "ist korrekt!" : "wurde von $var[0] auf $var[1] korrigiert!") : "Konfig-Datei konnte nicht gespeichert werden!");
     }
     else
      out(($data = cfginfo($data,$mod,$save)) ? $data : "Defekte Konfig Export-Datei angegeben");
    }
    elseif($mode[8] and !$mode[10] and !$mode[11] and (preg_match($cfg['ptar'],$file,$val) and is_file($file) or is_dir($file))) {	// Converter-Modus Dir/Tar -> File
     if($val)
      $file = tar2array($file);
     out(($file) ? (($data = cfgmake($file,$mode[9],$save)) ? (($save) ? $data : cfginfo($data)) : "Kein Konfig Export-Archiv/Verzeichnis angegeben") : errmsg(0,'tar2array'));
    }
    elseif($mode[8] and $mode[10] and !$mode[11] and $pass and is_file($file) and $data = (preg_match($cfg['ptar'],$file)) ? cfgmake(tar2array($file)) : file_contents($file)) {	// Kennwrter Entschlsseln
     if(preg_match('/^\*{4} .*? CONFIGURATION EXPORT/',$data)) {
      foreach($pw as $pass) {
       if($fp = (file_exists($pass)) ? $cfg['zlib']['open']($pass,'r') : false) {// Passwordliste einlesen
        $cfg['errmute'] = true;							// Fehlermeldungen pausieren
        dbug("Lese Password-Liste: $pass");
       }
       while($pwd = ($fp) ? $cfg['zlib']['gets']($fp,$cfg['sbuf']) : $pass)	// Password-Argument oder Passwordliste durchgehen
        if($pwd = preg_replace('/[\r\n]+/','',$pwd)) {				// Password von cr/lf bereinigen
         dbug(".",0,10);
         if(isset($cfg['error']['cfgdecrypt']))					// Alte Fehlermeldung entfernen
          unset($cfg['error']['cfgdecrypt']);
         if($dcdata = cfgdecrypt($data,$pwd)) {					// Konfig mit Kennwort entschlsseln
          dbug("\nKonfig-Kennwort gefunden: $pwd",0,8);
          if($save) {
           if(preg_match('/^(.*?)[\\\\\/]$/',$save,$var)) {			// Verzeichnis erstellen
            makedir($save);
            $mod = 1;
           }
           elseif(preg_match($cfg['ptar'],$save,$var))
            $mod = (ifset($var[1])) ? 3 : 2;
           else {
            file_contents($save,$dcdata);					// Entschlsselte Konfig sichern
            $mod = 0;
           }
          }
          else
           $mod = 0;
          out(cfginfo($dcdata,$mod,$save,showaccessdata($dcdata)));		// Daten als Text Prsentieren
          break;
         }
        }
       dbug("",0,8);
       if($fp)
        $cfg['zlib']['close']($fp);
      }
      $cfg['errmute'] = false;							// Fehlermeldungen pausieren
      if(!$dcdata)
       out(errmsg(0,'cfgdecrypt'));

     }
     else
      out("Keine Konfig-Datei angegeben!");
    }
    elseif($mode[8] and $mode[11] and is_file($file) and $pass = getArg('of',false,$pass))	// JSON Konverter (File -> File)
     if(function_exists('json_encode'))
      if($data = file_contents($file) and $array = konfig2array($data))
       if($data = json_encode($array) and file_contents($pass,$data))
        out("Konfig-Datei erflogreich in JSON konvertiert");
       else
        out("JSON_Encode von PHP {$cfg['php'][0]} ist fehlgeschlagen");
      else
       out("Keine Konfig-Datei");
     else
      out("JSON wird von PHP {$cfg['php'][0]} nicht untersttzt");
    else
     out("Parameter-Ressourcen zu Konfig $mode[0] nicht gefunden oder nicht korrekt angegeben");
   }
   else
    out("Unbekannte Funktionsangabe fr Konfig");
  }
  elseif(ifset($val['led'])) {				// LED
   if(!login(false,555))
    out("Diese Funktion wird nicht von der Fritz!OS Firmware untersttzt!");
   elseif(ifset($cfg['help']) or !$var = getArg('func','/([ao]n)|(off|aus)|(test)/i'))	// Hilfe Ausgeben
    out("$self <fritz.box> [mode:LED] [func:on|off|an|aus|test]".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:led func:off
$self fritz.box led test" : "")."\n");
   elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {			// Login durchfhren
    if($var[1] or $var[2]) {
     dbug("Schalte LED a".(($var[1]) ? "n" : "us"));
     request('POST','/system/led_display.lua',"sid=$sid&apply=&led_display=".(($var[2]) ? 2 : 0));	// LED schalten: an / aus
    }
    elseif($var[3]) {									// LED Status Abfragen
     dbug("Ermittle LED-Status");
     if($val = request('GET','/query.lua',"sid=$sid&led=box:settings/led_display") and $var = ifset($val,'/"led":\s*"(\d+)"/'))
      out("LED ist a".(($var[1]) ? "us" : "n"));					// LED Status ausgeben
     else
      out("LED-Status nicht ermittelbar!");
    }
    if(!ifset($cfg['bsid']))								// Abmelden
     logout($sid);
   }
   else
    out(errmsg(0,'login'));								// Login fehlgeschlagen
  }
  elseif(ifset($val['lio'])) {				// Manuelles Login / Logout
   if(ifset($cfg['help'])) {
    out("$self <http://user:pass@fritz.box:port#passui> [mode:LogIn|LogOut|LogInTest|li|lo|lit] <file:SID> <-s:sid|file>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self https://user:pass@example.org:12345#password mode:login -o:sid
$self password@fritz.box login sid
$self login -o:sid -p:https -fb:example.org -pt:12345 -un:user -pw:pass -ui:password
$self fritz.box login -pw:password -o:sid
$self fritz.box logout -s:sid
$self fritz.box logout -s:0123456789abcdef" : ""));
    if(!$cfg['help'] or $cfg['help'] === true)
     $cfg['help'] = -1;
   }
   elseif(preg_match('/l(?:og)?(?:(in?)(-?t(?:est)?)?|(o(?:ut)?))/i',$val['lio'],$var)) {
    if(ifset($var[1]) and !ifset($cfg['sid'])) {		// Login (User/Pass)
     $sid = login();
     if(ifset($var[2])) {					// Test
      if($sid) {
       logout($cfg['sid']);
       out("Login war erfolgreich");
      }
      else
       out("Login ist fehlgeschlagen");
     }
     else {
      if($file = getArg('file'))
       file_contents($file,serialize(preg_array('/^(host|port|sock|fiwa|sid)$/',$cfg,3)));
      out($sid);
     }
    }
    elseif(ifset($var[3]) and ifset($cfg['sid']))		// Logout
     logout($cfg['sid']);
    elseif(ifset($cfg['sid']))					// Login (SID)
     out(login(0,0,0,$cfg['sid']));
   }
  }
  elseif(ifset($val['rc'])) {				// ReConnect
   if(ifset($cfg['help']))
    out("$self <fritz.box> [mode:ReConnect|rc]".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self mode:reconnect
$self fritz.box rc" : ""));
   else
    out(($var = forcetermination()) ? "Reconnect ausgefhrt" : errmsg(0,'getexternalip'));
  }
  elseif(ifset($val['sh'])) {				// SmartHome
   $var = getArg('func','/([ao]n)|(off|aus)|(switch|schalt)|(info|set|test)|(list|csv|json)/i');
   $ain = getArg('ain');# 1	  2	    3		    4		    5
   $set = ($val = getArg('hkr','/^((([8-9]|1\d|2[0-8])(\.5)?)?C?|spar|komfort|an|aus)$/i')) ? $val[0] : false;
   $file = getArg('file');
   if(!login(false,669))
    out("Diese Funktion wird nicht von der Fritz!OS Firmware untersttzt!");
   elseif(ifset($cfg['help']) or !$var) {				// Hilfe Ausgeben
    out("$self <fritz.box> [mode:SmartHome|sh] [func:an|aus|csv|info|json|list|off|on|schalt|set|switch|test] <ain> <hkr> <file>\n
Funktionen (func):\n{{{tt}
list||-|bersicht aller Aktoren ausgeben
csv|<file:Datei>|-|bersicht aller Aktoren als CSV-Datei speichern
json|<file:Datei>|-|Vollstndige Aktorenliste als JSON-Datei speichern
info|[ain:Aktor]|-|Informationen ber Aktor ausgeben
on/an|[ain:Aktor]|-|Aktor einschalten
off/aus|[ain:Aktor]|-|Aktor ausschalten
switch/schalt|[ain:Aktor]|-|Aktor umschalten
test|[ain:Aktor]|-|Schaltzustand des Aktors abfragen
set|[ain:Aktor]||[hkr:8-28\|an\|aus\|komfort\|spar] - Temperatur des HeizkrperRegler setzen}}".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:smarthome func:test ain:11:23:58:13:21:34
$self fritz.box smarthome an Lampe
$self fritz.box sh set 01234-0001234 23
$self fritz.box sh json file.json" : "")."\n");
    if(!$cfg['help'] or $cfg['help'] === true)
     $cfg['help'] = -1;
    $opts .= "SmartHome:|-cs:|<Seperator>|CSV-Separator festlegen (;)
|-f||Aktor direkt per AIN Schalten (Fehler Ignorieren)";
   }
   elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {	// Login durchfhren
    $val = strtolower($var[0]);
    if(ifset($var[5])) {						// list / csv / json
     $set = false;
     if(ifset($val,'/csv|json/')) {					// Dateiname fr csv/json ermitteln
      if(!$file and $ain) {
       $file = $ain;
       $ain = false;
      }
      if(ifset($cfg['opts']['cs']))					// CSV-Separator festlegen
       $set = $cfg['opts']['cs'];
     }
     else
      $file = false;
     if($data = smarthome($val,0,$set)) {				// Smarthome Infos anfordern
      if($file)
       out((file_contents($file,$data)) ? "$file wurde erfolgreich gespeichert!" : "$file konnte nicht geschrieben werden!");
      else
       out("{{{tt}".utf8($data)."}}");					// Bildschrimausgabe
     }
     else
      out(errmsg(0,'smarthome'));					// Fehler
    }
    elseif(($var[1] or $var[2] or $var[3]) and $ain)			// on / off / switch
     out(($data = smarthome(($var[1]) ? 'on' : (($var[2]) ? "off" : "trip"),$ain,ifset($cfg['opts']['f']))) ? utf8($data) : errmsg(0,'smarthome'));
    elseif($var[4] and $ain)						// info / set / test
     out(($data = smarthome($val,$ain,$set)) ? "{{{tt}".utf8($data)."}}" : errmsg(0,'smarthome'));
    else
     out("Unbekannte Argumente angegeben!");
    if(!ifset($cfg['bsid']))						// Abmelden
     logout($sid);
   }
   else
    out(errmsg(0,'login'));						// Login fehlgeschlagen
  }
  elseif(ifset($val['sd'])) {				// Supportdaten
   if(ifset($cfg['help'])) {
    out("$self <fritz.box> [mode:SupportDaten|sd] <file:Datei|Ordner|.> <func:ExTrakt|Datei>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:supportdaten file:support.txt func:extrakt
$self fritz.box supportdaten . -tm
$self fritz.box supportdaten sd-ordner extrakt -d
$self fritz.box sd -pw:geheim
$self sd file:support.txt func:support.tar" : ""));
    if(!$cfg['help'] or $cfg['help'] === true)
     $cfg['help'] = -1;
    $opts .= "SupportDaten:|-tm:|<on/off>|Schaltet Telemetriedaten an/aus";
   }
   else {
    $file = getArg('file');
    $et = getArg('func');
    $mode = ($file and preg_match($cfg['ptar'],$file,$var)) ? ((ifset($var[1])) ? 2 : 1) : 0;
    if(!$mode and $et and $file and makedir($file))			// Neues Verzeichniss erstellen
     $file = './';
    if(file_exists($et) and is_file($et) and $data = file_contents($et) and $text = supportdataextrakt($data,$mode,$file))
     out("\n$text\n");
    elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {
     $tm = ($var = ifset($cfg['opts']['tm'],'/^(?:[ao](?:(n)|(us|ff)))?$/i') and (ifset($var[1]) or !ifset($var[2])));
     if(ifset($et,'/^(extra[ck]t|et)$/i') and $cfg['fiwa'] >= 630) {	// Extrakt
      dbug("Hole Support-Daten zum extrahieren");
      if($data = supportdata(0,$tm) and $text = supportdataextrakt($data[1],$mode,$file))
       out("\n$text\n");
      elseif($data[1])
       file_contents((!preg_match($cfg['ptar'],$file) and substr($file,-1) != '/') ? $file : ((preg_match('/filename=(["\']?)(.*?)\1/i',$data['Content-Disposition'],$var))
        ? preg_replace('/[?\\\\\/<*>:"]+/','_',$var[2]) : "Supportdaten.txt"),$data[1]);
     }
     elseif(supportdata(($file) ? $file : './',$tm))
      out("Supportdaten wurden erfolgreich gespeichert");
     else
      out(errmsg(0,'supportdata'));
     if(!ifset($cfg['bsid']))
      logout($sid);
    }
    else
     out(errmsg(0,'login'));
   }
  }
  elseif(ifset($val['ss'])) {				// SystemStatus
   if(ifset($cfg['help']))
    out("$self <fritz.box> [mode:SystemStatus|Status|ss] <code>".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:systemstatus
$self fritz.box status
$self ss code:\"FRITZ!Box Fon WLAN 7390-B-010203-040506-733454-124607-147902-840522-22574-avm-de\"" : ""));
   else
    out(($var = supportcode(getArg('code'))) ? $var : errmsg(0,'supportcode'));
  }
  elseif(ifset($val['wh'])) {				// Wahlhilfe
   if(ifset($cfg['help']) or !getArg(true))
    out("$self <fritz.box> [mode:WahlHilfe|wh|Dial|d] [tel:Rufnummer] <fon:Telefon>\n
Telefon:
FON1-4 | ISDN/DECT | ISDN1-8 | DECT1-6 | (Keine Untersttzung fr IP-Telefone)".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box mode:wahlhilfe tel:0123456789 fon:isdn/dect
$self fritz.box dial \"#96*7*\"
$self fritz.box wh . -pw:geheim" : ""));
   elseif($sid = (ifset($cfg['bsid'])) ? $cfg['bsid'] : login()) {
    out((dial(getArg('tel'),getArg('fon'))) ? "Rufnummer wurde gewhlt" : errmsg(0,'dial'));
    if(!ifset($cfg['bsid']))
     logout($sid);
   }
   else
    out(errmsg(0,'login'));
  }
  elseif((ifset($val['rp']) or isset($val['tg'])) and ifset($cfg['a1st'])) {	// Test-Funktion
   if($val['rp'])					// Test RP
    out(($pass = getArg('pass','/^\w+$/')) ? ($val = getupnppath('LANConfigSecurity')) ? (($val = upnprequest($val[1],$val[0],'ResetWebUi',$pass)) ? $val : "Fehlgeschlagen!")
	: str_rot13($cfg['a1st'][4]) : "$self ".$cfg['a1st'][2].((ifset($cfg['help'],'/[ab]/i')) ? "\n\nBeispiele:\n$self fritz.box rp sonnig1337" : ""));
   elseif($val['tg'])					// Test TG
    if(cfgdecrypt(0,'openssl') and function_exists('openssl_encrypt')) {
     if($mac = getArg('maca','/^[\da-f]{2}(?:[:-][\da-f]{2}){5}$/i') and $a = ifset($cfg['a1st'][0],'/T\w+(?=\s)/')) {
      out($a[0],2);
      for($a=0, $b=2, $c=str_rot13('fyrrc'), $data = bin2hex(openssl_encrypt(hash('sha256',strftime('AVM/%s'),1),"AES-256-ECB",$mac[0],OPENSSL_RAW_DATA)); $a < 10; $a++) {
       call_user_func($c,$a);
       $b = ($b + 13 < $cfg['wrap']) ? $b + 8 : 10;
       out((($b == 10) ? ($a ? str_pad("\n",$b," ") : ": ") : ", ").substr(str_pad(hexdec(substr($data,$a*5,5)),6,0,STR_PAD_LEFT),0,6),2);
      }
      out("\n\n".str_rot13($cfg['a1st'][4]));
     }
     else
     out("$self ".$cfg['a1st'][3].((ifset($cfg['help'],'/[ab]/i')) ? "\n\nBeispiele:\n$self fritz.box tg 04:08:15:16:23:42" : ""));
    }
    else
     out("OpenSSL konnte nicht geladen werden!");
  }
  elseif(ifset($val['pi']) and !$cfg['help'] and ifset($cfg['uplink'],4)
	and $mode = getArg('func',$preg = '/^(?:(?P<c>check|c)|(?P<i>i(?:nstall)?)|(?P<l>liste?|l)|(?P<u>update|ud))$/i')) { // Plugin Update(1)
   if($array = getArg('opt',$preg))				// Mode durch zweiten Parameter erweitern
    foreach($array as $key => $var)
     if($var and !ifset($mode[$key]))
      $mode[$key] = $var;
   foreach(array(443,80) as $port)				// MD5-Liste fr Plugins anfordern
    if($fbnet = request('GET-array',$cfg['uplink'][1].$cfg['uplink'][3].'.md5',0,0,$cfg['uplink'][0],$port))
     break;
   if($fbnet and preg_match("/((\d\d)\.(\d\d)\.(\d{4}))\s([\d:]+)\s*\(([\w.-]+)\)/s",$fbnet[1],$up)	// Datum und Archivname
	and preg_match_all('/^(\w+)\s+([\d.]+)\s+\*([\w.-]+)\s*$/m',$fbnet[1],$list)) {			// MD5, Version und Pluginname
    if(ifset($mode['l']))					// Mode: List
     out($fbnet[1]);
    else {
     if((array)$pi = listDir($cfg['fbtg'],$cfg['fbta'],4))
      $pi = array_keys($pi);
     $out = $files = $install = $filter = $update = array();
     foreach($list[3] as $key => $plug)				// Plugins-Liste mit Lokalen Verzeichnis abgleichen
      if($file = preg_array('/'.preg_quote($plug,'/').'$/',$pi,2))
       $files = array_merge($files,$file);
      else
       $install[] = array('name' => $plug, 'version' => $list[2][$key], 'hash' => $list[1][$key]);
     foreach($files as $key => $file)				// Von vorhandenen Plugins alle Daten zusammensuchen
      if($data = file_contents($file) and preg_match('/\$plugin\s*=\s*([\'"])(.*?)\1;[^$]*(?:\$info\s*=\s*([\'"])(.*?)\3;)?/',$data,$match)) {
       $name = preg_replace("/.*?$cfg[fbtm]$/",'$1',$file);
       $data = (preg_match('/^.*?('.preg_quote($name,'/').')\s([\d.]+)\s+(.*)$/i',$match[2],$var))
	? array('name' => $var[1], 'version' => (float)$var[2], 'copyright' => $var[3]) : false;
       $update = (($var = preg_array('/'.preg_quote($name,'/').'/',$list[3],4)) !== false) ? array('version' => (float)$list[2][$var], 'hash' => $list[1][$var]) : false;
       $files[$key] = array('name' => $name, 'file' => basename($file), 'filename' => $file, 'plugin' => $match[2], 'info' => $match[4], 'data' => $data,
	'hash' => md5_file($file), 'update' => $update);
      }
     foreach($files as $key => $data) {				// Lokale Plugins mit Update-Liste vergleichen und Updates anzeigen
      if(ifset($data['data']['version']) and ifset($data['update']['version']) and $data['data']['version'] < $data['update']['version'])
       $update[$key] = 1;
      elseif(ifset($data['hash']) and ifset($data['update']['hash']) and $data['hash'] != $data['update']['hash'])
       $update[$key] = (ifset($cfg['opts']['f'])) ? 0 : 2;	// Mit -f die Warnung fr vernderung ignorieren
      if(ifset($update[$key])) {				// Vernderungen ausgeben
       if($update[$key])
        $filter[$key] = preg_quote($data['file'],'/');		// Preg-Filter mit dem Dateinamen
       $out[$data['name']] = ($update[$key] == 1) ? "Update: ".$data['data']['version']." -> ".$data['update']['version'] : "Plugin wurde verndert"; 	// Update auflisten
      }
     }
     foreach($install as $file) {				// Neue (nicht installierte) Plugins anzeigen
      $out[preg_replace("/^$cfg[fbtm]$/",'$1',$file['name'])] = "NEU: $file[version]";
      if(ifset($mode['i']))
       $filter[] = preg_quote($file['name'],'/');		// Preg-Filter mit dem Dateinamen
     }
     if($out) {							// Updates ausgeben
      $max = max(array_map('strlen',array_keys($out))) + 1;
      out("Es sind Updates/Plugins verfgbar:");
      foreach($out as $key => $var)
       out(str_pad($key,$max,' ').$var);
      if(!ifset($mode['c']) and ($filter or $install)) {	// Update/Install durchfhren
       out("\nInstalliere/Aktualisiere Plugins...");
       foreach(array(443,80) as $port)
        if($tgz = request('GET-array',$cfg['uplink'][1].$up[6],0,0,$cfg['uplink'][0],$port))	// Tar-Archiv holen
         break;
       if($tgz and $tgz = datatar2array(gzdecode($tgz[1]),'/('.implode('|',$filter).')$/')) {	// Tar-Archiv in Array entpacken
        if(ifset($mode['u'])) {					// mode: Update
         foreach($update as $key => $file) {
          if($file and file_exists($files[$key]['filename']) and ifset($tgz[$files[$key]['file']])) {
           if(hash('md5',$tgz[$files[$key]['file']]['data']) == $files[$key]['update']['hash'] or ifset($cfg['opts']['f'])) {
            if(!ifset($cfg['opts']['ow'])) {			// Option ow fr berschreiben abfragen
             dbug("Sichere: ".$files[$key]['file']);
             if(file_exists($rename = preg_replace('/(\.\w+)$/','_'.$files[$key]['data']['version'].'$1.bak',$files[$key]['filename'])))
              $rename = preg_replace('/(\.\w+)$/','_'.time().'$1',$rename);
             @rename($files[$key]['filename'],$rename);
            }
            else
             dbug("berschreibe: ".$files[$key]['file']);
            out("Update: ".$files[$key]['file']." ... ",2);
            out((file_contents($files[$key]['filename'],$tgz[$files[$key]['file']]['data'])) ? "erfolgreich" : "fehlgeschlagen");
           }
           else
            out("Fehler: ".$files[$key]['file']." ist defekt oder verndert worden!");
          }
         }
        }
        if(ifset($mode['i']) and $install) {			// Neue Plugins installieren
         foreach(array_reverse($cfg['fbta']) as $var)		// Plugin-Ordner suchen
          if(file_exists($var) and is_dir($var)) {
           $path = $var;
           break;
          }
         dbug("Benutze Plugin-Ordner: $path");
         foreach($install as $file)				// Plugins aus Tar-Archiv installieren
          if(hash('md5',$tgz[$file['name']]['data']) == $file['hash'] or ifset($cfg['opts']['f'])) {
           out("Installiere: $file[name] ... ",2);
           out((file_contents("$path/$file[name]",$tgz[$file['name']]['data'])) ? "erfolgreich" : "fehlgeschlagen");
          }
          else
           out("Fehler: $file[name] ist defekt oder verndert worden!");
        }
       }
       else
        out("Plugin-Archiv ist fehlerhaft!");
      }
     }
     else
      out("Keine neuen Updates verfgbar!");
    }
    if(ifset($fbnet['X-Cookie']))				// Coolen Spruch ausgeben
     out("\n".$fbnet['X-Cookie']);
   }
   else
    out("Update-Server sagt NEIN!");
  }
  elseif($var = ((ifset($val['pi']) and $var = getArg('plug')) ? $var : ((ifset($val['pit'])) ? $val['pit'] : false)) and (file_exists($var) and is_file($var)
	or $var = preg_array('/'.preg_quote($var,'/').'/i',listDir("/$cfg[fbtm]\s*$/i",$cfg['fbta'],1)))) {	// Plugin Exec(2)
   $plug = preg_replace("!^.*?$cfg[fbtm]$!",'$1',$var);
   include $var;
   if(ifset($cfg['error']))
    out(errmsg(0,'main'));
  }
  elseif(ifset($val['pi'])) {				// Plugin Liste(3)
   out("$self <fritz.box> <mode:PlugIn|pi> [plug:Plugin|Script-Datei] <...>
$self [mode:PlugIn|pi] [func|opt:Check|Install|List|UpDate]".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self fritz.box plugin fbtp_led.php off
$self test \"Hello World\"
$self plugin
$self plugin update list
$self plugin update check
$self plugin update -ow
$self plugin install update
$self plugin fbtp_test.php" : ""));
   if(!$cfg['help'])
    if($array = listDir("/$cfg[fbtm]\s*$/i",array_merge($cfg['fbta'],array(str_replace('\\','/',(file_exists($var) and is_dir($var)) ? preg_replace('![\\\\/]+$!','',$var) : "."))),5)) {
     $plugins = "";
     foreach($array as $file => $v)
      if($data = file_contents($file) and preg_match('/\$plugin\s*=\s*([\'"])(.*?(?:('.preg_quote((preg_match("/$cfg[fbtm]\s*$/i",$file,$var)) ? $var[1] : basename($file),'/')
	.')\s+([\d.]+)\s+)?.*?)\1;[^$]*(?:\$info\s*=\s*([\'"])(.*?)\5;)?/i',$data,$var) and $data = preg_replace('/\|/','\|',$var))
       $plugins .= "$data[3]|$data[4]|$data[6]\n";
     out(($plugins) ? "\nVorhandene Plugins: (WARNUNG: Es gibt KEINE Prfung auf Malware!)\n{{{tt}$plugins}}\n" : "Keine gltigen Plugins gefunden!",2);
    }
    else
     out("Keine Plugins gefunden!");
   else {
    $opts .= "Update:|-f||Force - Fehler Ignorieren\n|-ow||Dateien berschreiben";
    if($cfg['help'] === true)
     $cfg['help'] = -1;
   }
  }
  else
   out("Mglichweise ist ein unbekannter und unerwarterer, sowie mysteriser Layer-8 Problem aufgetreten ;-)\nEine Hilfe erhalten Sie mit $self -h");
 }
 elseif($cfg['dbug']%2) {				// DEBUG: $argv & $cfg ausgeben
  dbug('$argv');
  dbug('$cfg');
 }
 else {							// Hilfe ausgeben
  $_help = out("$self <http://user:pass@fritz.box:port> [mode] <Parameter> ... <Option>".((ifset($cfg['help'])) ? "\n
Modes (mode):\n{{{tt}
AnrufListe|-|Anrufliste abrufen/mit Datei Syncronisieren(2)
BoxInfo|-|Modell, Firmware-Version und MAC-Adresse ausgeben
Ereignisse|-|Systemmeldungen abrufen/mit Datei Syncronisieren(2)
GetIP|-|Aktuelle externe IPv4-Adresse ausgeben(1)
Info|-|FB-Tools/PHP Version, Checksum hasher, Update/Prfen(3)
Konfig|-|Einstellungen Ex/Importieren, Daten entschlsseln(2,3,4,5)
LED|-|LED an/ausschalten oder Status abfragen(2)
LogIn/LogOut|-|Manuelles Einloggen fr Scriptdateien(2)
PlugIn|-|Weitere Funktion per Plugin-Script einbinden
ReConnect|-|Neueinwahl ins Internet(1)
SmartHome|-|Aktoren schalten und auslesen(2)
SupportDaten|-|AVM-Supportdaten Speichern(2)
SystemStatus|-|Modell, Version, Laufzeiten, Neustarts und Status ausgeben(3)
WahlHilfe/Dial|-|Rufnummer whlen(2)".(($cfg['a1st']) ? $cfg['a1st'][0] : "")."}}
(1) Aktiviertes UPnP erforderlich (Nicht ber https nutzbar)
(2) Anmeldung mit Logindaten erforderlich / (3) Teilweise ohne Fritz!Box nutzbar
(4) OpenSSL, MCrypt oder Aes.php ntig / [ ] Pflicht / < > Optional
(5) Ab OS 6.69 muss die Sicherheits-Besttigungsfunktion deaktiviert werden".((ifset($cfg['help'],'/[ab]/i')) ? "\n
Beispiele:
$self mode:getip filter:ipv4
$self secret@fritz.box supportdaten
$self hans:geheim@fritz.box konfig export
$self http://secret@169.254.1.1 Ereignisse -w:80 -c:utf8 -o:file.txt
$self https://max:headroom@0123456789abcdef.myfritz.net:12345 AnrufListe /var/log/fb_call_%F.log -lf
$self wahlhilfe \"**51\" -fb:fritz.box -un:max -pw:geheim
$self fritz.box led off -pw:secret
$self -h:alles": "") : "\n\nWeitere Hilfe bekommen Sie mit der -h Option oder mehr Hilfe mit -h:all"));
 }
 if($cfg['help']) {					// Weitere Hilfe ausgeben
  if((ifset($cfg['help'],'/k/i') or $cfg['help'] == -1) and ifset($opts))
   out("\nKontext-Optionen:\n{{{tt}$opts}}");
  elseif(ifset($cfg['help'],'/[ao]/i'))			// Optionen ausgeben
   out("\nAlle Optionen: (Mssen immer als Letztes angegeben werden!)\n{{{tt,0,|,\n, ;; ;, }
|-d||Debuginfos
|-h:|<a\|b\|o\|k\|s>|Hilfe (Alles, Beispiele, Optionen, Standard)
Console:|-c:|[CodePage]|Kodierung der Umlaute ({$cfg['char'][0]})
|-w:|[Breite]|Wortumbruch ($cfg[wrap])
|-o:|[Datei]|Ansi-Ausgabe in Datei
Login:|-s:|[SID\|Datei]|Manuelle SID Angabe (Fr Scriptdateien)
|-fb:|[Host]|Fritz!Box Angabe ($cfg[host])
|-fw:|[Version]|Manuelle Angabe der Firmware-Version ($cfg[fiwa])
|-pt:|[Port]|Port Angabe ($cfg[port])
|-pw:|[Pass]|Kennwort Angabe
|-ui:|[Pass]|Anmeldekennwort (Bei Fernwartung)
|-un:|[User]|Benutzername Angabe
Request:|-b:|[Bytes]|Buffergre ($cfg[sbuf])
|-p:|[Protokoll]|Protokoll ($cfg[sock])
|-t:|[Sekunden]|TCP/IP Timeout ($cfg[tout])
|-ua:|[String]|User-Agent (".preg_replace('/\s.*$/',' ...',$cfg['head']['User-Agent']).")
Dateien:|-gz:|[Level]|Packstufe festlegen ({$cfg['zlib']['mode']})
PHP:|-pe:|<Extension>|Ldt ohne rckfrage eine PHP-Erweiterung nach".((ifset($opts) ? "\n$opts" : ""))."}}");
  elseif($cfg['help'] === true and !ifset($cfg['arg']) or $cfg['help'] === -1)
   out("\nMehr Hilfe bekommen Sie mit -h:a (Alles) -h:b (Beispiele) -h:k (Kontext) -h:o (Optionen)");
  if(ifset($_help))
   out("\nEine Anleitung finden Sie auf ".preg_replace('/(?<=\/)www\./','',$cfg['ver'][7]).$cfg['ver'][8]);
 }
 if($cfg['dbug'] and ifset($cfg['error']))		// Fehler bei -d ausgeben
  dbug("Fehler:\n".print_r($cfg['error'],true));
}
?>
